/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !const_double_operand (operands[1], E_DFmode)
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !s_register_operand (operands[2], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != PLUS
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x17, 1);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x19 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x19) != SET)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PLUS
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XEXP (x20, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x22) != SET)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PLUS
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XEXP (x23, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern51 (x3, 
E_V8BImode, 
i1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
i2, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_32 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern106 (x3); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != XOR
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern117 (x3, 
i1, 
i2); /* [-1, 1] */
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 6;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern40 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        case E_V16QImode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_mve_cde1_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i3)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern148 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern148 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern148 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (XINT (x2, 1))
    {
    case 33:
      return pattern250 (x1); /* [-1, 1] */

    case 34:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case 37:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case 356:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 8;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern277 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !reg_or_zero_operand (operands[2], E_V4HImode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !reg_or_zero_operand (operands[2], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !reg_or_zero_operand (operands[2], E_V8HImode))
            return -1;
          return 4;

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !reg_or_zero_operand (operands[2], E_V8HFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !reg_or_zero_operand (operands[2], E_V2SImode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !reg_or_zero_operand (operands[2], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !reg_or_zero_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !reg_or_zero_operand (operands[2], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern337 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 101
      || GET_MODE (x6) != E_SImode
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern345 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32L:
      return 0;

    case 16L:
      if (pattern344 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!s_register_operand (x3, i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (!s_register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      return 0;

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[4] = x6;
      if (!shift_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_inv_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern402 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i3)
      || !vpr_register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern438 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern454 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern463 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern462 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern462 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != COND_EXEC)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != COND_EXEC)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != EQ)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x8, 1);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[3], i2)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XVECEXP (x9, 0, 2);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern530 (x1); /* [-1, 3] */
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i1
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case MINUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 4;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], i1)
      || !vpr_register_operand (operands[4], i2)
      || !s_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode)
      || pattern614 (x1) != 0)
    return -1;
  return 0;
}

int
pattern623 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern630 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SImode)
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V4SImode)
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_V4SImode)
    return -1;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != E_V4SImode)
    return -1;
  x10 = XEXP (x7, 1);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != E_V4SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return 0;

    case ZERO_EXTEND:
      return 1;

    default:
      return -1;
    }
}

int
pattern641 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  res = recog_4 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[1] = x5;
  operands[3] = x4;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      switch (GET_CODE (x8))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!rtx_equal_p (x8, operands[3]))
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 4771 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 152; /* *shiftsi3_compare0 */

        default:
          return -1;
        }

    case CLOBBER:
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 4785 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 153; /* *shiftsi3_compare0_scratch */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[5] = x5;
      if (!minmax_operator (operands[5], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[4] = x4;
      if (!shiftable_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 4256 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && !arm_restrict_it))
        return -1;
      return 125; /* *minmax_arithsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x5;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[5] = x4;
      if (!shiftable_operator (operands[5], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 10110 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return 338; /* *cond_arith */
      if (!
#line 756 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
        return -1;
      return 1036; /* *thumb2_cond_arith */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x5;
      if (memory_operand (operands[2], E_SImode))
        {
          operands[1] = x4;
          if (shiftable_operator (operands[1], E_SImode))
            {
              x9 = XEXP (x4, 1);
              operands[3] = x9;
              if (memory_operand (operands[3], E_SImode))
                {
                  x6 = XEXP (x2, 0);
                  operands[4] = x6;
                  if (scratch_operand (operands[4], E_SImode)
                      && 
#line 11472 "../../gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3])))
                    return 380; /* *arith_adjacentmem */
                }
            }
        }
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[3] = x4;
      if (!thumb_16bit_operator (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1256 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS))
        return -1;
      return 1052; /* *thumb2_alusi3_short */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (pattern16 (x3, 
PLUS, 
MEM, 
E_SImode) != 0
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x9, 0);
  if (!rtx_equal_p (x11, operands[1])
      || !
#line 12723 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[2]) + 4) == INTVAL (operands[4]))
     && (operands_ok_ldrd_strd (operands[0], operands[3],
                                  operands[1], INTVAL (operands[2]),
                                  false, true))))
    return -1;
  return 423; /* *thumb2_ldrd */
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 1);
  if (!s_register_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[1] = x9;
      if (ldrd_strd_offset_operand (operands[1], E_SImode))
        {
          res = recog_24 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x9, 0) != -4L)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x6;
      operands[2] = x7;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[0])
          || !
#line 12793 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], -4, false, false))))
        return -1;
      return 428; /* *thumb2_strd_base_neg */

    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x5, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      operands[1] = x6;
      operands[2] = x7;
      x13 = XEXP (x11, 0);
      if (!rtx_equal_p (x13, operands[0])
          || !
#line 12780 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], 0, false, false))))
        return -1;
      return 427; /* *thumb2_strd_base */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      switch (pattern294 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 10494 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_OR_Y)
       != CCmode)))
            return 344; /* *ior_scc_scc */
          break;

        case 1:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3143; /* atomic_or_fetchqi */
            }
          break;

        case 2:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3148; /* atomic_or_fetchhi */
            }
          break;

        case 3:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3153; /* atomic_or_fetchsi */
            }
          break;

        case 4:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3158; /* atomic_or_fetchdi */
            }
          break;

        default:
          break;
        }
      break;

    case AND:
      switch (pattern294 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 10556 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
            return 346; /* *and_scc_scc */
          if (
#line 10624 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       == CCmode)))
            return 348; /* *and_scc_scc_nodom */
          break;

        case 1:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3145; /* atomic_and_fetchqi */
            }
          break;

        case 2:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3150; /* atomic_and_fetchhi */
            }
          break;

        case 3:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3155; /* atomic_and_fetchsi */
            }
          break;

        case 4:
          if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3160; /* atomic_and_fetchdi */
            }
          break;

        default:
          break;
        }
      break;

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern295 (x5, pnum_clobbers) == 0)
        {
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          switch (pattern291 (x1))
            {
            case 0:
              if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3144; /* atomic_xor_fetchqi */
                }
              break;

            case 1:
              if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3149; /* atomic_xor_fetchhi */
                }
              break;

            case 2:
              if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3154; /* atomic_xor_fetchsi */
                }
              break;

            case 3:
              if (
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3159; /* atomic_xor_fetchdi */
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (s_register_operand (operands[0], E_SImode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x7 = XEXP (x5, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
    case AND:
      operands[5] = x4;
      if (shiftable_operator_strict_it (operands[5], E_SImode))
        {
          x6 = XEXP (x4, 0);
          if (arm_comparison_operator (x6, E_SImode))
            {
              operands[4] = x6;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x8 = XEXP (x6, 0);
                  operands[2] = x8;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x9 = XEXP (x6, 1);
                      operands[3] = x9;
                      if (arm_rhs_operand (operands[3], E_SImode))
                        {
                          x10 = XEXP (x4, 1);
                          operands[1] = x10;
                          if (s_register_operand (operands[1], E_SImode)
                              && 
#line 798 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
                            return 1037; /* *thumb2_cond_arith_strict_it */
                        }
                    }
                }
            }
        }
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode
          || !low_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!low_reg_or_int_operand (operands[2], E_SImode)
          || !
#line 1301 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      return 1057; /* *thumb2_addsi_short */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !low_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!low_register_operand (operands[2], E_SImode)
          || !
#line 1330 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      return 1058; /* *thumb2_subsi_short */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || pattern24 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER
      || pattern641 (x1) != 0)
    return -1;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[5] = x8;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[6] = x9;
  if (!scratch_operand (operands[6], E_SImode)
      || pattern653 (x1) != 0
      || !
#line 1044 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 972; /* cpymem12b */
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 0
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          operands[2] = x1;
          if (!multi_register_push (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          if (s_register_operand (operands[1], E_SImode)
              && push_mult_memory_operand (operands[0], E_BLKmode))
            return 384; /* *push_multi */
          if (!vfp_register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[0], E_BLKmode)
              || !
#line 2026 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE))
            return -1;
          return 890; /* *push_multi_vfp */

        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          operands[0] = x1;
          if (!clear_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1711 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed))
            return -1;
          return 1071; /* *clear_multiple */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 55)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x1;
      if (!clear_vfp_multiple_operation (operands[0], E_VOIDmode)
          || !
#line 1688 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed))
        return -1;
      return 858; /* *clear_vfp_multiple */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x2, 0);
  operands[5] = x9;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[5]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 16L:
      switch (pattern496 (x5))
        {
        case 0:
          if (pattern578 (x1) != 0)
            return -1;
          x11 = XEXP (x8, 1);
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x12, 1);
          if (GET_CODE (x13) != CONST_INT
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x16 = XEXP (x7, 0);
          operands[3] = x16;
          x17 = XEXP (x8, 0);
          operands[4] = x17;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          x20 = XEXP (x19, 0);
          if (!rtx_equal_p (x20, operands[5]))
            return -1;
          x21 = XEXP (x7, 1);
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          x24 = XEXP (x12, 0);
          if (!rtx_equal_p (x24, operands[5]))
            return -1;
          switch (pattern633 (x1))
            {
            case 0:
              x25 = XEXP (x5, 1);
              x26 = XEXP (x25, 0);
              if (!rtx_equal_p (x26, operands[5]))
                return -1;
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != 4L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != 8L
                  || XWINT (x13, 0) != 12L)
                return -1;
              if (arm_hard_general_register_operand (operands[1], E_SImode)
                  && arm_hard_general_register_operand (operands[2], E_SImode)
                  && arm_hard_general_register_operand (operands[3], E_SImode)
                  && arm_hard_general_register_operand (operands[4], E_SImode)
                  && 
#line 74 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return 439; /* *ldm4_ia_update */
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[2], E_SImode)
                  || !low_register_operand (operands[3], E_SImode)
                  || !low_register_operand (operands[4], E_SImode)
                  || !
#line 94 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 440; /* *thumb_ldm4_ia_update */

            case 1:
              if (XWINT (x13, 0) != 16L
                  || !arm_hard_general_register_operand (operands[1], E_SImode)
                  || !arm_hard_general_register_operand (operands[2], E_SImode)
                  || !arm_hard_general_register_operand (operands[3], E_SImode)
                  || !arm_hard_general_register_operand (operands[4], E_SImode))
                return -1;
              x25 = XEXP (x5, 1);
              x26 = XEXP (x25, 0);
              x29 = XEXP (x26, 0);
              if (!rtx_equal_p (x29, operands[5])
                  || !
#line 181 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 445; /* *ldm4_ib_update */

            default:
              return -1;
            }

        case 1:
          if (pattern590 (x1) != 0)
            return -1;
          x17 = XEXP (x8, 0);
          x30 = XEXP (x17, 0);
          if (GET_CODE (x30) != PLUS
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != CONST_INT
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x6, 1);
          operands[2] = x18;
          x21 = XEXP (x7, 1);
          operands[3] = x21;
          x11 = XEXP (x8, 1);
          operands[4] = x11;
          x15 = XEXP (x6, 0);
          x32 = XEXP (x15, 0);
          x33 = XEXP (x32, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x16 = XEXP (x7, 0);
          x34 = XEXP (x16, 0);
          x35 = XEXP (x34, 0);
          if (!rtx_equal_p (x35, operands[5]))
            return -1;
          x36 = XEXP (x30, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          switch (pattern635 (x1))
            {
            case 0:
              x14 = XEXP (x5, 0);
              x37 = XEXP (x14, 0);
              if (!rtx_equal_p (x37, operands[5]))
                return -1;
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != 4L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != 8L
                  || XWINT (x31, 0) != 12L)
                return -1;
              if (arm_hard_general_register_operand (operands[1], E_SImode)
                  && arm_hard_general_register_operand (operands[2], E_SImode)
                  && arm_hard_general_register_operand (operands[3], E_SImode)
                  && arm_hard_general_register_operand (operands[4], E_SImode)
                  && 
#line 125 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return 442; /* *stm4_ia_update */
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[2], E_SImode)
                  || !low_register_operand (operands[3], E_SImode)
                  || !low_register_operand (operands[4], E_SImode)
                  || !
#line 142 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 443; /* *thumb_stm4_ia_update */

            case 1:
              if (XWINT (x31, 0) != 16L
                  || !arm_hard_general_register_operand (operands[1], E_SImode)
                  || !arm_hard_general_register_operand (operands[2], E_SImode)
                  || !arm_hard_general_register_operand (operands[3], E_SImode)
                  || !arm_hard_general_register_operand (operands[4], E_SImode))
                return -1;
              x14 = XEXP (x5, 0);
              x37 = XEXP (x14, 0);
              x40 = XEXP (x37, 0);
              if (!rtx_equal_p (x40, operands[5])
                  || !
#line 213 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 447; /* *stm4_ib_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case -16L:
      x25 = XEXP (x5, 1);
      switch (GET_CODE (x25))
        {
        case MEM:
          if (pattern367 (x25) != 0
              || pattern578 (x1) != 0
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[3] = x16;
          if (!arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x17 = XEXP (x8, 0);
          operands[4] = x17;
          if (!arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x26 = XEXP (x25, 0);
          x29 = XEXP (x26, 0);
          if (!rtx_equal_p (x29, operands[5]))
            return -1;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          x20 = XEXP (x19, 0);
          if (!rtx_equal_p (x20, operands[5]))
            return -1;
          x21 = XEXP (x7, 1);
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          x41 = XEXP (x26, 1);
          switch (XWINT (x41, 0))
            {
            case -12L:
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != -8L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != -4L)
                return -1;
              x11 = XEXP (x8, 1);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[5])
                  || !
#line 251 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 449; /* *ldm4_da_update */

            case -16L:
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != -12L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != -8L)
                return -1;
              x11 = XEXP (x8, 1);
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != PLUS
                  || GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x12, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x24 = XEXP (x12, 0);
              if (!rtx_equal_p (x24, operands[5])
                  || !
#line 323 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 453; /* *ldm4_db_update */

            default:
              return -1;
            }

        case REG:
          operands[1] = x25;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x5, 0);
          if (pattern423 (x14) != 0
              || pattern590 (x1) != 0
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x6, 1);
          operands[2] = x18;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x21 = XEXP (x7, 1);
          operands[3] = x21;
          if (!arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[4] = x11;
          if (!arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x37 = XEXP (x14, 0);
          x40 = XEXP (x37, 0);
          if (!rtx_equal_p (x40, operands[5]))
            return -1;
          x15 = XEXP (x6, 0);
          x32 = XEXP (x15, 0);
          x33 = XEXP (x32, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x16 = XEXP (x7, 0);
          x34 = XEXP (x16, 0);
          x35 = XEXP (x34, 0);
          if (!rtx_equal_p (x35, operands[5]))
            return -1;
          x42 = XEXP (x37, 1);
          switch (XWINT (x42, 0))
            {
            case -12L:
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != -8L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != -4L)
                return -1;
              x17 = XEXP (x8, 0);
              x30 = XEXP (x17, 0);
              if (!rtx_equal_p (x30, operands[5])
                  || !
#line 283 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 451; /* *stm4_da_update */

            case -16L:
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != -12L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != -8L)
                return -1;
              x17 = XEXP (x8, 0);
              x30 = XEXP (x17, 0);
              if (GET_CODE (x30) != PLUS
                  || GET_MODE (x30) != E_SImode)
                return -1;
              x31 = XEXP (x30, 1);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x36 = XEXP (x30, 0);
              if (!rtx_equal_p (x36, operands[5])
                  || !
#line 355 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 455; /* *stm4_db_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2230; /* neon_vextv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2231; /* neon_vextv16qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2232; /* neon_vextv4hi */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2233; /* neon_vextv8hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2234; /* neon_vextv2si */

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2235; /* neon_vextv4si */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2236; /* neon_vextv4hf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2237; /* neon_vextv8hf */

    case E_V4BFmode:
      if (pattern41 (x3, 
E_V4BFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2238; /* neon_vextv4bf */

    case E_V8BFmode:
      if (pattern41 (x3, 
E_V8BFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2239; /* neon_vextv8bf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2240; /* neon_vextv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2241; /* neon_vextv4sf */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2242; /* neon_vextdi */

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0
          || !
#line 4423 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2243; /* neon_vextv2di */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern45 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern500 (x2, 
E_OImode, 
E_SImode) != 0
          || !
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2953; /* neon_vst4_lanev8qi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2954; /* neon_vst4_lanev4hi */

        case 1:
          if (!
#line 6266 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2959; /* neon_vst4_lanev8hi */

        default:
          return -1;
        }

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HFmode, 
E_V8HFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2955; /* neon_vst4_lanev4hf */

        case 1:
          if (!
#line 6266 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2960; /* neon_vst4_lanev8hf */

        default:
          return -1;
        }

    case E_V4BFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4BFmode, 
E_V8BFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2956; /* neon_vst4_lanev4bf */

        case 1:
          if (!(
#line 6266 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2963; /* neon_vst4_lanev8bf */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2957; /* neon_vst4_lanev2si */

        case 1:
          if (!
#line 6266 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2961; /* neon_vst4_lanev4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2958; /* neon_vst4_lanev2sf */

        case 1:
          if (!
#line 6266 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2962; /* neon_vst4_lanev4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern427 (x3, 
E_SImode) != 0
          || !
#line 2203 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 931; /* arm_vcx1asi */

    case E_DImode:
      if (pattern427 (x3, 
E_DImode) != 0
          || !
#line 2203 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 932; /* arm_vcx1adi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !const_int_mve_cde1_operand (operands[3], E_SImode)
          || !
#line 4448 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5046; /* arm_vcx1qav16qi */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1574; /* neon_vmlsv8qi_unspec */

    case 1:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1575; /* neon_vmlsv16qi_unspec */

    case 2:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1576; /* neon_vmlsv4hi_unspec */

    case 3:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1577; /* neon_vmlsv8hi_unspec */

    case 4:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1578; /* neon_vmlsv2si_unspec */

    case 5:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1579; /* neon_vmlsv4si_unspec */

    case 6:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1580; /* neon_vmlsv2sf_unspec */

    case 7:
      if (!
#line 2155 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1581; /* neon_vmlsv4sf_unspec */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_ccde2_operand (operands[3], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4550 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 143; /* arm_cx2si */

    case 1:
      if (!
#line 4550 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 144; /* arm_cx2di */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2244; /* neon_vrev64v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2245; /* neon_vrev64v16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2246; /* neon_vrev64v4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2247; /* neon_vrev64v8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2248; /* neon_vrev64v2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2249; /* neon_vrev64v4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2250; /* neon_vrev64v4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2251; /* neon_vrev64v8hf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2252; /* neon_vrev64v2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2253; /* neon_vrev64v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 4435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2254; /* neon_vrev64v2di */

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4846; /* mve_vldrq_extend_v8qis */

        case 1:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4848; /* mve_vldrq_extend_v4qis */

        case 2:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4850; /* mve_vldrq_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4847; /* mve_vldrq_extend_v8qiu */

        case 1:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4849; /* mve_vldrq_extend_v4qiu */

        case 2:
          if (!
#line 3275 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4851; /* mve_vldrq_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1869; /* neon_vpaddlsv8qi */

    case 1:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1871; /* neon_vpaddlsv16qi */

    case 2:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1873; /* neon_vpaddlsv4hi */

    case 3:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1875; /* neon_vpaddlsv8hi */

    case 4:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1877; /* neon_vpaddlsv2si */

    case 5:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1879; /* neon_vpaddlsv4si */

    default:
      return -1;
    }
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_OImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!neon_struct_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V8QImode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2926; /* neon_vld4_dupv8qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[1], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2927; /* neon_vld4_dupv4hi */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HFmode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2928; /* neon_vld4_dupv4hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[1], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4BFmode
          || !(
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2929; /* neon_vld4_dupv4bf */

    case E_V4SImode:
      if (!neon_struct_operand (operands[1], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2930; /* neon_vld4_dupv2si */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SFmode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2931; /* neon_vld4_dupv2sf */

    case E_OImode:
      if (!neon_struct_operand (operands[1], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 6105 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2932; /* neon_vld4_dupdi */

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !vpr_register_operand (operands[2], E_V16BImode)
          || !
#line 1256 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3774; /* mve_vctp8q_mv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !vpr_register_operand (operands[2], E_V8BImode)
          || !
#line 1256 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3775; /* mve_vctp16q_mv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !vpr_register_operand (operands[2], E_V4BImode)
          || !
#line 1256 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3776; /* mve_vctp32q_mv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !vpr_register_operand (operands[2], E_V2QImode)
          || !
#line 1256 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3777; /* mve_vctp64q_mv2qi */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_EImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_BLKmode:
      if (!neon_struct_operand (operands[1], E_BLKmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2858; /* neon_vld3_dupv8qi */

        case E_V4HImode:
          if (!
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2859; /* neon_vld3_dupv4hi */

        case E_V4HFmode:
          if (!
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2860; /* neon_vld3_dupv4hf */

        case E_V4BFmode:
          if (!(
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2861; /* neon_vld3_dupv4bf */

        case E_V2SImode:
          if (!
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2862; /* neon_vld3_dupv2si */

        case E_V2SFmode:
          if (!
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2863; /* neon_vld3_dupv2sf */

        default:
          return -1;
        }

    case E_EImode:
      if (!neon_struct_operand (operands[1], E_EImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 5773 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2864; /* neon_vld3_dupdi */

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1351 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1435; /* neon_vpadd_internalv8qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 1351 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1436; /* neon_vpadd_internalv4hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 1351 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1437; /* neon_vpadd_internalv2si */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1351 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1438; /* neon_vpadd_internalv2sf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 1366 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1439; /* neon_vpaddv4hf */

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2342; /* neon_vrshru_nv8qi */

    case 1:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2346; /* neon_vrshru_nv16qi */

    case 2:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2350; /* neon_vrshru_nv4hi */

    case 3:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2354; /* neon_vrshru_nv8hi */

    case 4:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2358; /* neon_vrshru_nv2si */

    case 5:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2362; /* neon_vrshru_nv4si */

    case 6:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2366; /* neon_vrshru_ndi */

    case 7:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2370; /* neon_vrshru_nv2di */

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2276; /* neon_vshluv8qi */

    case 1:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2280; /* neon_vshluv16qi */

    case 2:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2284; /* neon_vshluv4hi */

    case 3:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2288; /* neon_vshluv8hi */

    case 4:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2292; /* neon_vshluv2si */

    case 5:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2296; /* neon_vshluv4si */

    case 6:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2300; /* neon_vshludi */

    case 7:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2304; /* neon_vshluv2di */

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1508; /* neon_vqaddsv8qi */

    case 1:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1510; /* neon_vqaddsv16qi */

    case 2:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1512; /* neon_vqaddsv4hi */

    case 3:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1514; /* neon_vqaddsv8hi */

    case 4:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1516; /* neon_vqaddsv2si */

    case 5:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1518; /* neon_vqaddsv4si */

    case 6:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1520; /* neon_vqaddsdi */

    case 7:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1522; /* neon_vqaddsv2di */

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1383; /* ashlv8qi3_signed */

    case 1:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1384; /* ashlv16qi3_signed */

    case 2:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1385; /* ashlv4hi3_signed */

    case 3:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1386; /* ashlv8hi3_signed */

    case 4:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1387; /* ashlv2si3_signed */

    case 5:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1388; /* ashlv4si3_signed */

    case 6:
      if (!
#line 939 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1389; /* ashlv2di3_signed */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1881; /* neon_vpadalsv8qi */

    case 1:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1883; /* neon_vpadalsv16qi */

    case 2:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1885; /* neon_vpadalsv4hi */

    case 3:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1887; /* neon_vpadalsv8hi */

    case 4:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1889; /* neon_vpadalsv2si */

    case 5:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1891; /* neon_vpadalsv4si */

    default:
      return -1;
    }
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1486; /* neon_vhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1490; /* neon_vhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1494; /* neon_vhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1498; /* neon_vhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1502; /* neon_vhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1506; /* neon_vhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1759; /* neon_vcalev2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1763; /* neon_vcalev4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1775; /* neon_vcalev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1779; /* neon_vcalev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1389 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1444; /* neon_vpsmaxv8qi */

    case 1:
      if (!
#line 1389 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1445; /* neon_vpsmaxv4hi */

    case 2:
      if (!
#line 1389 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1446; /* neon_vpsmaxv2si */

    case 3:
      if (!
#line 1389 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1447; /* neon_vpsmaxv2sf */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4891; /* mve_vldrq_gather_offset_z_v16qi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4892; /* mve_vldrq_gather_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4893; /* mve_vldrq_gather_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4894; /* mve_vldrq_gather_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4895; /* mve_vldrq_gather_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3480 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4896; /* mve_vldrq_gather_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde2_operand (operands[4], E_SImode))
    return -1;
  switch (pattern426 (x3))
    {
    case 0:
      if (!
#line 4562 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 145; /* arm_cx2asi */

    case 1:
      if (!
#line 4562 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 146; /* arm_cx2adi */

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != NEG
          || GET_MODE (x7) != E_SImode)
        return -1;
      operands[0] = x5;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (!
#line 1308 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 977; /* *negated_cbranchsi4 */

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x5;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (XWINT (x11, 0) == 1L)
        {
          x13 = XEXP (x6, 2);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 1347 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 978; /* *tbit_cbranch */
            }
        }
      x13 = XEXP (x6, 2);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 1392 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      *pnum_clobbers = 1;
      return 979; /* *tlobits_cbranch */

    case AND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[3] = x5;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x6, 1);
      operands[1] = x11;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!
#line 1435 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 980; /* *tstsi3_cbranch */

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!cc_register (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LABEL_REF:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x4;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!
#line 7974 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 277; /* arm_cond_branch */

    case PC:
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !arm_comparison_operator (x3, E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          operands[1] = x3;
          operands[2] = x4;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!
#line 8027 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 278; /* *arm_cond_branch_reversed */

        case RETURN:
          operands[0] = x3;
          operands[1] = x4;
          if (!
#line 9065 "../../gcc/config/arm/arm.md"
(TARGET_ARM  && USE_RETURN_INSN (TRUE)))
            return -1;
          return 301; /* *cond_return_inverted */

        case SIMPLE_RETURN:
          operands[0] = x3;
          operands[1] = x4;
          if (!
#line 9065 "../../gcc/config/arm/arm.md"
(TARGET_ARM  && use_simple_return_p ()))
            return -1;
          return 302; /* *cond_simple_return_inverted */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (x5, E_SFmode))
            return -1;
          operands[3] = x5;
          operands[1] = x3;
          if (arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            {
              operands[2] = x4;
              x6 = XEXP (x2, 2);
              operands[4] = x6;
              if (s_register_operand (operands[4], E_SFmode)
                  && 
#line 8443 "../../gcc/config/arm/arm.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 283; /* *cmovsf */
            }
          operands[1] = x5;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SFmode))
            return -1;
          if (
#line 8570 "../../gcc/config/arm/arm.md"
(TARGET_ARM && TARGET_SOFT_FLOAT))
            return 287; /* *movsfcc_soft_insn */
          if (
#line 780 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT))
            return 778; /* *movsfcc_vfp */
          if (
#line 803 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE && !arm_restrict_it))
            return 779; /* *thumb2_movsfcc_vfp */
          if (!
#line 520 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE))
            return -1;
          return 1024; /* *thumb2_movsfcc_soft_insn */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !s_register_operand (x5, E_DFmode))
            return -1;
          operands[3] = x5;
          operands[1] = x3;
          if (arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            {
              operands[2] = x4;
              x6 = XEXP (x2, 2);
              operands[4] = x6;
              if (s_register_operand (operands[4], E_DFmode)
                  && (
#line 8443 "../../gcc/config/arm/arm.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 284; /* *cmovdf */
            }
          operands[1] = x5;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_DFmode))
            return -1;
          if (
#line 826 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return 780; /* *movdfcc_vfp */
          if (!
#line 849 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE && TARGET_VFP_DOUBLE
   && !arm_restrict_it))
            return -1;
          return 781; /* *thumb2_movdfcc_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          operands[1] = x3;
          if (!arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x4;
          operands[3] = x5;
          if (!s_register_operand (operands[3], E_HFmode))
            return -1;
          x6 = XEXP (x2, 2);
          operands[4] = x6;
          if (!s_register_operand (operands[4], E_HFmode)
              || !
#line 8474 "../../gcc/config/arm/arm.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 285; /* *cmovhf */

        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!arm_not_operand (operands[2], E_SImode)
              || !
#line 8506 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 286; /* *movsicc_insn */

        default:
          return -1;
        }

    case RETURN:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[0] = x3;
      if (!arm_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      operands[1] = x4;
      if (!
#line 9043 "../../gcc/config/arm/arm.md"
(TARGET_ARM   && USE_RETURN_INSN (TRUE)))
        return -1;
      return 299; /* *cond_return */

    case SIMPLE_RETURN:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[0] = x3;
      if (!arm_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      operands[1] = x4;
      if (!
#line 9043 "../../gcc/config/arm/arm.md"
(TARGET_ARM   && use_simple_return_p ()))
        return -1;
      return 300; /* *cond_simple_return */

    default:
      return -1;
    }
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !
#line 2279 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 57; /* *mla */

            case E_HFmode:
              if (pattern395 (x2, 
E_HFmode) != 0
                  || !
#line 1200 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 813; /* *mulsf3addhf_vfp */

            case E_SFmode:
              if (pattern395 (x2, 
E_SFmode) != 0
                  || !
#line 1211 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 814; /* *mulsf3addsf_vfp */

            case E_DFmode:
              if (pattern395 (x2, 
E_DFmode) != 0
                  || !
#line 1222 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 815; /* *muldf3adddf_vfp */

            case E_V8QImode:
              if (pattern395 (x2, 
E_V8QImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
                return -1;
              return 1189; /* mulv8qi3addv8qi_neon */

            case E_V16QImode:
              if (pattern395 (x2, 
E_V16QImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
                return -1;
              return 1190; /* mulv16qi3addv16qi_neon */

            case E_V4HImode:
              if (pattern395 (x2, 
E_V4HImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
                return -1;
              return 1191; /* mulv4hi3addv4hi_neon */

            case E_V8HImode:
              if (pattern395 (x2, 
E_V8HImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
                return -1;
              return 1192; /* mulv8hi3addv8hi_neon */

            case E_V2SImode:
              if (pattern395 (x2, 
E_V2SImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
                return -1;
              return 1193; /* mulv2si3addv2si_neon */

            case E_V4SImode:
              if (pattern395 (x2, 
E_V4SImode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
                return -1;
              return 1194; /* mulv4si3addv4si_neon */

            case E_V2SFmode:
              if (pattern395 (x2, 
E_V2SFmode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
                return -1;
              return 1195; /* mulv2sf3addv2sf_neon */

            case E_V4SFmode:
              if (pattern395 (x2, 
E_V4SFmode) != 0
                  || !
#line 588 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
                return -1;
              return 1196; /* mulv4sf3addv4sf_neon */

            case E_V8HFmode:
              if (pattern395 (x2, 
E_V8HFmode) != 0
                  || !
#line 601 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
                return -1;
              return 1197; /* mulv8hf3addv8hf_neon */

            case E_V4HFmode:
              if (pattern395 (x2, 
E_V4HFmode) != 0
                  || !
#line 601 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
                return -1;
              return 1198; /* mulv4hf3addv4hf_neon */

            default:
              return -1;
            }

        case CONST_INT:
          operands[3] = x6;
          if (!power_of_two_operand (operands[3], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_SImode)
              || !s_register_operand (operands[1], E_SImode)
              || !
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 319; /* *add_multsi */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_HImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern535 (x2, 
E_SImode) != 0
                  || !
#line 2603 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
                return -1;
              return 77; /* *arm_maddhisi4 */

            case E_DImode:
              if (pattern535 (x2, 
E_DImode) != 0
                  || !
#line 2747 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 83; /* maddhidi4 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          if (!s_register_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[3], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!s_register_operand (operands[2], E_HImode)
                  || !
#line 2763 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 84; /* *maddhidi4tb */

            case ASHIFTRT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x11 = XEXP (x8, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x12 = XEXP (x8, 0);
              operands[2] = x12;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2780 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 85; /* *maddhidi4tt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x13 = XEXP (x4, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_HImode)
              || !
#line 2650 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
            return -1;
          return 79; /* maddhisi4tb */

        case ASHIFTRT:
          x14 = XEXP (x6, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2699 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
            return -1;
          return 81; /* maddhisi4tt */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern303 (x3, 
3, 
1) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      x14 = XEXP (x6, 1);
      x15 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 1);
      if (pattern580 (x5, 
E_V2SImode, 
VEC_SELECT, 
MULT) != 0)
        return -1;
      x17 = XEXP (x5, 0);
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != PARALLEL
          || XVECLEN (x18, 0) != 2)
        return -1;
      x19 = XVECEXP (x18, 0, 0);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x18, 0, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XEXP (x5, 1);
      if (GET_CODE (x21) != VEC_SELECT
          || GET_MODE (x21) != E_V2SImode)
        return -1;
      x22 = XEXP (x21, 1);
      if (GET_CODE (x22) != PARALLEL
          || XVECLEN (x22, 0) != 2)
        return -1;
      x23 = XVECEXP (x22, 0, 0);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x22, 0, 1);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      switch (pattern630 (x2))
        {
        case 0:
          switch (pattern643 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1454 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 663; /* iwmmxt_wmadds */

            case 1:
              if (!
#line 194 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 699; /* iwmmxt_wmaddsx */

            default:
              return -1;
            }

        case 1:
          switch (pattern643 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1473 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 664; /* iwmmxt_wmaddu */

            case 1:
              if (!
#line 213 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 700; /* iwmmxt_wmaddux */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern371 (x2) != 0
                  || !
#line 3023 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 90; /* *arm_andsi3_insn */

            case E_DImode:
              if (pattern347 (x2, 
E_DImode) != 0
                  || !
#line 83 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 535; /* iwmmxt_anddi3 */

            case E_V2SImode:
              if (GET_MODE (x2) != E_V2SImode)
                return -1;
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 543; /* *andv2si3_iwmmxt */
              if (!s_register_operand (operands[0], E_V2SImode)
                  || !s_register_operand (operands[1], E_V2SImode)
                  || !neon_inv_logic_op2 (operands[2], E_V2SImode)
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1258; /* andv2si3_neon */

            case E_V4HImode:
              if (GET_MODE (x2) != E_V4HImode)
                return -1;
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 544; /* *andv4hi3_iwmmxt */
              if (!s_register_operand (operands[0], E_V4HImode)
                  || !s_register_operand (operands[1], E_V4HImode)
                  || !neon_inv_logic_op2 (operands[2], E_V4HImode)
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1256; /* andv4hi3_neon */

            case E_V8QImode:
              if (GET_MODE (x2) != E_V8QImode)
                return -1;
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 545; /* *andv8qi3_iwmmxt */
              if (!s_register_operand (operands[0], E_V8QImode)
                  || !s_register_operand (operands[1], E_V8QImode)
                  || !neon_inv_logic_op2 (operands[2], E_V8QImode)
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1254; /* andv8qi3_neon */

            case E_V16QImode:
              if (pattern396 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1255; /* andv16qi3_neon */
              if (!
#line 759 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3550; /* mve_vandq_uv16qi */

            case E_V8HImode:
              if (pattern396 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1257; /* andv8hi3_neon */
              if (!
#line 759 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3551; /* mve_vandq_uv8hi */

            case E_V4SImode:
              if (pattern396 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1259; /* andv4si3_neon */
              if (!
#line 759 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3552; /* mve_vandq_uv4si */

            case E_V4HFmode:
              if (pattern396 (x2, 
E_V4HFmode) != 0
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1260; /* andv4hf3_neon */

            case E_V8HFmode:
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !s_register_operand (operands[1], E_V8HFmode))
                return -1;
              if (neon_inv_logic_op2 (operands[2], E_V8HFmode)
                  && 
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1261; /* andv8hf3_neon */
              if (!s_register_operand (operands[2], E_V8HFmode)
                  || !
#line 1177 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3734; /* mve_vandq_fv8hf */

            case E_V2SFmode:
              if (pattern396 (x2, 
E_V2SFmode) != 0
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1262; /* andv2sf3_neon */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !s_register_operand (operands[1], E_V4SFmode))
                return -1;
              if (neon_inv_logic_op2 (operands[2], E_V4SFmode)
                  && 
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1263; /* andv4sf3_neon */
              if (!s_register_operand (operands[2], E_V4SFmode)
                  || !
#line 1177 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3735; /* mve_vandq_fv4sf */

            case E_V2DImode:
              if (pattern396 (x2, 
E_V2DImode) != 0
                  || !
#line 749 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1264; /* andv2di3_neon */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 94 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 536; /* iwmmxt_nanddi3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (s_register_operand (operands[0], E_SImode))
                {
                  operands[2] = x6;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x4 = XEXP (x2, 1);
                      operands[1] = x4;
                      if (s_register_operand (operands[1], E_SImode)
                          && 
#line 3605 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                        return 104; /* andsi_notsi_si */
                    }
                }
              if (!register_operand (operands[0], E_SImode))
                return -1;
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 235 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 948; /* thumb1_bicsi3 */

            case E_V8QImode:
              if (pattern358 (x2, 
E_V8QImode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1276; /* bicv8qi3_neon */

            case E_V16QImode:
              if (pattern358 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1277; /* bicv16qi3_neon */
              if (!
#line 786 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3553; /* mve_vbicq_uv16qi */

            case E_V4HImode:
              if (pattern358 (x2, 
E_V4HImode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1278; /* bicv4hi3_neon */

            case E_V8HImode:
              if (pattern358 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1279; /* bicv8hi3_neon */
              if (!
#line 786 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3554; /* mve_vbicq_uv8hi */

            case E_V2SImode:
              if (pattern358 (x2, 
E_V2SImode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1280; /* bicv2si3_neon */

            case E_V4SImode:
              if (pattern358 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1281; /* bicv4si3_neon */
              if (!
#line 786 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3555; /* mve_vbicq_uv4si */

            case E_V4HFmode:
              if (pattern358 (x2, 
E_V4HFmode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1282; /* bicv4hf3_neon */

            case E_V8HFmode:
              if (pattern359 (x2, 
E_V8HFmode) != 0)
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              operands[2] = x6;
              if (
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1283; /* bicv8hf3_neon */
              operands[2] = x4;
              operands[1] = x6;
              if (!
#line 1192 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3736; /* mve_vbicq_fv8hf */

            case E_V2SFmode:
              if (pattern358 (x2, 
E_V2SFmode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1284; /* bicv2sf3_neon */

            case E_V4SFmode:
              if (pattern359 (x2, 
E_V4SFmode) != 0)
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              operands[2] = x6;
              if (
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1285; /* bicv4sf3_neon */
              operands[2] = x4;
              operands[1] = x6;
              if (!
#line 1192 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3737; /* mve_vbicq_fv4sf */

            case E_V2DImode:
              if (pattern358 (x2, 
E_V2DImode) != 0
                  || !
#line 775 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1286; /* bicv2di3_neon */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x6;
          if (!shift_operator (operands[4], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 3617 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 105; /* andsi_not_shiftsi_si */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != NOT
          || GET_MODE (x4) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !
#line 3910 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 116; /* *andsi_iorsi3_notsi */

    case MULT:
      if (pattern275 (x2) != 0
          || !
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 323; /* *and_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 328; /* *and_shiftsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (pattern305 (x2) == 0
          && 
#line 9815 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return 334; /* *and_scc */
      if (pnum_clobbers == NULL
          || pattern306 (x2) != 0)
        return -1;
      if (
#line 10556 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
        {
          *pnum_clobbers = 1;
          return 346; /* *and_scc_scc */
        }
      if (!
#line 10624 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       == CCmode)))
        return -1;
      *pnum_clobbers = 1;
      return 348; /* *and_scc_scc_nodom */

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 52:
          if (pattern100 (x1, 
E_CCmode, 
104) != 0
              || !
#line 4429 "../../gcc/config/arm/arm.md"
(TARGET_ARM_QBIT))
            return -1;
          return 132; /* arm_set_apsr */

        case 45:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 12302 "../../gcc/config/arm/arm.md"
(TARGET_HARD_TP))
            return -1;
          return 406; /* reload_tp_hard */

        case 53:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          switch (GET_CODE (x5))
            {
            case POST_DEC:
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 1647 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 856; /* push_fpsysreg_insn */

            case POST_INC:
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 1666 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 857; /* pop_fpsysreg_insn */

            default:
              return -1;
            }

        case 29:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2124 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_BASE))
            return -1;
          return 926; /* get_fpscr */

        case 26:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !mem_and_no_t1_wback_op (operands[1], E_QImode))
                return -1;
              return 3068; /* arm_atomic_loadqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !mem_and_no_t1_wback_op (operands[1], E_HImode))
                return -1;
              return 3069; /* arm_atomic_loadhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !mem_and_no_t1_wback_op (operands[1], E_SImode))
                return -1;
              return 3070; /* arm_atomic_loadsi */

            default:
              return -1;
            }

        case 25:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !arm_sync_memory_operand (operands[1], E_QImode)
                  || !
#line 79 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3071; /* arm_atomic_load_acquireqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !arm_sync_memory_operand (operands[1], E_HImode)
                  || !
#line 79 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3072; /* arm_atomic_load_acquirehi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !arm_sync_memory_operand (operands[1], E_SImode)
                  || !
#line 79 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3073; /* arm_atomic_load_acquiresi */

            default:
              return -1;
            }

        case 28:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 3074; /* arm_atomic_storeqi */

            case E_HImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 3075; /* arm_atomic_storehi */

            case E_SImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 3076; /* arm_atomic_storesi */

            default:
              return -1;
            }

        case 27:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!arm_sync_memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 97 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3077; /* arm_atomic_store_releaseqi */

            case E_HImode:
              if (!arm_sync_memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 97 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3078; /* arm_atomic_store_releasehi */

            case E_SImode:
              if (!arm_sync_memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 97 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3079; /* arm_atomic_store_releasesi */

            default:
              return -1;
            }

        case 21:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!arm_ldrd_memory_operand (operands[1], E_DImode)
              || !
#line 166 "../../gcc/config/arm/sync.md"
(ARM_DOUBLEWORD_ALIGN && TARGET_HAVE_LPAE))
            return -1;
          return 3080; /* arm_atomic_loaddi2_ldrd */

        case 20:
          switch (pattern241 (x1))
            {
            case 0:
              if (!
#line 519 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX))
                return -1;
              return 3169; /* arm_load_exclusivesi */

            case 1:
              if (!
#line 537 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD))
                return -1;
              return 3171; /* arm_load_exclusivedi */

            default:
              return -1;
            }

        case 23:
          switch (pattern241 (x1))
            {
            case 0:
              if (!
#line 528 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3170; /* arm_load_acquire_exclusivesi */

            case 1:
              if (!
#line 546 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQEXD && ARM_DOUBLEWORD_ALIGN))
                return -1;
              return 3172; /* arm_load_acquire_exclusivedi */

            default:
              return -1;
            }

        case 120:
          if (pattern94 (x2, 
101, 
E_SImode) != 0)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3969 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4974; /* get_fpscr_nzcvqc */

        case 31:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 101
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3977 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4975; /* set_fpscr_nzcvqc */

        case 61:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5071; /* dlstp8_insn */

        case 62:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5072; /* dlstp16_insn */

        case 63:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5073; /* dlstp32_insn */

        case 64:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5074; /* dlstp64_insn */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 32:
          if (pattern128 (x1, 
E_SImode) != 0
              || !
#line 9273 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 307; /* probe_stack_range */

        case 58:
          if (pattern124 (x1) != 0
              || !
#line 13108 "../../gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 515; /* pacbti_nop */

        case 13:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 802 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 594; /* eqv8qi3 */

            case 1:
              if (!
#line 813 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 595; /* eqv4hi3 */

            case 2:
              if (!
#line 825 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 596; /* eqv2si3 */

            default:
              return -1;
            }

        case 14:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 836 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 597; /* gtuv8qi3 */

            case 1:
              if (!
#line 847 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 598; /* gtuv4hi3 */

            case 2:
              if (!
#line 858 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 599; /* gtuv2si3 */

            default:
              return -1;
            }

        case 15:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 869 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 600; /* gtv8qi3 */

            case 1:
              if (!
#line 880 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 601; /* gtv4hi3 */

            case 2:
              if (!
#line 891 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 602; /* gtv2si3 */

            default:
              return -1;
            }

        case 19:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3093; /* atomic_addqi */

                case 1:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3098; /* atomic_addhi */

                case 2:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3103; /* atomic_addsi */

                case 3:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3108; /* atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3094; /* atomic_subqi */

                case 1:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3099; /* atomic_subhi */

                case 2:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3104; /* atomic_subsi */

                case 3:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3109; /* atomic_subdi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3095; /* atomic_orqi */

                case 1:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3100; /* atomic_orhi */

                case 2:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3105; /* atomic_orsi */

                case 3:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3110; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3096; /* atomic_xorqi */

                case 1:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3101; /* atomic_xorhi */

                case 2:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3106; /* atomic_xorsi */

                case 3:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3111; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3097; /* atomic_andqi */

                case 1:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3102; /* atomic_andhi */

                case 2:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3107; /* atomic_andsi */

                case 3:
                  if (!
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3112; /* atomic_anddi */

                default:
                  return -1;
                }

            case NOT:
              x8 = XEXP (x3, 0);
              if (GET_CODE (x8) != AND)
                return -1;
              x9 = XEXP (x8, 1);
              operands[1] = x9;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern514 (x2, 
E_QImode) != 0
                      || !
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3113; /* atomic_nandqi */

                case E_HImode:
                  if (pattern514 (x2, 
E_HImode) != 0
                      || !
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3114; /* atomic_nandhi */

                case E_SImode:
                  if (pattern514 (x2, 
E_SImode) != 0
                      || !
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3115; /* atomic_nandsi */

                case E_DImode:
                  if (!mem_noofs_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x8) != E_DImode
                      || !s_register_operand (operands[1], E_DImode)
                      || !
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3116; /* atomic_nanddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      if (pattern9 (x1, 
E_SImode) != 0)
        return -1;
      x11 = XVECEXP (x2, 0, 3);
      operands[4] = x11;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x12 = XVECEXP (x2, 0, 4);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 45:
          if (!
#line 13026 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRC)))
            return -1;
          return 507; /* arm_mrc */

        case 46:
          if (!
#line 13026 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRC2)))
            return -1;
          return 508; /* arm_mrc2 */

        default:
          return -1;
        }

    case 3:
      if (pattern9 (x1, 
E_DImode) != 0)
        return -1;
      switch (XINT (x2, 1))
        {
        case 49:
          if (!
#line 13059 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRRC)))
            return -1;
          return 511; /* arm_mrrc */

        case 50:
          if (!
#line 13059 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRRC2)))
            return -1;
          return 512; /* arm_mrrc2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 171; /* *arm_abssi2 */
            }
          if (
#line 334 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 957; /* *thumb1_abssi2 */
            }
          if (!
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1011; /* *thumb2_abssi2 */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 872 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 782; /* *abssf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 881 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 783; /* *absdf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 949 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 786; /* abshf2 */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1309; /* neon_absv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1310; /* neon_absv16qi2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3292; /* mve_vabsq_sv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1311; /* neon_absv4hi2 */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1312; /* neon_absv8hi2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3294; /* mve_vabsq_sv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1313; /* neon_absv2si2 */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1314; /* neon_absv4si2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3296; /* mve_vabsq_sv4si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1315; /* neon_absv2sf2 */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (
#line 800 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1316; /* neon_absv4sf2 */
          if (!
#line 189 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3273; /* mve_vabsq_fv4sf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (
#line 822 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1325; /* neon_absv8hf2 */
          if (!
#line 189 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3271; /* mve_vabsq_fv8hf */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 822 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1327; /* neon_absv4hf2 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (pattern281 (x3, 
E_V4HFmode) != 0
              || !(
#line 6602 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3012; /* neon_vabdv4hf_2 */

        case E_V8HFmode:
          if (pattern281 (x3, 
E_V8HFmode) != 0
              || !(
#line 6602 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3013; /* neon_vabdv8hf_2 */

        case E_V2SFmode:
          if (pattern281 (x3, 
E_V2SFmode) != 0
              || !
#line 6602 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 3014; /* neon_vabdv2sf_2 */

        case E_V4SFmode:
          if (pattern281 (x3, 
E_V4SFmode) != 0
              || !
#line 6602 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 3015; /* neon_vabdv4sf_2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 336)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HFmode:
          if (pattern400 (x3, 
E_V4HFmode) != 0
              || !(
#line 6612 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3016; /* neon_vabdv4hf_3 */

        case E_V8HFmode:
          if (pattern400 (x3, 
E_V8HFmode) != 0
              || !(
#line 6612 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
            return -1;
          return 3017; /* neon_vabdv8hf_3 */

        case E_V2SFmode:
          if (pattern400 (x3, 
E_V2SFmode) != 0
              || !
#line 6612 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 3018; /* neon_vabdv2sf_3 */

        case E_V4SFmode:
          if (pattern400 (x3, 
E_V4SFmode) != 0
              || !
#line 6612 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 3019; /* neon_vabdv4sf_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (XVECLEN (x3, 0) != 1)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[2] = x6;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_V2SImode)
              && 
#line 770 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 592; /* iwmmxt_textrmw */
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (!s_register_operand (operands[1], E_V2SImode)
                  || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1151; /* vec_extractv2sisi */

            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode))
                return -1;
              if (
#line 468 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1156; /* neon_vec_extractv4sisi */
              if (!
#line 4157 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 5009; /* mve_vec_extractv4sisi */

            default:
              return -1;
            }

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8QImode:
              if (!s_register_operand (operands[1], E_V8QImode)
                  || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1147; /* vec_extractv8qiqi */

            case E_V16QImode:
              if (!s_register_operand (operands[1], E_V16QImode))
                return -1;
              if (
#line 468 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1153; /* neon_vec_extractv16qiqi */
              if (!
#line 4157 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
                return -1;
              return 5007; /* mve_vec_extractv16qiqi */

            default:
              return -1;
            }

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!s_register_operand (operands[1], E_V4HImode)
                  || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1148; /* vec_extractv4hihi */

            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode))
                return -1;
              if (
#line 468 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1154; /* neon_vec_extractv8hihi */
              if (!
#line 4157 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
                return -1;
              return 5008; /* mve_vec_extractv8hihi */

            default:
              return -1;
            }

        case E_HFmode:
          if (!nonimmediate_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!s_register_operand (operands[1], E_V4HFmode)
                  || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1149; /* vec_extractv4hfhf */

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode))
                return -1;
              if (
#line 468 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1155; /* neon_vec_extractv8hfhf */
              if (!
#line 4157 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
                return -1;
              return 5010; /* mve_vec_extractv8hfhf */

            default:
              return -1;
            }

        case E_BFmode:
          if (!nonimmediate_operand (operands[0], E_BFmode)
              || GET_MODE (x2) != E_BFmode
              || !s_register_operand (operands[1], E_V4BFmode)
              || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1150; /* vec_extractv4bfbf */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!s_register_operand (operands[1], E_V2SFmode)
                  || !
#line 394 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1152; /* vec_extractv2sfsf */

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode))
                return -1;
              if (
#line 468 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1157; /* neon_vec_extractv4sfsf */
              if (!
#line 4157 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 5011; /* mve_vec_extractv4sfsf */

            default:
              return -1;
            }

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !s_register_operand (operands[1], E_V2DImode))
            return -1;
          if (
#line 496 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1158; /* neon_vec_extractv2didi */
          if (!
#line 4175 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5012; /* mve_vec_extractv2didi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!
#line 1141 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 627; /* iwmmxt_wunpckehub */

        case 1:
          if (!
#line 1209 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 633; /* iwmmxt_wunpckelub */

        case 2:
          if (!
#line 1152 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 628; /* iwmmxt_wunpckehuh */

        case 3:
          if (!
#line 1220 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 634; /* iwmmxt_wunpckeluh */

        case 4:
          if (!
#line 1163 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 629; /* iwmmxt_wunpckehuw */

        case 5:
          if (!
#line 1231 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 635; /* iwmmxt_wunpckeluw */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!
#line 1175 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 630; /* iwmmxt_wunpckehsb */

        case 1:
          if (!
#line 1243 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 636; /* iwmmxt_wunpckelsb */

        case 2:
          if (!
#line 1186 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 631; /* iwmmxt_wunpckehsh */

        case 3:
          if (!
#line 1254 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 637; /* iwmmxt_wunpckelsh */

        case 4:
          if (!
#line 1197 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 632; /* iwmmxt_wunpckehsw */

        case 5:
          if (!
#line 1265 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 638; /* iwmmxt_wunpckelsw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 381 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 558; /* usaddv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1438 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1458; /* *us_addv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 391 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 559; /* usaddv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1438 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1459; /* *us_addv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 401 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 560; /* usaddv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1438 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1460; /* *us_addv2si_neon */

    case 3:
      if (!
#line 1438 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1461; /* *us_addv2sf_neon */

    case 4:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3194; /* usaddv4uqq3 */

    case 5:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3195; /* usaddv2uhq3 */

    case 6:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3196; /* usadduqq3 */

    case 7:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3197; /* usadduhq3 */

    case 8:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3198; /* usaddv2uha3 */

    case 9:
      if (!
#line 55 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3199; /* usadduha3 */

    default:
      return -1;
    }
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x1, 0);
  operands[3] = x6;
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XVECEXP (x4, 0, 2);
  operands[2] = x10;
  if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6771 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
    return -1;
  return 6568; /* *p tls_load_dot_plus_eight */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 101)
    return -1;
  x6 = XEXP (x1, 0);
  operands[2] = x6;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x5))
    {
    case E_CCFPmode:
      switch (pattern554 (x3, 
E_CCFPmode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1815 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6963; /* *p *cmpsf_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1839 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6965; /* *p *cmpdf_vfp */

        default:
          return -1;
        }

    case E_CCFPEmode:
      switch (pattern554 (x3, 
E_CCFPEmode))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1827 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6964; /* *p *cmpsf_trap_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1851 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6966; /* *p *cmpdf_trap_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[6] = x2;
  x3 = XEXP (x2, 0);
  operands[7] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x10 = XEXP (x5, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!const_int_operand (operands[2], E_VOIDmode)
      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3559 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0))))
    return -1;
  return 6447; /* *p *bfi_alt1 */
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case LSHIFTRT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case MULT:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x10) != E_V4SImode)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != SIGN_EXTEND
                  || GET_MODE (x11) != E_V4SImode
                  || XWINT (x8, 0) != 16L
                  || !register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x6) != E_V4HImode
                  || GET_MODE (x7) != E_V4SImode
                  || GET_MODE (x9) != E_V4SImode)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_V4HImode))
                return -1;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              if (!register_operand (operands[2], E_V4HImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 494 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6709; /* *p smulv4hi3_highpart */

            case ZERO_EXTEND:
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != ZERO_EXTEND)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              switch (XWINT (x8, 0))
                {
                case 16L:
                  if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 507 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6710; /* *p umulv4hi3_highpart */

                case 32L:
                  if (pattern570 (x6, 
E_V2SImode, 
E_V2DImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 279 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6842; /* *p iwmmxt_wmulwum */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case PLUS:
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != ZERO_EXTEND)
                return -1;
              x14 = XEXP (x10, 1);
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != CONST_VECTOR
                  || XWINT (x8, 0) != 1L)
                return -1;
              x15 = XEXP (x12, 0);
              operands[1] = x15;
              x16 = XEXP (x14, 0);
              operands[2] = x16;
              switch (XVECLEN (x11, 0))
                {
                case 8:
                  if (pattern601 (x11, 
1) != 0
                      || pattern594 (x6, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 617 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6719; /* *p iwmmxt_uavgrndv8qi3 */

                case 4:
                  if (GET_MODE (x11) != E_V4SImode)
                    return -1;
                  x17 = XVECEXP (x11, 0, 0);
                  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x18 = XVECEXP (x11, 0, 1);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x19 = XVECEXP (x11, 0, 2);
                  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x20 = XVECEXP (x11, 0, 3);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 635 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6720; /* *p iwmmxt_uavgrndv4hi3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || XWINT (x8, 0) != 1L)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern570 (x6, 
E_V8QImode, 
E_V8HImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 648 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6721; /* *p iwmmxt_uavgv8qi3 */

                case E_V4HImode:
                  if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 661 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6722; /* *p iwmmxt_uavgv4hi3 */

                default:
                  return -1;
                }

            case MULT:
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != ZERO_EXTEND)
                return -1;
              x14 = XEXP (x10, 1);
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != CONST_VECTOR)
                return -1;
              x15 = XEXP (x12, 0);
              operands[1] = x15;
              x16 = XEXP (x14, 0);
              operands[2] = x16;
              switch (XVECLEN (x11, 0))
                {
                case 4:
                  if (pattern593 (x11) != 0)
                    return -1;
                  x20 = XVECEXP (x11, 0, 3);
                  if (GET_CODE (x20) != CONST_INT
                      || XWINT (x20, 0) != 32768L
                      || XWINT (x8, 0) != 16L
                      || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 316 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6844; /* *p iwmmxt_wmulumr */

                case 2:
                  if (pattern595 (x6) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 350 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                    return -1;
                  return 6846; /* *p iwmmxt_wmulwumr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MINUS)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != ZERO_EXTEND)
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x13 = XEXP (x11, 0);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern570 (x6, 
E_V8QImode, 
E_V8HImode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 37 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6828; /* *p iwmmxt_wabsdiffb */

        case E_V4HImode:
          if (pattern570 (x6, 
E_V4HImode, 
E_V4SImode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 50 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6829; /* *p iwmmxt_wabsdiffh */

        case E_V2SImode:
          if (pattern570 (x6, 
E_V2SImode, 
E_V2DImode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 63 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6830; /* *p iwmmxt_wabsdiffw */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x7) != E_V8HImode)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != VEC_MERGE
          || GET_MODE (x9) != E_V8HImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != LSHIFTRT
          || GET_MODE (x10) != E_V8HImode)
        return -1;
      x12 = XEXP (x10, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_V8HImode)
        return -1;
      x15 = XEXP (x12, 0);
      if (GET_CODE (x15) != PLUS
          || GET_MODE (x15) != E_V8HImode)
        return -1;
      x21 = XEXP (x15, 0);
      if (GET_CODE (x21) != PLUS
          || GET_MODE (x21) != E_V8HImode)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS
          || GET_MODE (x22) != E_V8HImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_V8HImode)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != ZERO_EXTEND
          || GET_MODE (x24) != E_V8HImode)
        return -1;
      x25 = XEXP (x21, 1);
      if (GET_CODE (x25) != VEC_SELECT
          || GET_MODE (x25) != E_V8HImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != ZERO_EXTEND
          || GET_MODE (x26) != E_V8HImode)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != PARALLEL
          || XVECLEN (x27, 0) != 8)
        return -1;
      x28 = XVECEXP (x27, 0, 0);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x29 = XVECEXP (x27, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x30 = XVECEXP (x27, 0, 2);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x31 = XVECEXP (x27, 0, 3);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x32 = XVECEXP (x27, 0, 4);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x27, 0, 5);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x34 = XVECEXP (x27, 0, 6);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x35 = XVECEXP (x27, 0, 7);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x36 = XEXP (x15, 1);
      if (GET_CODE (x36) != VEC_SELECT
          || GET_MODE (x36) != E_V8HImode)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != ZERO_EXTEND
          || GET_MODE (x37) != E_V8HImode)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != PARALLEL
          || XVECLEN (x38, 0) != 8)
        return -1;
      x39 = XVECEXP (x38, 0, 0);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x40 = XVECEXP (x38, 0, 1);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x41 = XVECEXP (x38, 0, 2);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x42 = XVECEXP (x38, 0, 3);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x43 = XVECEXP (x38, 0, 4);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x44 = XVECEXP (x38, 0, 5);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x45 = XVECEXP (x38, 0, 6);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x46 = XVECEXP (x38, 0, 7);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x47 = XEXP (x12, 1);
      if (GET_CODE (x47) != CONST_VECTOR
          || XVECLEN (x47, 0) != 8
          || GET_MODE (x47) != E_V8HImode)
        return -1;
      x48 = XVECEXP (x47, 0, 0);
      if (GET_CODE (x48) != CONST_INT)
        return -1;
      x49 = XVECEXP (x47, 0, 1);
      if (GET_CODE (x49) != CONST_INT)
        return -1;
      x50 = XVECEXP (x47, 0, 2);
      if (GET_CODE (x50) != CONST_INT)
        return -1;
      x51 = XVECEXP (x47, 0, 3);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x47, 0, 4);
      if (GET_CODE (x52) != CONST_INT)
        return -1;
      x53 = XVECEXP (x47, 0, 5);
      if (GET_CODE (x53) != CONST_INT)
        return -1;
      x54 = XVECEXP (x47, 0, 6);
      if (GET_CODE (x54) != CONST_INT)
        return -1;
      x55 = XVECEXP (x47, 0, 7);
      if (GET_CODE (x55) != CONST_INT)
        return -1;
      x14 = XEXP (x10, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != CONST_VECTOR
          || XVECLEN (x11, 0) != 8
          || pattern601 (x11, 
0) != 0)
        return -1;
      x56 = XEXP (x9, 2);
      if (GET_CODE (x56) != CONST_INT
          || XWINT (x56, 0) != 254L)
        return -1;
      x8 = XEXP (x7, 1);
      if (pattern604 (x8, 
2, 
8) != 0)
        return -1;
      x57 = XVECEXP (x8, 0, 2);
      if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x58 = XVECEXP (x8, 0, 3);
      if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x59 = XVECEXP (x8, 0, 4);
      if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x60 = XVECEXP (x8, 0, 5);
      if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x61 = XVECEXP (x8, 0, 6);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x62 = XVECEXP (x8, 0, 7);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x63 = XEXP (x23, 0);
      operands[1] = x63;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x64 = XEXP (x24, 0);
      operands[2] = x64;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      x65 = XEXP (x26, 0);
      if (!rtx_equal_p (x65, operands[1]))
        return -1;
      x66 = XEXP (x37, 0);
      if (!rtx_equal_p (x66, operands[2]))
        return -1;
      switch (XWINT (x48, 0))
        {
        case 1L:
          if (XWINT (x49, 0) != 1L
              || XWINT (x50, 0) != 1L
              || XWINT (x51, 0) != 1L
              || XWINT (x52, 0) != 1L
              || XWINT (x53, 0) != 1L
              || XWINT (x54, 0) != 1L
              || XWINT (x55, 0) != 1L
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 143 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6835; /* *p iwmmxt_avg4 */

        case 2L:
          if (XWINT (x49, 0) != 2L
              || XWINT (x50, 0) != 2L
              || XWINT (x51, 0) != 2L
              || XWINT (x52, 0) != 2L
              || XWINT (x53, 0) != 2L
              || XWINT (x54, 0) != 2L
              || XWINT (x55, 0) != 2L
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 175 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6836; /* *p iwmmxt_avg4r */

        default:
          return -1;
        }

    case ASHIFTRT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case MULT:
          if (GET_MODE (x9) != E_V2DImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_V2DImode)
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_V2DImode
              || XWINT (x8, 0) != 32L
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x6) != E_V2SImode
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_V2SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 265 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6841; /* *p iwmmxt_wmulwsm */

        case PLUS:
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MULT)
            return -1;
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != SIGN_EXTEND)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != SIGN_EXTEND)
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != CONST_VECTOR)
            return -1;
          x15 = XEXP (x12, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 0);
          operands[2] = x16;
          switch (XVECLEN (x11, 0))
            {
            case 3:
              if (pattern593 (x11) != 0
                  || XWINT (x8, 0) != 16L
                  || pattern594 (x6, 
E_V4HImode, 
E_V4SImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 297 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6843; /* *p iwmmxt_wmulsmr */

            case 2:
              if (pattern595 (x6) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 333 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6845; /* *p iwmmxt_wmulwsmr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 52:
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 104
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 0);
          operands[0] = x7;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4429 "../../gcc/config/arm/arm.md"
(TARGET_ARM_QBIT)))
            return -1;
          return 6465; /* *p arm_set_apsr */

        case 53:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          switch (GET_CODE (x8))
            {
            case POST_DEC:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1647 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse)))
                return -1;
              return 6959; /* *p push_fpsysreg_insn */

            case POST_INC:
              x9 = XEXP (x8, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1666 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse)))
                return -1;
              return 6960; /* *p pop_fpsysreg_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      switch (XINT (x3, 1))
        {
        case 13:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 802 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6732; /* *p eqv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 813 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6733; /* *p eqv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 825 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6734; /* *p eqv2si3 */

            default:
              return -1;
            }

        case 14:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 836 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6735; /* *p gtuv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 847 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6736; /* *p gtuv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 858 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6737; /* *p gtuv2si3 */

            default:
              return -1;
            }

        case 15:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern542 (x3, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 869 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6738; /* *p gtv8qi3 */

            case E_V4HImode:
              if (pattern542 (x3, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 880 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6739; /* *p gtv4hi3 */

            case E_V2SImode:
              if (pattern542 (x3, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 891 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6740; /* *p gtv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          if (XWINT (x6, 0) != 0L)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4127 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6459; /* *p *smin_0 */

        case REG:
        case SUBREG:
          switch (pattern441 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6747; /* *p *sminv2si3_iwmmxt */

            case 1:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6748; /* *p *sminv4hi3_iwmmxt */

            case 2:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6749; /* *p *sminv8qi3_iwmmxt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return 6466; /* *p satsi_smin */
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6467; /* *p satsi_smin_setq */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4503 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6470; /* *p *satsi_smin_shift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[1] = x9;
      if (ldrd_strd_offset_operand (operands[1], E_SImode))
        {
          res = recog_365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x9, 0) != -4L)
        return -1;
      x10 = XEXP (x1, 0);
      operands[3] = x10;
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      x12 = XEXP (x8, 0);
      operands[0] = x12;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[1] = x13;
      operands[2] = x7;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[0])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12793 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], -4, false, false)))))
        return -1;
      return 6619; /* *p *thumb2_strd_base_neg */

    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x10 = XEXP (x1, 0);
      operands[3] = x10;
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      x13 = XEXP (x3, 1);
      operands[1] = x13;
      operands[2] = x7;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[0])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12780 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], 0, false, false)))))
        return -1;
      return 6618; /* *p *thumb2_strd_base */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return recog_306 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      return recog_307 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_300 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_317 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_308 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_278 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[5] = x3;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[4] = x8;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          operands[2] = x10;
          if (!arm_rhs_operand (operands[2], E_SImode)
              || !
#line 10767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_311 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_284 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_287 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_288 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_289 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          res = recog_290 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_291 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x2) == E_SImode)
        {
          res = recog_292 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_293 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x2))
        {
        case PLUS:
        case AND:
          operands[5] = x2;
          if (shiftable_operator_strict_it (operands[5], E_SImode))
            {
              x3 = XEXP (x2, 0);
              if (arm_comparison_operator (x3, E_SImode))
                {
                  operands[4] = x3;
                  if (s_register_operand (operands[0], E_SImode))
                    {
                      x4 = XEXP (x3, 0);
                      operands[2] = x4;
                      if (s_register_operand (operands[2], E_SImode))
                        {
                          x5 = XEXP (x3, 1);
                          operands[3] = x5;
                          if (arm_rhs_operand (operands[3], E_SImode))
                            {
                              x9 = XEXP (x2, 1);
                              operands[1] = x9;
                              if (s_register_operand (operands[1], E_SImode)
                                  && 
#line 798 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
                                {
                                  *pnum_clobbers = 1;
                                  return 1037; /* *thumb2_cond_arith_strict_it */
                                }
                            }
                        }
                    }
                }
            }
          if (GET_CODE (x2) != PLUS
              || GET_MODE (x2) != E_SImode
              || !low_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          if (!low_reg_or_int_operand (operands[2], E_SImode)
              || !
#line 1301 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1057; /* *thumb2_addsi_short */

        case MINUS:
          if (GET_MODE (x2) != E_SImode
              || !low_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          if (!low_register_operand (operands[2], E_SImode)
              || !
#line 1330 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1058; /* *thumb2_subsi_short */

        default:
          return -1;
        }

    case SS_PLUS:
      return recog_318 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_319 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_301 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_313 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_315 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_312 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[2] = x9;
      if (pattern276 (x1) == 0
          && 
#line 5104 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3]))))
        return 164; /* *extv_reg */
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x10 = XEXP (x2, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11839 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *sign_extract_onebit */

        case 8L:
          x10 = XEXP (x2, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          switch (XWINT (x10, 0))
            {
            case 8L:
              if (!
#line 12688 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 420; /* *arm_signextractsi2_8_8 */

            case 16L:
              if (!
#line 12698 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 421; /* *arm_signextractsi2_8_16 */

            default:
              return -1;
            }

        case 16L:
          x10 = XEXP (x2, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !
#line 12708 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return -1;
          return 422; /* *arm_signextractsi2_16_8 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[2] = x9;
      if (pattern276 (x1) == 0
          && 
#line 5118 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3]))))
        return 165; /* extzv_t2 */
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 8L:
          switch (XWINT (x10, 0))
            {
            case 8L:
              if (!
#line 12655 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 417; /* *arm_zeroextractsi2_8_8 */

            case 16L:
              if (!
#line 12665 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 418; /* *arm_zeroextractsi2_8_16 */

            default:
              return -1;
            }

        case 16L:
          if (XWINT (x10, 0) != 8L
              || !
#line 12675 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return -1;
          return 419; /* *arm_zeroextractsi2_16_8 */

        default:
          return -1;
        }

    case DIV:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1 (x2, 
E_SImode) != 0
              || !
#line 5133 "../../gcc/config/arm/arm.md"
(TARGET_IDIV))
            return -1;
          return 166; /* divsi3 */

        case E_HFmode:
          if (pattern1 (x2, 
E_HFmode) != 0
              || !
#line 1064 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 801; /* divhf3 */

        case E_SFmode:
          if (pattern1 (x2, 
E_SFmode) != 0
              || !
#line 1077 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 802; /* *divsf3_vfp */

        case E_DFmode:
          if (pattern1 (x2, 
E_DFmode) != 0
              || !
#line 1088 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 803; /* *divdf3_vfp */

        default:
          return -1;
        }

    case UDIV:
      if (pattern3 (x1, 
E_SImode) != 0
          || !
#line 5146 "../../gcc/config/arm/arm.md"
(TARGET_IDIV))
        return -1;
      return 167; /* udivsi3 */

    case NEG:
      return recog_309 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_310 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_302 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 6544 "../../gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT && arm_valid_symbolic_address_p (operands[2])))
        return -1;
      return 256; /* *arm_movt */

    case CLZ:
      return recog_322 (x1, insn, pnum_clobbers);

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 12213 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
        return -1;
      return 401; /* ctzsi2 */

    case BSWAP:
      return recog_324 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_303 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_321 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_320 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_304 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_314 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_316 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_305 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1458 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 837; /* *extendsfdf2_vfp */

            case E_HFmode:
              if (!s_register_operand (operands[1], E_HFmode)
                  || !
#line 1494 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE))
                return -1;
              return 841; /* *extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 1476 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST)))
            return -1;
          return 839; /* extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 1467 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 838; /* *truncdfsf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 1485 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE))
                return -1;
              return 840; /* *truncdfhf2 */

            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1503 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST)))
                return -1;
              return 842; /* truncsfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_323 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_325 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1550 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 847; /* *floatsisf2_vfp */

        case 1:
          if (!
#line 1559 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 848; /* *floatsidf2_vfp */

        case 2:
          if (!
#line 3685 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2100; /* floatv2siv2sf2 */

        case 3:
          if (!
#line 3685 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2101; /* floatv4siv4sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1569 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 849; /* floatunssisf2 */

        case 1:
          if (!
#line 1578 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 850; /* floatunssidf2 */

        case 2:
          if (!
#line 3693 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2102; /* floatunsv2siv2sf2 */

        case 3:
          if (!
#line 3693 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2103; /* floatunsv4siv4sf2 */

        default:
          return -1;
        }

    case SQRT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 1590 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 851; /* neon_vsqrthf */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 1614 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 853; /* *sqrtsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 1624 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 854; /* *sqrtdf2_vfp */

        default:
          return -1;
        }

    case POPCOUNT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 3166 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2024; /* popcountv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode)
              || !
#line 3166 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2025; /* popcountv16qi2 */

        default:
          return -1;
        }

    case SS_MULT:
      if (pnum_clobbers == NULL
          || pattern3 (x1, 
E_SAmode) != 0
          || !
#line 264 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      *pnum_clobbers = 3;
      return 3235; /* *arm_ssmulsa3 */

    case US_MULT:
      if (pnum_clobbers == NULL
          || pattern3 (x1, 
E_USAmode) != 0
          || !
#line 336 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      *pnum_clobbers = 3;
      return 3236; /* *arm_usmulusa3 */

    case SS_TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (!sat_shift_operator (x3, E_SImode))
        return -1;
      operands[1] = x3;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 481 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      return 3237; /* arm_ssatsihi_shift */

    case US_TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 490 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3238; /* arm_usatsihi */

    case US_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !
#line 4321 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5031; /* mve_uqshll_di */

        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !arm_general_register_operand (operands[1], E_SImode)
              || !
#line 4344 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5033; /* mve_uqshl_si */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !arm_general_register_operand (operands[1], E_DImode)
              || !
#line 4367 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5035; /* mve_sqshl_si */

        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !
#line 4402 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5038; /* mve_sqshll_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
