/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case MEM:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      return 0;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 39)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      return 0;

    case E_V2SImode:
      if (GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      return 1;

    case E_DImode:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern27 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern27 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V4SImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern38 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern38 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8BImode:
      return pattern49 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4BImode:
      if (pattern49 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V8HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_V16QImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_V8HImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SImode, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern59 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern41 (x3, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern41 (x3, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern41 (x3, 
E_DFmode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 4;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 5;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 8;

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !mve_imm_8 (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (pattern166 (x3, 
E_V8HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern167 (x3, 
E_V4SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern40 (x3, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern40 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_low_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_low_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !mve_imm_16 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], E_V4SImode)
      || !mve_imm_32 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern211 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern211 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern211 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern223 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern223 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          return pattern233 (x1, 
E_V16QImode, 
E_V16BImode); /* [-1, 0] */

        case E_V8BImode:
          if (!vpr_register_operand (operands[0], E_V8BImode)
              || GET_MODE (x1) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode)
                  || !s_register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case E_V4BImode:
          if (!vpr_register_operand (operands[0], E_V4BImode)
              || GET_MODE (x1) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode)
                  || !s_register_operand (operands[2], E_V4SImode))
                return -1;
              return 3;

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode))
                return -1;
              return 4;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          if (pattern234 (x1, 
E_QImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 5;

        case E_V8BImode:
          if (!vpr_register_operand (operands[0], E_V8BImode)
              || GET_MODE (x1) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !s_register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode
                  || !s_register_operand (operands[2], E_HFmode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_V4BImode:
          if (!vpr_register_operand (operands[0], E_V4BImode)
              || GET_MODE (x1) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !s_register_operand (operands[2], E_SImode))
                return -1;
              return 8;

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_SFmode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!s_register_operand (operands[1], E_HImode))
                return -1;
              return 0;

            case E_QImode:
              if (!s_register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern272 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern272 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 3;

        case E_V2DImode:
          if (pattern272 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern273 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern273 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern273 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      return 0;

    case REG:
      operands[1] = x3;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!arm_comparison_operator (operands[3], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (!arm_comparison_operator (x3, E_SImode))
    return -1;
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arm_add_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  if (!arm_add_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 28
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  return 0;
}

int
pattern338 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern342 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern354 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern354 (x1, 
E_V4SImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern364 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 28
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern382 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  return pattern256 (x9); /* [-1, 0] */
}

int
pattern393 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x5) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern423 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !const_int_vcde2_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern435 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern311 (x3, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern311 (x3, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!s_register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_SFmode:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 6;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_HFmode:
      if (!s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  return pattern504 (x2, 
i1, 
i2); /* [-1, 1] */
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !const_int_vcde3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arm_general_register_operand (operands[0], E_SImode)
      || !arm_general_register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !mem_noofs_operand (operands[1], i1)
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern549 (rtx x1, machine_mode i1, unsigned int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern567 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern567 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || !mem_noofs_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern588 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i2
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != i1
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern600 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern607 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x2, 2);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 0L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 0;

        case 1L:
          return 1;

        default:
          return -1;
        }

    case 1L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 2;

        case 1L:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_V2SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != E_V4SImode)
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != E_V4SImode)
    return -1;
  x14 = XEXP (x11, 1);
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != E_V4SImode)
    return -1;
  switch (GET_CODE (x8))
    {
    case SIGN_EXTEND:
      return 0;

    case ZERO_EXTEND:
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!store_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 1);
  operands[4] = x7;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern656 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  x16 = XEXP (x4, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 0L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 2L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 0;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 1L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 3L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 2;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 82:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 226; /* arm_sadd8 */

    case 83:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 227; /* arm_ssub8 */

    case 84:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 228; /* arm_uadd8 */

    case 85:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 229; /* arm_usub8 */

    case 86:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 230; /* arm_sadd16 */

    case 87:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 231; /* arm_sasx */

    case 88:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 232; /* arm_ssax */

    case 89:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 233; /* arm_ssub16 */

    case 90:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 234; /* arm_uadd16 */

    case 91:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 235; /* arm_uasx */

    case 92:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 236; /* arm_usax */

    case 93:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 237; /* arm_usub16 */

    case 98:
      if (pattern324 (x1, 
28, 
E_SImode, 
E_CCmode, 
104) != 0
          || !
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 247; /* arm_smuad_setq_insn */

    case 99:
      if (pattern324 (x1, 
28, 
E_SImode, 
E_CCmode, 
104) != 0
          || !
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 249; /* arm_smuadx_setq_insn */

    case 100:
      if (pattern325 (x1) != 0
          || !ssat16_imm (operands[2], E_SImode)
          || !
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 251; /* arm_ssat16_setq_insn */

    case 101:
      if (pattern325 (x1) != 0
          || !usat16_imm (operands[2], E_SImode)
          || !
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 253; /* arm_usat16_setq_insn */

    case 177:
      if (pattern326 (x1) != 0
          || !
#line 1941 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 878; /* neon_vcvths_nhf_unspec */

    case 178:
      if (pattern326 (x1) != 0
          || !
#line 1941 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 879; /* neon_vcvthu_nhf_unspec */

    case 41:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || !register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[2])
          || !
#line 2116 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 1006; /* thumb1_stack_protect_test_insn */

    case 345:
      switch (pattern328 (x1, 
346))
        {
        case 0:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2492; /* *neon_vtrnv8qi_insn */

        case 1:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2493; /* *neon_vtrnv16qi_insn */

        case 2:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2494; /* *neon_vtrnv4hi_insn */

        case 3:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2495; /* *neon_vtrnv8hi_insn */

        case 4:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2496; /* *neon_vtrnv2si_insn */

        case 5:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2497; /* *neon_vtrnv4si_insn */

        case 6:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2498; /* *neon_vtrnv2sf_insn */

        case 7:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2499; /* *neon_vtrnv4sf_insn */

        case 8:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2500; /* *neon_vtrnv8hf_insn */

        case 9:
          if (!
#line 4926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2501; /* *neon_vtrnv4hf_insn */

        default:
          return -1;
        }

    case 350:
      switch (pattern328 (x1, 
351))
        {
        case 0:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2502; /* *neon_vzipv8qi_insn */

        case 1:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2503; /* *neon_vzipv16qi_insn */

        case 2:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2504; /* *neon_vzipv4hi_insn */

        case 3:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2505; /* *neon_vzipv8hi_insn */

        case 4:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2506; /* *neon_vzipv2si_insn */

        case 5:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2507; /* *neon_vzipv4si_insn */

        case 6:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2508; /* *neon_vzipv2sf_insn */

        case 7:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2509; /* *neon_vzipv4sf_insn */

        case 8:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2510; /* *neon_vzipv8hf_insn */

        case 9:
          if (!
#line 4952 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2511; /* *neon_vzipv4hf_insn */

        default:
          return -1;
        }

    case 348:
      switch (pattern328 (x1, 
349))
        {
        case 0:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2512; /* *neon_vuzpv8qi_insn */

        case 1:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2513; /* *neon_vuzpv16qi_insn */

        case 2:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2514; /* *neon_vuzpv4hi_insn */

        case 3:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2515; /* *neon_vuzpv8hi_insn */

        case 4:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2516; /* *neon_vuzpv2si_insn */

        case 5:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2517; /* *neon_vuzpv4si_insn */

        case 6:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2518; /* *neon_vuzpv2sf_insn */

        case 7:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2519; /* *neon_vuzpv4sf_insn */

        case 8:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2520; /* *neon_vuzpv8hf_insn */

        case 9:
          if (!
#line 4978 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2521; /* *neon_vuzpv4hf_insn */

        default:
          return -1;
        }

    case 1033:
      switch (pattern330 (x1, 
PLUS))
        {
        case 0:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4938; /* mve_vidupq_uv16qi_insn */

        case 1:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4940; /* mve_vidupq_uv8hi_insn */

        case 2:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4942; /* mve_vidupq_uv4si_insn */

        default:
          return -1;
        }

    case 1029:
      switch (pattern330 (x1, 
MINUS))
        {
        case 0:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4939; /* mve_vddupq_uv16qi_insn */

        case 1:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4941; /* mve_vddupq_uv8hi_insn */

        case 2:
          if (!
#line 3734 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4943; /* mve_vddupq_uv4si_insn */

        default:
          return -1;
        }

    case 1053:
      if (pattern331 (x1, 
1053) != 0
          || !
#line 3994 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4976; /* mve_vadciq_uv4si */

    case 1055:
      if (pattern331 (x1, 
1055) != 0
          || !
#line 3994 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4977; /* mve_vadciq_sv4si */

    case 1045:
      if (pattern331 (x1, 
1045) != 0
          || !
#line 3994 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4978; /* mve_vsbciq_uv4si */

    case 1046:
      if (pattern331 (x1, 
1046) != 0
          || !
#line 3994 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4979; /* mve_vsbciq_sv4si */

    case 1041:
      if (pattern324 (x1, 
1041, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4984; /* mve_vadcq_uv4si */

    case 1043:
      if (pattern324 (x1, 
1043, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4985; /* mve_vadcq_sv4si */

    case 1049:
      if (pattern324 (x1, 
1049, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4986; /* mve_vsbcq_uv4si */

    case 1050:
      if (pattern324 (x1, 
1050, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4987; /* mve_vsbcq_sv4si */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      operands[3] = x4;
      if (equality_operator (operands[3], E_VOIDmode))
        {
          res = recog_35 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != NE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (XWINT (x6, 0) != 1L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x9, 1);
      if (XWINT (x11, 0) != -1L
          || pattern478 (x1, 
E_CCmode, 
100, 
14) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      if (!
#line 1771 "../../gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1075; /* *doloop_end_internal */

    case GTU:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern298 (x5) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode
          || pattern603 (x1) != 0)
        return -1;
      switch (pattern628 (x1))
        {
        case 0:
          if (!
#line 4677 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5067; /* predicated_doloop_end_internal16 */

        case 1:
          if (!
#line 4677 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5068; /* predicated_doloop_end_internal8 */

        case 2:
          if (!
#line 4677 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5069; /* predicated_doloop_end_internal4 */

        case 3:
          if (!
#line 4677 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5070; /* predicated_doloop_end_internal2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || pattern25 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CLOBBER
      || pattern624 (x1) != 0)
    return -1;
  x6 = XEXP (x4, 0);
  operands[4] = x6;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[5] = x7;
  if (!scratch_operand (operands[5], E_SImode)
      || pattern637 (x1) != 0
      || !
#line 1063 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 973; /* cpymem8b */
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM)
            return -1;
          if (GET_MODE (x5) == E_SImode
              && load_multiple_operation (operands[0], E_VOIDmode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_register_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x4, 1);
                  operands[2] = x7;
                  if (const_int_I_operand (operands[2], E_SImode))
                    {
                      x8 = XEXP (x2, 0);
                      operands[3] = x8;
                      if (s_register_operand (operands[3], E_SImode))
                        {
                          x9 = XEXP (x4, 0);
                          if (rtx_equal_p (x9, operands[1]))
                            {
                              x10 = XEXP (x5, 0);
                              if (rtx_equal_p (x10, operands[1])
                                  && 
#line 11940 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
                                return 386; /* *load_multiple_with_writeback */
                            }
                        }
                    }
                }
            }
          if (GET_MODE (x5) != E_DFmode
              || !pop_multiple_fp (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          if (!vfp_hard_register_operand (operands[3], E_DFmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 12029 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_VFP_BASE))
            return -1;
          return 390; /* *vfp_pop_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x11 = XEXP (x9, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[3])
              || !
#line 993 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 486; /* *ldm2_da */

        case REG:
          operands[1] = x4;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode)
            return -1;
          x13 = XEXP (x6, 0);
          if (GET_CODE (x13) != PLUS
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x13, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[3])
              || !
#line 1018 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 488; /* *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case PLUS:
          x8 = XEXP (x2, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x5, 1);
          operands[2] = x17;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 11971 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 387; /* *pop_multiple_with_writeback_and_return */

        case MEM:
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11994 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 388; /* *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MEM:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != MEM
          || pattern367 (x5) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x10 = XEXP (x9, 1);
          if (XWINT (x10, 0) != 4L)
            return -1;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && 
#line 855 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return 475; /* *ldm2_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !
#line 867 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 476; /* *thumb_ldm2_ia */

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          switch (XWINT (x12, 0))
            {
            case 4L:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != 8L
                  || !
#line 942 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 482; /* *ldm2_ib */

            case -8L:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != -4L
                  || !
#line 1044 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 490; /* *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x4;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (pattern423 (x7) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[3] = x14;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 904 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 479; /* *stm2_ */

        case PLUS:
          if (GET_MODE (x14) != E_SImode)
            return -1;
          x18 = XEXP (x14, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x14, 0);
          operands[3] = x19;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4L:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != 8L
                  || !
#line 968 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 484; /* *stm2_ib */

            case -8L:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != -4L
                  || !
#line 1070 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 492; /* *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (!shift_operator (x4, E_SImode))
    return -1;
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[4] = x9;
  if (!shift_amount_operand (operands[4], E_SImode)
      || !
#line 9802 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  *pnum_clobbers = 1;
  return 333; /* *sub_shiftsi_compare0_scratch */
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[2] = x3;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 2261 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 56; /* *mul */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V4HImode)
              && register_operand (operands[0], E_V4HImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V4HImode)
                  && 
#line 481 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 570; /* *mulv4hi3_iwmmxt */
            }
          if (!s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[0], E_V4HImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V4HImode)
              || !
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1183; /* *mulv4hi3_neon */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V2SImode)
              && register_operand (operands[0], E_V2SImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V2SImode)
                  && 
#line 361 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return 709; /* iwmmxt_wmulwl */
            }
          if (!s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[0], E_V2SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V2SImode)
              || !
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1185; /* *mulv2si3_neon */

        case E_HFmode:
          if (pattern300 (x2, 
E_HFmode) != 0
              || !
#line 1103 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 804; /* mulhf3 */

        case E_SFmode:
          if (pattern300 (x2, 
E_SFmode) != 0
              || !
#line 1113 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 805; /* *mulsf3_vfp */

        case E_DFmode:
          if (pattern300 (x2, 
E_DFmode) != 0
              || !
#line 1123 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 806; /* *muldf3_vfp */

        case E_V8QImode:
          if (pattern300 (x2, 
E_V8QImode) != 0
              || !
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1181; /* *mulv8qi3_neon */

        case E_V16QImode:
          if (pattern300 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1182; /* *mulv16qi3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3672; /* mve_vmulqv16qi */

        case E_V8HImode:
          if (pattern300 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1184; /* *mulv8hi3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3675; /* mve_vmulqv8hi */

        case E_V4SImode:
          if (pattern300 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1186; /* *mulv4si3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3678; /* mve_vmulqv4si */

        case E_V2SFmode:
          if (pattern300 (x2, 
E_V2SFmode) != 0
              || !
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1187; /* *mulv2sf3_neon */

        case E_V4SFmode:
          if (pattern300 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 543 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1188; /* *mulv4sf3_neon */
          if (!
#line 1399 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3833; /* mve_vmulq_fv4sf */

        case E_V8HFmode:
          if (pattern300 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 1635 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1534; /* neon_vmulfv8hf */
          if (!
#line 1399 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3830; /* mve_vmulq_fv8hf */

        case E_V4HFmode:
          if (pattern300 (x2, 
E_V4HFmode) != 0
              || !
#line 1635 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1535; /* neon_vmulfv4hf */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern424 (x2) != 0
                      || GET_MODE (x4) != E_SImode
                      || !s_register_operand (operands[2], E_HImode)
                      || !
#line 2528 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                    return -1;
                  return 73; /* mulhisi3 */

                case E_V8HImode:
                  if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3000; /* neon_vec_smult_v8qi */

                case E_V4SImode:
                  if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3002; /* neon_vec_smult_v4hi */

                case E_V2DImode:
                  if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3004; /* neon_vec_smult_v2si */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || pattern424 (x2) != 0)
                return -1;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2554 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 75; /* *mulhisi3bt */

            default:
              return -1;
            }

        case VEC_SELECT:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != SIGN_EXTEND)
            return -1;
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2976; /* neon_vec_smult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2982; /* neon_vec_smult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2978; /* neon_vec_smult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2984; /* neon_vec_smult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2980; /* neon_vec_smult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2986; /* neon_vec_smult_hi_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern267 (x2, 
16) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_HImode)
              || !
#line 2541 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 74; /* *mulhisi3tb */

        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2568 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 76; /* *mulhisi3tt */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern368 (x2, 
E_HFmode) != 0
              || !
#line 1133 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST && !flag_rounding_math))
            return -1;
          return 807; /* *mulsf3neghf_vfp */

        case E_SFmode:
          if (pattern368 (x2, 
E_SFmode) != 0
              || !
#line 1153 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && !flag_rounding_math))
            return -1;
          return 809; /* *mulsf3negsf_vfp */

        case E_DFmode:
          if (pattern368 (x2, 
E_DFmode) != 0
              || !
#line 1173 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE
  && !flag_rounding_math))
            return -1;
          return 811; /* *muldf3negdf_vfp */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 869; /* *combine_vcvt_f32_u32 */

        case 1:
          if (!
#line 1878 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 871; /* *combine_vcvt_f64_u32 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 870; /* *combine_vcvt_f32_s32 */

        case 1:
          if (!
#line 1878 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 872; /* *combine_vcvt_f64_s32 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2977; /* neon_vec_umult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2983; /* neon_vec_umult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2979; /* neon_vec_umult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2985; /* neon_vec_umult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6355 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2981; /* neon_vec_umult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6389 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2987; /* neon_vec_umult_hi_v4si */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3001; /* neon_vec_umult_v8qi */

            case E_V4SImode:
              if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3003; /* neon_vec_umult_v4hi */

            case E_V2DImode:
              if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 6495 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3005; /* neon_vec_umult_v2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (register_operand (operands[0], E_SImode)
      && 
#line 12292 "../../gcc/config/arm/arm.md"
(TARGET_HARD_TP))
    return 405; /* load_tp_hard */
  if (pnum_clobbers == NULL
      || GET_CODE (x4) != REG
      || REGNO (x4) != 0
      || GET_MODE (x4) != E_SImode)
    return -1;
  if (
#line 12314 "../../gcc/config/arm/arm.md"
(TARGET_SOFT_TP && TARGET_FDPIC))
    {
      *pnum_clobbers = 4;
      return 407; /* load_tp_soft_fdpic */
    }
  if (!
#line 12326 "../../gcc/config/arm/arm.md"
(TARGET_SOFT_TP && !TARGET_FDPIC))
    return -1;
  *pnum_clobbers = 3;
  return 408; /* load_tp_soft */
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_DImode)
          || !
#line 5005 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_LDRD))
        return -1;
      return 157; /* unaligned_loaddi */

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mem_and_no_t1_wback_op (operands[1], E_SImode)
          || !
#line 5016 "../../gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 158; /* unaligned_loadsi */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1870; /* neon_vpaddluv8qi */

    case 1:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1872; /* neon_vpaddluv16qi */

    case 2:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1874; /* neon_vpaddluv4hi */

    case 3:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1876; /* neon_vpaddluv8hi */

    case 4:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1878; /* neon_vpaddluv2si */

    case 5:
      if (!
#line 2756 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1880; /* neon_vpaddluv4si */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1929; /* neon_vcadd270v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1931; /* neon_vcadd270v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3739; /* mve_vcaddq_rot270_fv8hf */

    case 2:
      if (!
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1933; /* neon_vcadd270v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1935; /* neon_vcadd270v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3745; /* mve_vcaddq_rot270_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3563; /* mve_vcaddq_rot270_v16qi */

    case 5:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3567; /* mve_vcaddq_rot270_v8hi */

    case 6:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3571; /* mve_vcaddq_rot270_v4si */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[2], E_V8QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode)
              || !
#line 4671 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2481; /* neon_vtbl1v8qi */

        case E_TImode:
          if (!s_register_operand (operands[1], E_TImode)
              || !
#line 4681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2482; /* neon_vtbl2v8qi */

        case E_EImode:
          if (!s_register_operand (operands[1], E_EImode)
              || !
#line 4702 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2483; /* neon_vtbl3v8qi */

        case E_OImode:
          if (!s_register_operand (operands[1], E_OImode)
              || !
#line 4724 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2484; /* neon_vtbl4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (pattern415 ())
        {
        case 0:
          if (!
#line 4748 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2485; /* neon_vtbl1v16qi */

        case 1:
          if (!
#line 4779 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2486; /* neon_vtbl2v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern165 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V16QImode, 
E_V4x16QImode) != 0
          || !
#line 4128 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x16QImode))))
        return -1;
      return 5002; /* mve_vld4qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HImode, 
E_V4x8HImode) != 0
          || !
#line 4128 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HImode))))
        return -1;
      return 5003; /* mve_vld4qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SImode, 
E_V4x4SImode) != 0
          || !
#line 4128 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SImode))))
        return -1;
      return 5004; /* mve_vld4qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HFmode, 
E_V4x8HFmode) != 0
          || !
#line 4128 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HFmode))))
        return -1;
      return 5005; /* mve_vld4qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SFmode, 
E_V4x4SFmode) != 0
          || !
#line 4128 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SFmode))))
        return -1;
      return 5006; /* mve_vld4qv4sf */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern41 (x3, 
E_HFmode) != 0
          || !
#line 1602 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 852; /* neon_vrsqrtshf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2817 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1913; /* neon_vrsqrtsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2817 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1914; /* neon_vrsqrtsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2828 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1915; /* neon_vrsqrtsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2828 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1916; /* neon_vrsqrtsv4hf */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2339; /* neon_vshrs_nv8qi */

    case 1:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2343; /* neon_vshrs_nv16qi */

    case 2:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2347; /* neon_vshrs_nv4hi */

    case 3:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2351; /* neon_vshrs_nv8hi */

    case 4:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2355; /* neon_vshrs_nv2si */

    case 5:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2359; /* neon_vshrs_nv4si */

    case 6:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2363; /* neon_vshrs_ndi */

    case 7:
      if (!
#line 4520 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2367; /* neon_vshrs_nv2di */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern150 (x1))
    {
    case 0:
      if (!
#line 3777 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2126; /* neon_vcvts_nv2sf */

    case 1:
      if (!
#line 3777 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2128; /* neon_vcvts_nv4sf */

    case 2:
      if (!
#line 3791 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2130; /* neon_vcvts_nv8hf */

    case 3:
      if (!
#line 3791 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2132; /* neon_vcvts_nv4hf */

    case 4:
      if (!
#line 3804 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2134; /* neon_vcvts_nv2si */

    case 5:
      if (!
#line 3804 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2136; /* neon_vcvts_nv4si */

    case 6:
      if (!
#line 3818 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2138; /* neon_vcvts_nv4hi */

    case 7:
      if (!
#line 3818 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2140; /* neon_vcvts_nv8hi */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern160 (x1, 
E_OImode))
    {
    case 0:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2896; /* neon_vld4v8qi */

    case 1:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2897; /* neon_vld4v4hi */

    case 2:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2898; /* neon_vld4v4hf */

    case 3:
      if (!(
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2899; /* neon_vld4v4bf */

    case 4:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2900; /* neon_vld4v2si */

    case 5:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2901; /* neon_vld4v2sf */

    case 6:
      if (!
#line 5971 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2902; /* neon_vld4di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2095 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 920; /* neon_vminnmhf */

    case 1:
      if (!
#line 2106 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
        return -1;
      return 922; /* fminsf3 */

    case 2:
      if (!(
#line 2106 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
        return -1;
      return 924; /* fmindf3 */

    case 3:
      if (!
#line 2725 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1862; /* neon_vminnmv8hf */

    case 4:
      if (!
#line 2725 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1864; /* neon_vminnmv4hf */

    case 5:
      if (!
#line 2736 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1866; /* neon_vminnmv2sf */

    case 6:
      if (!
#line 2736 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1868; /* neon_vminnmv4sf */

    default:
      return -1;
    }
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern146 (x1))
    {
    case 0:
      if (!
#line 2713 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1859; /* neon_vpmaxfv4hf */

    case 1:
      if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1893; /* neon_vpmaxsv8qi */

    case 2:
      if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1897; /* neon_vpmaxsv4hi */

    case 3:
      if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1901; /* neon_vpmaxsv2si */

    case 4:
      if (!
#line 2786 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1905; /* neon_vpmaxfv2sf */

    case 5:
      if (!
#line 2786 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1907; /* neon_vpmaxfv4sf */

    default:
      return -1;
    }
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!
#line 2008 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  *pnum_clobbers = 2;
  return 999; /* thumb1_casesi_dispatch */
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8BFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8BFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8BFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SFmode)
      || !
#line 6690 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
    return -1;
  return 3031; /* neon_vbfcvtv4sf_highv8bf */
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1708; /* neon_vcgtv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1713; /* neon_vcgtv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1728; /* neon_vcgtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1733; /* neon_vcgtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_ccde1_operand (operands[2], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4528 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 139; /* arm_cx1si */

    case 1:
      if (!
#line 4528 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 140; /* arm_cx1di */

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_SImode) != 0
          || !
#line 2238 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 937; /* arm_vcx3si */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_DImode) != 0
          || !
#line 2238 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 938; /* arm_vcx3di */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern482 (x2) != 0
          || !const_int_mve_cde3_operand (operands[4], E_SImode)
          || !
#line 4486 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5049; /* arm_vcx3qv16qi */

    case 3:
      if (!
#line 4513 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5051; /* arm_vcx1q_p_v16qi */

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4082 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2218; /* neon_vmls_lanev4hi */

    case 1:
      if (!
#line 4082 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2219; /* neon_vmls_lanev2si */

    case 2:
      if (!
#line 4082 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2220; /* neon_vmls_lanev2sf */

    case 3:
      if (!
#line 4100 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2221; /* neon_vmls_lanev8hi */

    case 4:
      if (!
#line 4100 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2222; /* neon_vmls_lanev4si */

    case 5:
      if (!
#line 4100 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2223; /* neon_vmls_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 102:
      return recog_243 (x1, insn, pnum_clobbers);

    case 47:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 192; /* arm_qadd8 */

    case 48:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 193; /* arm_qsub8 */

    case 49:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 194; /* arm_shadd8 */

    case 50:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 195; /* arm_shsub8 */

    case 51:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 196; /* arm_uhadd8 */

    case 52:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 197; /* arm_uhsub8 */

    case 53:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 198; /* arm_uqadd8 */

    case 54:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 199; /* arm_uqsub8 */

    case 55:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 200; /* arm_qadd16 */

    case 56:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 201; /* arm_qasx */

    case 57:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 202; /* arm_qsax */

    case 58:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 203; /* arm_qsub16 */

    case 59:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 204; /* arm_shadd16 */

    case 60:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 205; /* arm_shasx */

    case 61:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 206; /* arm_shsax */

    case 62:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 207; /* arm_shsub16 */

    case 63:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 208; /* arm_uhadd16 */

    case 64:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 209; /* arm_uhasx */

    case 65:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 210; /* arm_uhsax */

    case 66:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 211; /* arm_uhsub16 */

    case 67:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 212; /* arm_uqadd16 */

    case 68:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 213; /* arm_uqasx */

    case 69:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 214; /* arm_uqsax */

    case 70:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 215; /* arm_uqsub16 */

    case 71:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 216; /* arm_smusd */

    case 72:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 217; /* arm_smusdx */

    case 43:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 218; /* arm_sxtab16 */

    case 44:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 219; /* arm_uxtab16 */

    case 73:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 220; /* arm_usad8 */

    case 98:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 246; /* arm_smuad_insn */

    case 99:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 248; /* arm_smuadx_insn */

    case 100:
      return recog_242 (x1, insn, pnum_clobbers);

    case 101:
      return recog_241 (x1, insn, pnum_clobbers);

    case 27:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!
#line 6690 "../../gcc/config/arm/arm.md"
(flag_pic))
        return -1;
      return 258; /* pic_load_addr_unified */

    case 42:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 289; /* restore_pic_register_after_call */

    case 3:
      return recog_223 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 429; /* arm_crc32b */

    case 124:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 430; /* arm_crc32h */

    case 125:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 431; /* arm_crc32w */

    case 126:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 432; /* arm_crc32cb */

    case 127:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 433; /* arm_crc32ch */

    case 128:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 434; /* arm_crc32cw */

    case 107:
      if (pattern124 (x1) != 0
          || !
#line 13100 "../../gcc/config/arm/arm.md"
(arm_arch8m_main))
        return -1;
      return 514; /* pac_nop */

    case 462:
      return recog_222 (x1, insn, pnum_clobbers);

    case 463:
      return recog_221 (x1, insn, pnum_clobbers);

    case 13:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 528 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 574; /* iwmmxt_wmacsz */

    case 14:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 549 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 576; /* iwmmxt_wmacuz */

    case 6:
      return recog_240 (x1, insn, pnum_clobbers);

    case 10:
      return recog_186 (x1, insn, pnum_clobbers);

    case 113:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 371 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 710; /* iwmmxt_wqmulm */

    case 112:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 381 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 711; /* iwmmxt_wqmulwm */

    case 111:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 391 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 712; /* iwmmxt_wqmulmr */

    case 110:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 401 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 713; /* iwmmxt_wqmulwmr */

    case 299:
      return recog_158 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 880; /* neon_vcvths_nsi_unspec */

    case 180:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 881; /* neon_vcvthu_nsi_unspec */

    case 219:
      return recog_197 (x1, insn, pnum_clobbers);

    case 222:
      return recog_198 (x1, insn, pnum_clobbers);

    case 104:
      return recog_148 (x1, insn, pnum_clobbers);

    case 21:
      return recog_220 (x1, insn, pnum_clobbers);

    case 121:
      return recog_196 (x1, insn, pnum_clobbers);

    case 122:
      return recog_195 (x1, insn, pnum_clobbers);

    case 250:
      return recog_157 (x1, insn, pnum_clobbers);

    case 258:
      return recog_239 (x1, insn, pnum_clobbers);

    case 257:
      return recog_238 (x1, insn, pnum_clobbers);

    case 260:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1402 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1448; /* neon_vpuminv8qi */

        case 1:
          if (!
#line 1402 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1449; /* neon_vpuminv4hi */

        case 2:
          if (!
#line 1402 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1450; /* neon_vpuminv2si */

        default:
          return -1;
        }

    case 259:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1412 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1451; /* neon_vpumaxv8qi */

        case 1:
          if (!
#line 1412 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1452; /* neon_vpumaxv4hi */

        case 2:
          if (!
#line 1412 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1453; /* neon_vpumaxv2si */

        default:
          return -1;
        }

    case 153:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 1555 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1470; /* neon_vaddv2sf_unspec */

        case 1:
          if (!
#line 1555 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1471; /* neon_vaddv4sf_unspec */

        default:
          return -1;
        }

    case 156:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1472; /* neon_vaddlsv8qi */

        case 1:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1474; /* neon_vaddlsv4hi */

        case 2:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1476; /* neon_vaddlsv2si */

        default:
          return -1;
        }

    case 157:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1473; /* neon_vaddluv8qi */

        case 1:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1475; /* neon_vaddluv4hi */

        case 2:
          if (!
#line 1568 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1477; /* neon_vaddluv2si */

        default:
          return -1;
        }

    case 158:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1478; /* neon_vaddwsv8qi */

        case 1:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1480; /* neon_vaddwsv4hi */

        case 2:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1482; /* neon_vaddwsv2si */

        default:
          return -1;
        }

    case 159:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1479; /* neon_vaddwuv8qi */

        case 1:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1481; /* neon_vaddwuv4hi */

        case 2:
          if (!
#line 1578 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1483; /* neon_vaddwuv2si */

        default:
          return -1;
        }

    case 194:
      return recog_219 (x1, insn, pnum_clobbers);

    case 195:
      return recog_218 (x1, insn, pnum_clobbers);

    case 192:
      return recog_217 (x1, insn, pnum_clobbers);

    case 193:
      return recog_216 (x1, insn, pnum_clobbers);

    case 262:
      return recog_185 (x1, insn, pnum_clobbers);

    case 263:
      return recog_184 (x1, insn, pnum_clobbers);

    case 154:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1524; /* neon_vaddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1526; /* neon_vaddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1528; /* neon_vaddhnv2di */

        default:
          return -1;
        }

    case 155:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1525; /* neon_vraddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1527; /* neon_vraddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1529; /* neon_vraddhnv2di */

        default:
          return -1;
        }

    case 241:
      return recog_183 (x1, insn, pnum_clobbers);

    case 268:
      return recog_237 (x1, insn, pnum_clobbers);

    case 270:
      return recog_236 (x1, insn, pnum_clobbers);

    case 243:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1608; /* neon_vmullsv8qi */

        case 1:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1611; /* neon_vmullsv4hi */

        case 2:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1614; /* neon_vmullsv2si */

        default:
          return -1;
        }

    case 244:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1609; /* neon_vmulluv8qi */

        case 1:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1612; /* neon_vmulluv4hi */

        case 2:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1615; /* neon_vmulluv2si */

        default:
          return -1;
        }

    case 242:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1610; /* neon_vmullpv8qi */

        case 1:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1613; /* neon_vmullpv4hi */

        case 2:
          if (!
#line 2224 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1616; /* neon_vmullpv2si */

        default:
          return -1;
        }

    case 272:
      switch (pattern141 (x1, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2234 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1617; /* neon_vqdmullv4hi */

        case 1:
          if (!
#line 2234 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1618; /* neon_vqdmullv2si */

        default:
          return -1;
        }

    case 336:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1619; /* neon_vsubv2sf_unspec */

        case 1:
          if (!
#line 2260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1620; /* neon_vsubv4sf_unspec */

        default:
          return -1;
        }

    case 339:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1621; /* neon_vsublsv8qi */

        case 1:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1623; /* neon_vsublsv4hi */

        case 2:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1625; /* neon_vsublsv2si */

        default:
          return -1;
        }

    case 340:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1622; /* neon_vsubluv8qi */

        case 1:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1624; /* neon_vsubluv4hi */

        case 2:
          if (!
#line 2273 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1626; /* neon_vsubluv2si */

        default:
          return -1;
        }

    case 341:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1627; /* neon_vsubwsv8qi */

        case 1:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1629; /* neon_vsubwsv4hi */

        case 2:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1631; /* neon_vsubwsv2si */

        default:
          return -1;
        }

    case 342:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1628; /* neon_vsubwuv8qi */

        case 1:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1630; /* neon_vsubwuv4hi */

        case 2:
          if (!
#line 2283 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1632; /* neon_vsubwuv2si */

        default:
          return -1;
        }

    case 291:
      return recog_182 (x1, insn, pnum_clobbers);

    case 292:
      return recog_181 (x1, insn, pnum_clobbers);

    case 196:
      return recog_215 (x1, insn, pnum_clobbers);

    case 197:
      return recog_214 (x1, insn, pnum_clobbers);

    case 337:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1661; /* neon_vsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1663; /* neon_vsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1665; /* neon_vsubhnv2di */

        default:
          return -1;
        }

    case 338:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1662; /* neon_vrsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1664; /* neon_vrsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1666; /* neon_vrsubhnv2di */

        default:
          return -1;
        }

    case 165:
      return recog_235 (x1, insn, pnum_clobbers);

    case 168:
      return recog_233 (x1, insn, pnum_clobbers);

    case 166:
      return recog_234 (x1, insn, pnum_clobbers);

    case 354:
      return recog_232 (x1, insn, pnum_clobbers);

    case 353:
      return recog_231 (x1, insn, pnum_clobbers);

    case 161:
      return recog_230 (x1, insn, pnum_clobbers);

    case 162:
      return recog_229 (x1, insn, pnum_clobbers);

    case 163:
      return recog_228 (x1, insn, pnum_clobbers);

    case 164:
      return recog_227 (x1, insn, pnum_clobbers);

    case 149:
      return recog_213 (x1, insn, pnum_clobbers);

    case 150:
      return recog_212 (x1, insn, pnum_clobbers);

    case 148:
      return recog_180 (x1, insn, pnum_clobbers);

    case 151:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1803; /* neon_vabdlsv8qi */

        case 1:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1805; /* neon_vabdlsv4hi */

        case 2:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1807; /* neon_vabdlsv2si */

        default:
          return -1;
        }

    case 152:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1804; /* neon_vabdluv8qi */

        case 1:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1806; /* neon_vabdluv4hi */

        case 2:
          if (!
#line 2623 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1808; /* neon_vabdluv2si */

        default:
          return -1;
        }

    case 217:
      return recog_156 (x1, insn, pnum_clobbers);

    case 218:
      return recog_211 (x1, insn, pnum_clobbers);

    case 220:
      return recog_155 (x1, insn, pnum_clobbers);

    case 221:
      return recog_209 (x1, insn, pnum_clobbers);

    case 253:
      return recog_210 (x1, insn, pnum_clobbers);

    case 255:
      return recog_208 (x1, insn, pnum_clobbers);

    case 248:
      return recog_207 (x1, insn, pnum_clobbers);

    case 249:
      return recog_206 (x1, insn, pnum_clobbers);

    case 254:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1894; /* neon_vpmaxuv8qi */

        case 1:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1898; /* neon_vpmaxuv4hi */

        case 2:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1902; /* neon_vpmaxuv2si */

        default:
          return -1;
        }

    case 256:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1896; /* neon_vpminuv8qi */

        case 1:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1900; /* neon_vpminuv4hi */

        case 2:
          if (!
#line 2776 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1904; /* neon_vpminuv2si */

        default:
          return -1;
        }

    case 294:
      return recog_179 (x1, insn, pnum_clobbers);

    case 376:
      return recog_142 (x1, insn, pnum_clobbers);

    case 377:
      return recog_141 (x1, insn, pnum_clobbers);

    case 175:
      return recog_178 (x1, insn, pnum_clobbers);

    case 176:
      return recog_177 (x1, insn, pnum_clobbers);

    case 300:
      return recog_176 (x1, insn, pnum_clobbers);

    case 301:
      return recog_175 (x1, insn, pnum_clobbers);

    case 302:
      return recog_174 (x1, insn, pnum_clobbers);

    case 303:
      return recog_173 (x1, insn, pnum_clobbers);

    case 278:
      return recog_172 (x1, insn, pnum_clobbers);

    case 279:
      return recog_171 (x1, insn, pnum_clobbers);

    case 280:
      return recog_170 (x1, insn, pnum_clobbers);

    case 281:
      return recog_169 (x1, insn, pnum_clobbers);

    case 307:
      return recog_168 (x1, insn, pnum_clobbers);

    case 308:
      return recog_167 (x1, insn, pnum_clobbers);

    case 309:
      return recog_166 (x1, insn, pnum_clobbers);

    case 310:
      return recog_165 (x1, insn, pnum_clobbers);

    case 311:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2371; /* neon_vshrn_nv8hi */

        case 1:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2373; /* neon_vshrn_nv4si */

        case 2:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2375; /* neon_vshrn_nv2di */

        default:
          return -1;
        }

    case 312:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2372; /* neon_vrshrn_nv8hi */

        case 1:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2374; /* neon_vrshrn_nv4si */

        case 2:
          if (!
#line 4534 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2376; /* neon_vrshrn_nv2di */

        default:
          return -1;
        }

    case 285:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2377; /* neon_vqshrns_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2381; /* neon_vqshrns_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2385; /* neon_vqshrns_nv2di */

        default:
          return -1;
        }

    case 286:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2378; /* neon_vqshrnu_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2382; /* neon_vqshrnu_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2386; /* neon_vqshrnu_nv2di */

        default:
          return -1;
        }

    case 287:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2379; /* neon_vqrshrns_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2383; /* neon_vqrshrns_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2387; /* neon_vqrshrns_nv2di */

        default:
          return -1;
        }

    case 288:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2380; /* neon_vqrshrnu_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2384; /* neon_vqrshrnu_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2388; /* neon_vqrshrnu_nv2di */

        default:
          return -1;
        }

    case 289:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2389; /* neon_vqshrun_nv8hi */

        case 1:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2391; /* neon_vqshrun_nv4si */

        case 2:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2393; /* neon_vqshrun_nv2di */

        default:
          return -1;
        }

    case 290:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2390; /* neon_vqrshrun_nv8hi */

        case 1:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2392; /* neon_vqrshrun_nv4si */

        case 2:
          if (!
#line 4562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2394; /* neon_vqrshrun_nv2di */

        default:
          return -1;
        }

    case 306:
      return recog_164 (x1, insn, pnum_clobbers);

    case 282:
      return recog_163 (x1, insn, pnum_clobbers);

    case 283:
      return recog_162 (x1, insn, pnum_clobbers);

    case 284:
      return recog_161 (x1, insn, pnum_clobbers);

    case 304:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2427; /* neon_vshlls_nv8qi */

        case 1:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2429; /* neon_vshlls_nv4hi */

        case 2:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2431; /* neon_vshlls_nv2si */

        default:
          return -1;
        }

    case 305:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2428; /* neon_vshllu_nv8qi */

        case 1:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2430; /* neon_vshllu_nv4hi */

        case 2:
          if (!
#line 4614 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2432; /* neon_vshllu_nv2si */

        default:
          return -1;
        }

    case 343:
      return recog_144 (x1, insn, pnum_clobbers);

    case 171:
      if (pattern154 (x1, 
E_V16QImode, 
E_OImode) != 0
          || !
#line 4814 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2487; /* neon_vcombinev16qi */

    case 198:
      return recog_136 (x1, insn, pnum_clobbers);

    case 199:
      return recog_194 (x1, insn, pnum_clobbers);

    case 201:
      return recog_193 (x1, insn, pnum_clobbers);

    case 319:
      return recog_135 (x1, insn, pnum_clobbers);

    case 320:
      return recog_146 (x1, insn, pnum_clobbers);

    case 321:
      return recog_145 (x1, insn, pnum_clobbers);

    case 322:
      return recog_192 (x1, insn, pnum_clobbers);

    case 323:
      return recog_191 (x1, insn, pnum_clobbers);

    case 324:
      return recog_134 (x1, insn, pnum_clobbers);

    case 204:
      return recog_140 (x1, insn, pnum_clobbers);

    case 205:
      return recog_137 (x1, insn, pnum_clobbers);

    case 325:
      return recog_139 (x1, insn, pnum_clobbers);

    case 207:
      return recog_190 (x1, insn, pnum_clobbers);

    case 208:
      return recog_205 (x1, insn, pnum_clobbers);

    case 210:
      return recog_149 (x1, insn, pnum_clobbers);

    case 327:
      return recog_189 (x1, insn, pnum_clobbers);

    case 328:
      return recog_204 (x1, insn, pnum_clobbers);

    case 329:
      return recog_203 (x1, insn, pnum_clobbers);

    case 212:
      return recog_188 (x1, insn, pnum_clobbers);

    case 213:
      return recog_202 (x1, insn, pnum_clobbers);

    case 215:
      return recog_138 (x1, insn, pnum_clobbers);

    case 331:
      return recog_187 (x1, insn, pnum_clobbers);

    case 332:
      return recog_201 (x1, insn, pnum_clobbers);

    case 333:
      return recog_200 (x1, insn, pnum_clobbers);

    case 393:
      return recog_226 (x1, insn, pnum_clobbers);

    case 139:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3056; /* crypto_sha1su1 */

    case 142:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3057; /* crypto_sha256su0 */

    case 144:
      if (pattern127 (x1, 
E_DImode, 
E_TImode) != 0
          || !
#line 262 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3063; /* crypto_vmullp64 */

    case 397:
      return recog_154 (x1, insn, pnum_clobbers);

    case 452:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      switch (pattern112 (x2))
        {
        case 0:
          if (!
#line 496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3360; /* mve_vbrsrq_n_fv8hf */

        case 1:
          if (!
#line 496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3361; /* mve_vbrsrq_n_fv4sf */

        default:
          return -1;
        }

    case 450:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3362; /* mve_vcvtq_n_to_f_sv8hf */

        case 1:
          if (!
#line 512 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3364; /* mve_vcvtq_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 451:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3363; /* mve_vcvtq_n_to_f_uv8hf */

        case 1:
          if (!
#line 512 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3365; /* mve_vcvtq_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 449:
      return recog_160 (x1, insn, pnum_clobbers);

    case 454:
      return recog_225 (x1, insn, pnum_clobbers);

    case 455:
      return recog_224 (x1, insn, pnum_clobbers);

    case 496:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3376; /* mve_vrshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3380; /* mve_vrshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3384; /* mve_vrshrq_n_sv4si */

        default:
          return -1;
        }

    case 533:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3377; /* mve_vrshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3381; /* mve_vrshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3385; /* mve_vrshrq_n_uv4si */

        default:
          return -1;
        }

    case 456:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3378; /* mve_vshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3382; /* mve_vshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3386; /* mve_vshrq_n_sv4si */

        default:
          return -1;
        }

    case 457:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3379; /* mve_vshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3383; /* mve_vshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3387; /* mve_vshrq_n_uv4si */

        default:
          return -1;
        }

    case 458:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3394; /* mve_vcvtq_n_from_f_sv8hi */

        case 1:
          if (!
#line 610 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3396; /* mve_vcvtq_n_from_f_sv4si */

        default:
          return -1;
        }

    case 459:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3395; /* mve_vcvtq_n_from_f_uv8hi */

        case 1:
          if (!
#line 610 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3397; /* mve_vcvtq_n_from_f_uv4si */

        default:
          return -1;
        }

    case 460:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3398; /* mve_vaddlvq_p_sv4si */

    case 461:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3399; /* mve_vaddlvq_p_uv4si */

    case 464:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3448; /* mve_vabdq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3472; /* mve_vabdq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3496; /* mve_vabdq_sv4si */

        default:
          return -1;
        }

    case 501:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3449; /* mve_vabdq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3473; /* mve_vabdq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3497; /* mve_vabdq_uv4si */

        default:
          return -1;
        }

    case 469:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3450; /* mve_vhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3474; /* mve_vhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3498; /* mve_vhaddq_sv4si */

        default:
          return -1;
        }

    case 506:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3451; /* mve_vhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3475; /* mve_vhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3499; /* mve_vhaddq_uv4si */

        default:
          return -1;
        }

    case 471:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3452; /* mve_vhsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3476; /* mve_vhsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3500; /* mve_vhsubq_sv4si */

        default:
          return -1;
        }

    case 508:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3453; /* mve_vhsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3477; /* mve_vhsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3501; /* mve_vhsubq_uv4si */

        default:
          return -1;
        }

    case 478:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3454; /* mve_vmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3478; /* mve_vmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3502; /* mve_vmulhq_sv4si */

        default:
          return -1;
        }

    case 515:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3455; /* mve_vmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3479; /* mve_vmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3503; /* mve_vmulhq_uv4si */

        default:
          return -1;
        }

    case 483:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3456; /* mve_vqaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3480; /* mve_vqaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3504; /* mve_vqaddq_sv4si */

        default:
          return -1;
        }

    case 520:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3457; /* mve_vqaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3481; /* mve_vqaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3505; /* mve_vqaddq_uv4si */

        default:
          return -1;
        }

    case 548:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3458; /* mve_vqdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3482; /* mve_vqdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3506; /* mve_vqdmulhq_sv4si */

        default:
          return -1;
        }

    case 550:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3459; /* mve_vqrdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3483; /* mve_vqrdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3507; /* mve_vqrdmulhq_sv4si */

        default:
          return -1;
        }

    case 485:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3460; /* mve_vqrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3484; /* mve_vqrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3508; /* mve_vqrshlq_sv4si */

        default:
          return -1;
        }

    case 522:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3461; /* mve_vqrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3485; /* mve_vqrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3509; /* mve_vqrshlq_uv4si */

        default:
          return -1;
        }

    case 487:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3462; /* mve_vqshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3486; /* mve_vqshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3510; /* mve_vqshlq_sv4si */

        default:
          return -1;
        }

    case 524:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3463; /* mve_vqshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3487; /* mve_vqshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3511; /* mve_vqshlq_uv4si */

        default:
          return -1;
        }

    case 490:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3464; /* mve_vqsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3488; /* mve_vqsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3512; /* mve_vqsubq_sv4si */

        default:
          return -1;
        }

    case 527:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3465; /* mve_vqsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3489; /* mve_vqsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3513; /* mve_vqsubq_uv4si */

        default:
          return -1;
        }

    case 492:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3466; /* mve_vrhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3490; /* mve_vrhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3514; /* mve_vrhaddq_sv4si */

        default:
          return -1;
        }

    case 529:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3467; /* mve_vrhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3491; /* mve_vrhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3515; /* mve_vrhaddq_uv4si */

        default:
          return -1;
        }

    case 493:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3468; /* mve_vrmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3492; /* mve_vrmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3516; /* mve_vrmulhq_sv4si */

        default:
          return -1;
        }

    case 530:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3469; /* mve_vrmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3493; /* mve_vrmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3517; /* mve_vrmulhq_uv4si */

        default:
          return -1;
        }

    case 494:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3470; /* mve_vrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3494; /* mve_vrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3518; /* mve_vrshlq_sv4si */

        default:
          return -1;
        }

    case 531:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3471; /* mve_vrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3495; /* mve_vrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3519; /* mve_vrshlq_uv4si */

        default:
          return -1;
        }

    case 465:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3520; /* mve_vaddq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3526; /* mve_vaddq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3532; /* mve_vaddq_n_sv4si */

        default:
          return -1;
        }

    case 502:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3521; /* mve_vaddq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3527; /* mve_vaddq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3533; /* mve_vaddq_n_uv4si */

        default:
          return -1;
        }

    case 482:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3522; /* mve_vmulq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3528; /* mve_vmulq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3534; /* mve_vmulq_n_sv4si */

        default:
          return -1;
        }

    case 519:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3523; /* mve_vmulq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3529; /* mve_vmulq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3535; /* mve_vmulq_n_uv4si */

        default:
          return -1;
        }

    case 500:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3524; /* mve_vsubq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3530; /* mve_vsubq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3536; /* mve_vsubq_n_sv4si */

        default:
          return -1;
        }

    case 537:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3525; /* mve_vsubq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3531; /* mve_vsubq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3537; /* mve_vsubq_n_uv4si */

        default:
          return -1;
        }

    case 466:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3538; /* mve_vaddvaq_sv16qi */

        case 1:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3540; /* mve_vaddvaq_sv8hi */

        case 2:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3542; /* mve_vaddvaq_sv4si */

        default:
          return -1;
        }

    case 503:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3539; /* mve_vaddvaq_uv16qi */

        case 1:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3541; /* mve_vaddvaq_uv8hi */

        case 2:
          if (!
#line 723 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3543; /* mve_vaddvaq_uv4si */

        default:
          return -1;
        }

    case 504:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3544; /* mve_vaddvq_p_uv16qi */

        case 1:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3546; /* mve_vaddvq_p_uv8hi */

        case 2:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3548; /* mve_vaddvq_p_uv4si */

        default:
          return -1;
        }

    case 467:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3545; /* mve_vaddvq_p_sv16qi */

        case 1:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3547; /* mve_vaddvq_p_sv8hi */

        case 2:
          if (!
#line 740 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3549; /* mve_vaddvq_p_sv4si */

        default:
          return -1;
        }

    case 505:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3556; /* mve_vbrsrq_n_uv16qi */

        case 1:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3558; /* mve_vbrsrq_n_uv8hi */

        case 2:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3560; /* mve_vbrsrq_n_uv4si */

        default:
          return -1;
        }

    case 468:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3557; /* mve_vbrsrq_n_sv16qi */

        case 1:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3559; /* mve_vbrsrq_n_sv8hi */

        case 2:
          if (!
#line 811 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3561; /* mve_vbrsrq_n_sv4si */

        default:
          return -1;
        }

    case 539:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3564; /* mve_vhcaddq_rot90_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3568; /* mve_vhcaddq_rot90_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3572; /* mve_vhcaddq_rot90_sv4si */

        default:
          return -1;
        }

    case 538:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3565; /* mve_vhcaddq_rot270_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3569; /* mve_vhcaddq_rot270_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3573; /* mve_vhcaddq_rot270_sv4si */

        default:
          return -1;
        }

    case 470:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3577; /* mve_vhaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3587; /* mve_vhaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3597; /* mve_vhaddq_n_sv4si */

        default:
          return -1;
        }

    case 507:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3578; /* mve_vhaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3588; /* mve_vhaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3598; /* mve_vhaddq_n_uv4si */

        default:
          return -1;
        }

    case 472:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3579; /* mve_vhsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3589; /* mve_vhsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3599; /* mve_vhsubq_n_sv4si */

        default:
          return -1;
        }

    case 509:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3580; /* mve_vhsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3590; /* mve_vhsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3600; /* mve_vhsubq_n_uv4si */

        default:
          return -1;
        }

    case 484:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3581; /* mve_vqaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3591; /* mve_vqaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3601; /* mve_vqaddq_n_sv4si */

        default:
          return -1;
        }

    case 521:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3582; /* mve_vqaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3592; /* mve_vqaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3602; /* mve_vqaddq_n_uv4si */

        default:
          return -1;
        }

    case 547:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3583; /* mve_vqdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3593; /* mve_vqdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3603; /* mve_vqdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 549:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3584; /* mve_vqrdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3594; /* mve_vqrdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3604; /* mve_vqrdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 491:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3585; /* mve_vqsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3595; /* mve_vqsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3605; /* mve_vqsubq_n_sv4si */

        default:
          return -1;
        }

    case 528:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3586; /* mve_vqsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3596; /* mve_vqsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3606; /* mve_vqsubq_n_uv4si */

        default:
          return -1;
        }

    case 540:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3607; /* mve_vmaxaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3609; /* mve_vmaxaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3611; /* mve_vmaxaq_sv4si */

        default:
          return -1;
        }

    case 542:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3608; /* mve_vminaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3610; /* mve_vminaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3612; /* mve_vminaq_sv4si */

        default:
          return -1;
        }

    case 541:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3625; /* mve_vmaxavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3631; /* mve_vmaxavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3637; /* mve_vmaxavq_sv4si */

        default:
          return -1;
        }

    case 474:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3626; /* mve_vmaxvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3632; /* mve_vmaxvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3638; /* mve_vmaxvq_sv4si */

        default:
          return -1;
        }

    case 511:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3627; /* mve_vmaxvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3633; /* mve_vmaxvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3639; /* mve_vmaxvq_uv4si */

        default:
          return -1;
        }

    case 543:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3628; /* mve_vminavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3634; /* mve_vminavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3640; /* mve_vminavq_sv4si */

        default:
          return -1;
        }

    case 476:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3629; /* mve_vminvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3635; /* mve_vminvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3641; /* mve_vminvq_sv4si */

        default:
          return -1;
        }

    case 513:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3630; /* mve_vminvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3636; /* mve_vminvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3642; /* mve_vminvq_uv4si */

        default:
          return -1;
        }

    case 477:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3643; /* mve_vmladavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3648; /* mve_vmladavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3653; /* mve_vmladavq_sv4si */

        default:
          return -1;
        }

    case 514:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3644; /* mve_vmladavq_uv16qi */

        case 1:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3649; /* mve_vmladavq_uv8hi */

        case 2:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3654; /* mve_vmladavq_uv4si */

        default:
          return -1;
        }

    case 544:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3645; /* mve_vmladavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3650; /* mve_vmladavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3655; /* mve_vmladavxq_sv4si */

        default:
          return -1;
        }

    case 545:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3646; /* mve_vmlsdavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3651; /* mve_vmlsdavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3656; /* mve_vmlsdavq_sv4si */

        default:
          return -1;
        }

    case 546:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3647; /* mve_vmlsdavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3652; /* mve_vmlsdavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3657; /* mve_vmlsdavxq_sv4si */

        default:
          return -1;
        }

    case 516:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3658; /* mve_vmullbq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3662; /* mve_vmullbq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3666; /* mve_vmullbq_int_uv4si */

        default:
          return -1;
        }

    case 479:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3659; /* mve_vmullbq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3663; /* mve_vmullbq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3667; /* mve_vmullbq_int_sv4si */

        default:
          return -1;
        }

    case 517:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3660; /* mve_vmulltq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3664; /* mve_vmulltq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3668; /* mve_vmulltq_int_uv4si */

        default:
          return -1;
        }

    case 480:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3661; /* mve_vmulltq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3665; /* mve_vmulltq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3669; /* mve_vmulltq_int_sv4si */

        default:
          return -1;
        }

    case 486:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3685; /* mve_vqrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3689; /* mve_vqrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3693; /* mve_vqrshlq_n_sv4si */

        default:
          return -1;
        }

    case 523:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3686; /* mve_vqrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3690; /* mve_vqrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3694; /* mve_vqrshlq_n_uv4si */

        default:
          return -1;
        }

    case 495:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3687; /* mve_vrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3691; /* mve_vrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3695; /* mve_vrshlq_n_sv4si */

        default:
          return -1;
        }

    case 532:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3688; /* mve_vrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3692; /* mve_vrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3696; /* mve_vrshlq_n_uv4si */

        default:
          return -1;
        }

    case 488:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3697; /* mve_vqshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3701; /* mve_vqshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3705; /* mve_vqshlq_n_sv4si */

        default:
          return -1;
        }

    case 525:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3698; /* mve_vqshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3702; /* mve_vqshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3706; /* mve_vqshlq_n_uv4si */

        default:
          return -1;
        }

    case 497:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3699; /* mve_vshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3703; /* mve_vshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3707; /* mve_vshlq_n_sv4si */

        default:
          return -1;
        }

    case 534:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3700; /* mve_vshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3704; /* mve_vshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3708; /* mve_vshlq_n_uv4si */

        default:
          return -1;
        }

    case 489:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3709; /* mve_vqshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3713; /* mve_vqshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3717; /* mve_vqshlq_r_sv4si */

        default:
          return -1;
        }

    case 526:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3710; /* mve_vqshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3714; /* mve_vqshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3718; /* mve_vqshlq_r_uv4si */

        default:
          return -1;
        }

    case 498:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3711; /* mve_vshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3715; /* mve_vshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3719; /* mve_vshlq_r_sv4si */

        default:
          return -1;
        }

    case 535:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3712; /* mve_vshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3716; /* mve_vshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3720; /* mve_vshlq_r_uv4si */

        default:
          return -1;
        }

    case 551:
      return recog_199 (x1, insn, pnum_clobbers);

    case 554:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1127 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3724; /* mve_vabdq_fv8hf */

        case 1:
          if (!
#line 1127 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3725; /* mve_vabdq_fv4sf */

        default:
          return -1;
        }

    case 568:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3726; /* mve_vaddlvaq_sv4si */

    case 567:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3727; /* mve_vaddlvaq_uv4si */

    case 555:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3728; /* mve_vaddq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3731; /* mve_vaddq_n_fv4sf */

        default:
          return -1;
        }

    case 565:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3729; /* mve_vmulq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3732; /* mve_vmulq_n_fv4sf */

        default:
          return -1;
        }

    case 453:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3730; /* mve_vsubq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3733; /* mve_vsubq_n_fv4sf */

        default:
          return -1;
        }

    case 384:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3740; /* mve_vcmulq_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3746; /* mve_vcmulq_fv4sf */

        default:
          return -1;
        }

    case 385:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3741; /* mve_vcmulq_rot90_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3747; /* mve_vcmulq_rot90_fv4sf */

        default:
          return -1;
        }

    case 386:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3742; /* mve_vcmulq_rot180_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3748; /* mve_vcmulq_rot180_fv4sf */

        default:
          return -1;
        }

    case 387:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3743; /* mve_vcmulq_rot270_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3749; /* mve_vcmulq_rot270_fv4sf */

        default:
          return -1;
        }

    case 443:
      return recog_143 (x1, insn, pnum_clobbers);

    case 571:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3778; /* mve_vcvtbq_f16_f32v8hf */

    case 572:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3779; /* mve_vcvttq_f16_f32v8hf */

    case 556:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3782; /* mve_vmaxnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3784; /* mve_vmaxnmaq_fv4sf */

        default:
          return -1;
        }

    case 560:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3783; /* mve_vminnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3785; /* mve_vminnmaq_fv4sf */

        default:
          return -1;
        }

    case 557:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3786; /* mve_vmaxnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3790; /* mve_vmaxnmavq_fv4sf */

        default:
          return -1;
        }

    case 559:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3787; /* mve_vmaxnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3791; /* mve_vmaxnmvq_fv4sf */

        default:
          return -1;
        }

    case 561:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3788; /* mve_vminnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3792; /* mve_vminnmavq_fv4sf */

        default:
          return -1;
        }

    case 563:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3789; /* mve_vminnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3793; /* mve_vminnmvq_fv4sf */

        default:
          return -1;
        }

    case 575:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3798; /* mve_vmlaldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3803; /* mve_vmlaldavq_sv4si */

        default:
          return -1;
        }

    case 573:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3799; /* mve_vmlaldavq_uv8hi */

        case 1:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3804; /* mve_vmlaldavq_uv4si */

        default:
          return -1;
        }

    case 574:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3800; /* mve_vmlaldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3805; /* mve_vmlaldavxq_sv4si */

        default:
          return -1;
        }

    case 576:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3801; /* mve_vmlsldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3806; /* mve_vmlsldavq_sv4si */

        default:
          return -1;
        }

    case 577:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3802; /* mve_vmlsldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3807; /* mve_vmlsldavxq_sv4si */

        default:
          return -1;
        }

    case 579:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3808; /* mve_vmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3818; /* mve_vmovnbq_sv4si */

        default:
          return -1;
        }

    case 578:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3809; /* mve_vmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3819; /* mve_vmovnbq_uv4si */

        default:
          return -1;
        }

    case 581:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3810; /* mve_vmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3820; /* mve_vmovntq_sv4si */

        default:
          return -1;
        }

    case 580:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3811; /* mve_vmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3821; /* mve_vmovntq_uv4si */

        default:
          return -1;
        }

    case 589:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3812; /* mve_vqmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3822; /* mve_vqmovnbq_sv4si */

        default:
          return -1;
        }

    case 588:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3813; /* mve_vqmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3823; /* mve_vqmovnbq_uv4si */

        default:
          return -1;
        }

    case 600:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3814; /* mve_vqmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3824; /* mve_vqmovntq_sv4si */

        default:
          return -1;
        }

    case 599:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3815; /* mve_vqmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3825; /* mve_vqmovntq_uv4si */

        default:
          return -1;
        }

    case 590:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3816; /* mve_vqmovunbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3826; /* mve_vqmovunbq_sv4si */

        default:
          return -1;
        }

    case 591:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3817; /* mve_vqmovuntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3827; /* mve_vqmovuntq_sv4si */

        default:
          return -1;
        }

    case 570:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3838; /* mve_vbicq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3842; /* mve_vbicq_n_sv4si */

        default:
          return -1;
        }

    case 569:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3839; /* mve_vbicq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3843; /* mve_vbicq_n_uv4si */

        default:
          return -1;
        }

    case 582:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3840; /* mve_vorrq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3844; /* mve_vorrq_n_sv4si */

        default:
          return -1;
        }

    case 583:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3841; /* mve_vorrq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3845; /* mve_vorrq_n_uv4si */

        default:
          return -1;
        }

    case 584:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3846; /* mve_vqdmullbq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3848; /* mve_vqdmullbq_n_sv4si */

        default:
          return -1;
        }

    case 586:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3847; /* mve_vqdmulltq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3849; /* mve_vqdmulltq_n_sv4si */

        default:
          return -1;
        }

    case 585:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3850; /* mve_vqdmullbq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3852; /* mve_vqdmullbq_sv4si */

        default:
          return -1;
        }

    case 587:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3851; /* mve_vqdmulltq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3853; /* mve_vqdmulltq_sv4si */

        default:
          return -1;
        }

    case 606:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3854; /* mve_vrmlaldavhq_sv4si */

    case 605:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3855; /* mve_vrmlaldavhq_uv4si */

    case 592:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3856; /* mve_vrmlaldavhxq_sv4si */

    case 593:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3857; /* mve_vrmlsldavhq_sv4si */

    case 594:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3858; /* mve_vrmlsldavhxq_sv4si */

    case 601:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3859; /* mve_vshllbq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3863; /* mve_vshllbq_n_sv8hi */

        default:
          return -1;
        }

    case 602:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3860; /* mve_vshllbq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3864; /* mve_vshllbq_n_uv8hi */

        default:
          return -1;
        }

    case 604:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3861; /* mve_vshlltq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3865; /* mve_vshlltq_n_sv8hi */

        default:
          return -1;
        }

    case 603:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3862; /* mve_vshlltq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3866; /* mve_vshlltq_n_uv8hi */

        default:
          return -1;
        }

    case 608:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3867; /* mve_vmullbq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3869; /* mve_vmullbq_poly_pv8hi */

        default:
          return -1;
        }

    case 607:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3868; /* mve_vmulltq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3870; /* mve_vmulltq_poly_pv8hi */

        default:
          return -1;
        }

    case 1006:
      return recog_153 (x1, insn, pnum_clobbers);

    case 1008:
      return recog_159 (x1, insn, pnum_clobbers);

    case 1013:
      return recog_147 (x1, insn, pnum_clobbers);

    case 1059:
      return recog_152 (x1, insn, pnum_clobbers);

    case 1057:
      return recog_150 (x1, insn, pnum_clobbers);

    case 1058:
      return recog_151 (x1, insn, pnum_clobbers);

    case 1069:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5025; /* mve_uqrshll_sat64_di */

    case 1070:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5026; /* mve_uqrshll_sat48_di */

    case 1071:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5027; /* mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5028; /* mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern193 (x1) != 0
          || !
#line 4298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5029; /* mve_uqrshl_si */

    case 1067:
      if (pattern193 (x1) != 0
          || !
#line 4310 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5030; /* mve_sqrshr_si */

    case 1066:
      if (pattern194 (x1) != 0
          || !
#line 4333 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5032; /* mve_urshrl_di */

    case 1065:
      if (pattern195 (x1, 
E_SImode) != 0
          || !
#line 4356 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5034; /* mve_urshr_si */

    case 1064:
      if (pattern195 (x1, 
E_DImode) != 0
          || !
#line 4379 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5036; /* mve_srshr_si */

    case 1063:
      if (pattern194 (x1) != 0
          || !
#line 4391 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5037; /* mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern377 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3023 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6442; /* *p *arm_andsi3_insn */

            case 1:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 83 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6676; /* *p iwmmxt_anddi3 */

            case 2:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6681; /* *p *andv2si3_iwmmxt */

            case 3:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6682; /* *p *andv4hi3_iwmmxt */

            case 4:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6683; /* *p *andv8qi3_iwmmxt */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x8) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 94 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6677; /* *p iwmmxt_nanddi3 */

        default:
          return -1;
        }

    case NOT:
      switch (pattern374 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3605 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6450; /* *p andsi_notsi_si */

        case 1:
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!shift_amount_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3617 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6451; /* *p andsi_not_shiftsi_si */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != NOT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[2] = x13;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3910 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6456; /* *p *andsi_iorsi3_notsi */

    case MULT:
      if (pattern375 (x1) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6587; /* *p *and_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6592; /* *p *and_shiftsi */

    default:
      return -1;
    }
}

 int
recog_359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (pattern563 (x6, 
MULT, 
E_DImode, 
LSHIFTRT, 
TRUNCATE) != 0)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x7, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_MODE (x14) != E_DImode)
    return -1;
  switch (GET_CODE (x13))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x14) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6419; /* *p smull */

    case ZERO_EXTEND:
      if (GET_CODE (x14) != ZERO_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6420; /* *p umull */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          res = recog_360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != MULT
              || GET_MODE (x4) != E_SImode
              || pattern442 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!low_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1429 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed)))
            return -1;
          return 6993; /* *p *thumb2_mulsi_short */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              res = recog_362 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!low_register_operand (operands[0], E_SImode)
              || pattern442 (x1) != 0
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (x4))
            {
            case PLUS:
              if (!low_reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1301 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6991; /* *p *thumb2_addsi_short */

            case MINUS:
              if (!low_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1330 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6992; /* *p *thumb2_subsi_short */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern381 (x4, 
E_DImode, 
MULT, 
LSHIFTRT, 
E_SImode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x13))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x14) != SIGN_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6423; /* *p *smull_high */

            case ZERO_EXTEND:
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6424; /* *p *umull_high */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern381 (x4, 
E_SImode, 
NOT, 
AND, 
E_CC_NZmode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (!shift_operator (x13, E_SImode))
            return -1;
          operands[0] = x13;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[5] = x5;
          x11 = XEXP (x5, 0);
          operands[6] = x11;
          x16 = XEXP (x13, 0);
          operands[1] = x16;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x13, 1);
          operands[2] = x18;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[3] = x9;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x10))
            {
            case CLOBBER:
              x15 = XEXP (x10, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3637 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6452; /* *p andsi_not_shiftsi_si_scc_no_reuse */

            case SET:
              x19 = XEXP (x10, 1);
              if (pattern382 (x19, 
NOT, 
AND, 
E_SImode) != 0)
                return -1;
              x20 = XEXP (x19, 0);
              x21 = XEXP (x20, 0);
              switch (GET_CODE (x21))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x21, operands[0]))
                    return -1;
                  x15 = XEXP (x10, 0);
                  operands[4] = x15;
                  if (!s_register_operand (operands[4], E_SImode))
                    return -1;
                  x22 = XEXP (x19, 1);
                  if (!rtx_equal_p (x22, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3661 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                    return -1;
                  return 6453; /* *p andsi_not_shiftsi_si_scc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ABS:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6484; /* *p *arm_abssi2 */
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6978; /* *p *thumb2_abssi2 */

        case NEG:
          if (GET_MODE (x4) != E_SImode
              || pattern414 (x1) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case ABS:
              if (GET_MODE (x7) != E_SImode
                  || !s_register_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 0);
              operands[1] = x12;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
                return 6485; /* *p *arm_neg_abssi2 */
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
                return -1;
              return 6979; /* *p *thumb2_neg_abssi2 */

            case REG:
              operands[1] = x7;
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1523 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6995; /* *p *thumb2_negsi2_short */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2)
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x19 = XEXP (x10, 1);
          if (GET_CODE (x19) != UNSPEC
              || XVECLEN (x19, 0) != 1
              || XINT (x19, 1) != 29
              || GET_MODE (x19) != E_CCmode)
            return -1;
          x23 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 105
              || GET_MODE (x23) != E_CCmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 105
              || GET_MODE (x15) != E_CCmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x11 = XEXP (x5, 0);
          operands[4] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          x24 = XVECEXP (x4, 0, 0);
          operands[1] = x24;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XVECEXP (x4, 0, 1);
          operands[2] = x25;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 82:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6536; /* *p arm_sadd8 */

            case 83:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6537; /* *p arm_ssub8 */

            case 84:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6538; /* *p arm_uadd8 */

            case 85:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6539; /* *p arm_usub8 */

            case 86:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6540; /* *p arm_sadd16 */

            case 87:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6541; /* *p arm_sasx */

            case 88:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6542; /* *p arm_ssax */

            case 89:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6543; /* *p arm_ssub16 */

            case 90:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6544; /* *p arm_uadd16 */

            case 91:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6545; /* *p arm_uasx */

            case 92:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6546; /* *p arm_usax */

            case 93:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6547; /* *p arm_usub16 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x4))
            {
            case MEM:
              res = recog_364 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case REG:
            case SUBREG:
              res = recog_367 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              res = recog_368 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!memory_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!memory_operand (operands[3], E_SImode))
            return -1;
          x19 = XEXP (x10, 1);
          operands[1] = x19;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 184 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false))))
            return -1;
          return 6621; /* *p *arm_strd */

        case CONST_INT:
          operands[1] = x4;
          if (pattern414 (x1) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!low_register_operand (operands[0], E_QImode)
                  || !const_int_operand (operands[1], E_QImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6988; /* *p *thumb2_movqi_shortim */

            case E_HImode:
              if (!low_register_operand (operands[0], E_HImode)
                  || !const_int_operand (operands[1], E_HImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6989; /* *p *thumb2_movhi_shortim */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || !const_int_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6990; /* *p *thumb2_movsi_shortim */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
            return -1;
          return 6994; /* *p *thumb2_one_cmplsi2_short */

        default:
          return -1;
        }

    case RETURN:
      x10 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x19 = XEXP (x10, 1);
      if (pattern382 (x19, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 15
          || GET_MODE (x15) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!s_register_operand (operands[0], E_SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12016 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
        return -1;
      return 6598; /* *p *ldr_with_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 54
          || GET_MODE (x3) != E_SImode)
        return -1;
      x26 = XVECEXP (x3, 0, 0);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x2, 0, 1);
      if (pattern474 (x10) != 0)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1699 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse)))
        return -1;
      return 6998; /* *p *clear_apsr */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_4 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  if (XVECLEN (x3, 0) == 3)
    {
      res = peephole2_5 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (XVECLEN (x3, 0) != 2)
    return NULL;
  operands[3] = x2;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[5] = x9;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_25 (insn, operands);
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_23 (insn, operands);
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 8)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[8] = x2;
  x3 = PATTERN (peep2_next_insn (2));
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!const_int_operand (x5, E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = PATTERN (peep2_next_insn (5));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  if (!memory_operand (x8, E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (6));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = PATTERN (peep2_next_insn (7));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  x13 = XEXP (x12, 1);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x13, operands[0]))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      operands[1] = x4;
      operands[9] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      if (!memory_operand (operands[5], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      if (!rtx_equal_p (x17, operands[1]))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[2] = x18;
      if (!s_register_operand (operands[2], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      operands[10] = x19;
      if (!const_int_operand (operands[10], E_SImode))
        return NULL;
      operands[6] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[2]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      operands[11] = x22;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_21 (insn, operands);

    case CONST_INT:
      operands[9] = x13;
      if (!const_int_operand (operands[9], E_SImode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[1] = x14;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      operands[2] = x4;
      operands[10] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      operands[11] = x17;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[4] = x18;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      if (!rtx_equal_p (x19, operands[0]))
        return NULL;
      operands[5] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[1]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[6] = x21;
      if (!memory_operand (operands[6], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      if (!rtx_equal_p (x22, operands[2]))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_22 (insn, operands);

    default:
      return NULL;
    }
}
