/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1 (x3, 
E_SImode); /* [-1, 0] */

    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      return 1;

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode)
        return -1;
      return 2;

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4QQmode:
      if (pattern1 (x3, 
E_V4QQmode) != 0)
        return -1;
      return 5;

    case E_V2HQmode:
      if (pattern1 (x3, 
E_V2HQmode) != 0)
        return -1;
      return 6;

    case E_QQmode:
      if (pattern1 (x3, 
E_QQmode) != 0)
        return -1;
      return 7;

    case E_HQmode:
      if (pattern1 (x3, 
E_HQmode) != 0)
        return -1;
      return 8;

    case E_V2HAmode:
      if (pattern1 (x3, 
E_V2HAmode) != 0)
        return -1;
      return 9;

    case E_HAmode:
      if (pattern1 (x3, 
E_HAmode) != 0)
        return -1;
      return 10;

    case E_SQmode:
      if (pattern1 (x3, 
E_SQmode) != 0)
        return -1;
      return 11;

    case E_SAmode:
      if (pattern1 (x3, 
E_SAmode) != 0)
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PLUS
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x15 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x15) != SET)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PLUS
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 1);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i2))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[3], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern108 (x3); /* [-1, 2] */
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern112 (x3); /* [-1, 1] */
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 13
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 14
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 12
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern38 (x3, 
i1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
i2, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern38 (x3, 
i3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern142 (x3, 
E_V2SFmode, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern142 (x3, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern142 (x3, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern108 (x3); /* [-1, 2] */
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_OImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_XImode))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !mve_imm_32 (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vpr_register_operand (operands[2], E_V4BImode))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_general_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !s_register_operand (operands[1], E_V16QImode)
      || !s_register_operand (operands[2], i2)
      || !mve_imm_8 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return pattern214 (x3); /* [-1, 2] */
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V8BImode, 
E_V8HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern201 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern211 (x3, 
E_V8BImode, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern211 (x3, 
E_V4BImode, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern245 (x1, 
E_QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern245 (x1, 
E_HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern245 (x1, 
E_SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || pattern257 (x1) != 0)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case MULT:
    case ASHIFT:
    case ASHIFTRT:
      if (!sat_shift_operator (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[5] = x7;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 19)
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arm_comparison_operator (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  operands[2] = x1;
  if (!memory_operand (operands[2], E_SImode))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern342 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern342 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern342 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x6, 0, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 4)
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XVECEXP (x3, 0, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x3, 0, 2);
  operands[4] = x11;
  if (!mve_imm_selective_upto_8 (operands[4], E_SImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x13 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  x15 = XVECEXP (x6, 0, 2);
  if (!rtx_equal_p (x15, operands[4]))
    return -1;
  return pattern329 (x3); /* [-1, 2] */
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode)
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern406 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 2)
    return -1;
  return 0;
}

int
pattern415 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern448 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MINUS
      || GET_MODE (x7) != E_SImode
      || pattern447 (x1, 
E_DImode, 
E_CC_Vmode) != 0)
    return -1;
  return 0;
}

int
pattern459 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_struct_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde2_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !s_register_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !s_register_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 4;

        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern545 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern544 (x1) != 0)
    return -1;
  return 0;
}

int
pattern555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_binary_operator (x3, E_SImode))
    return -1;
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[4] = x6;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[3] = x14;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern632 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern631 (x5, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern653 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XEXP (x9, 0);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  x21 = XEXP (x20, 0);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || pattern448 (x1) != 0)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern615 (x1) != 0
          || !
#line 1669 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 27; /* subvsi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern448 (x1) != 0
              || !arm_immediate_operand (operands[1], E_VOIDmode)
              || pattern615 (x1) != 0
              || !
#line 1686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 28; /* subvsi3_imm1 */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern447 (x1, 
E_SImode, 
E_CC_NZmode) != 0
              || !arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2])
              || !
#line 2067 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 46; /* subsi3_compare0 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x7;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x4) != E_CC_NZmode
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x7, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x10, 
MINUS))
            {
            case 0:
              x12 = XEXP (x10, 1);
              x14 = XEXP (x12, 1);
              switch (GET_CODE (x14))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x14, operands[2]))
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[1])
                      || !
#line 9786 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 332; /* *sub_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 9802 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 333; /* *sub_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern477 (x9, 
MINUS) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern418 (x10, 
MINUS) != 0
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_CC_Vmode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x17 = XEXP (x8, 0);
      operands[1] = x17;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arm_borrow_operation (operands[4], E_DImode))
        return -1;
      x18 = XEXP (x9, 0);
      x19 = XEXP (x18, 1);
      operands[3] = x19;
      if (!arm_borrow_operation (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x20 = XEXP (x18, 0);
      x21 = XEXP (x20, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      x22 = XEXP (x13, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x23 = XEXP (x6, 1);
      switch (GET_CODE (x23))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x23) != E_DImode)
            return -1;
          x24 = XEXP (x23, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2185 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 54; /* subvsi3_borrow */

        case CONST_INT:
          operands[2] = x23;
          if (!arm_adcimm_operand (operands[2], E_VOIDmode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2206 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 55; /* subvsi3_borrow_imm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == USE)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == LABEL_REF)
            {
              x6 = XEXP (x2, 1);
              operands[0] = x6;
              if (register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (
#line 2086 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 1004; /* *thumb1_tablejump */
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x6, 0);
  if (GET_CODE (x8) != UNSPEC
      || pattern287 (x1, 
UNSPEC, 
E_CCmode, 
100) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x4, 0) != 1
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 15
      || GET_MODE (x9) != E_SImode)
    return -1;
  switch (XVECLEN (x8, 0))
    {
    case 1:
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x8, 1))
        {
        case 116:
          if (XINT (x4, 1) != 116)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 741; /* iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 742; /* iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 743; /* iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x4, 1) != 117)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 744; /* iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 745; /* iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 746; /* iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x4, 1) != 118)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 747; /* iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 748; /* iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 749; /* iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x8, 1) != 119)
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x4, 1) != 119)
        return -1;
      x11 = XVECEXP (x8, 0, 1);
      operands[0] = x11;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_V2SImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 750; /* iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 751; /* iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 752; /* iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_29 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      return recog_31 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (low_reg_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x3;
          if (shift_operator (operands[3], E_SImode)
              && 
#line 1271 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2]))))
            return 1053; /* *thumb2_shiftsi3_short */
        }
      if (!low_register_operand (operands[2], E_SImode)
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode
          || !
#line 1429 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed))
        return -1;
      return 1061; /* *thumb2_mulsi_short */

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 71; /* *smull_high */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 72; /* *umull_high */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_28 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_SImode)
          || pattern255 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      if (!arm_add_operand (operands[3], E_SImode)
          || !
#line 9952 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 336; /* *compare_scc */

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x6))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[5] = x6;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER
              || pattern450 (x1) != 0
              || pattern575 (x3) != 0
              || !
#line 10767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_32 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 128; /* arm_qadd_setq_insn */

    case SS_MINUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 130; /* arm_qsub_setq_insn */

    case ABS:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x5, 0);
      if (GET_CODE (x12) == REG
          && REGNO (x12) == 100
          && GET_MODE (x12) == E_CCmode)
        {
          if (
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 171; /* *arm_abssi2 */
          if (
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1011; /* *thumb2_abssi2 */
        }
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 334 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 957; /* *thumb1_abssi2 */

    case NEG:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ABS:
          if (GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) == REG
              && REGNO (x12) == 100
              && GET_MODE (x12) == E_CCmode)
            {
              if (
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 172; /* *arm_neg_abssi2 */
              if (
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1012; /* *thumb2_neg_abssi2 */
            }
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 349 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 958; /* *thumb1_neg_abssi2 */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x6;
          if (!arm_comparison_operator (operands[3], E_VOIDmode)
              || pattern385 (x1) != 0)
            return -1;
          if (
#line 10692 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 349; /* *negscc */
          if (!
#line 899 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
            return -1;
          return 1039; /* *thumb2_negscc */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 100
              || GET_MODE (x12) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 315 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 955; /* *thumb1_negdi2 */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !low_register_operand (operands[1], E_SImode)
                  || !
#line 1523 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
                return -1;
              return 1067; /* *thumb2_negsi2_short */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      switch (pattern18 (x2))
        {
        case 0:
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (s_register_operand (operands[1], E_SImode))
            {
              if (
#line 8826 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 292; /* *call_value_reg_armv5 */
                }
              if (
#line 8837 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 293; /* *call_value_reg_arm */
                }
            }
          if (
#line 8877 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[1]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 295; /* *call_value_symbol */
            }
          if (register_operand (operands[1], E_SImode))
            {
              if (
#line 1914 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 994; /* *call_value_reg_thumb1_v5 */
                }
              if (
#line 1940 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 996; /* *call_value_reg_thumb1 */
                }
            }
          if (
#line 1974 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 998; /* *call_value_insn */
            }
          if (!register_operand (operands[1], E_SImode)
              || !
#line 569 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1028; /* *call_value_reg_thumb2 */

        case 1:
          x6 = XEXP (x3, 0);
          x15 = XVECEXP (x6, 0, 0);
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 4
              && GET_MODE (x16) == E_SImode)
            {
              x7 = XEXP (x3, 1);
              operands[1] = x7;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (
#line 1928 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse))
                {
                  *pnum_clobbers = 1;
                  return 995; /* *nonsecure_call_value_reg_thumb1_v5 */
                }
            }
          operands[1] = x16;
          if (register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (
#line 582 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1029; /* *nonsecure_call_value_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 4
              || GET_MODE (x16) != E_SImode)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!
#line 595 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *nonsecure_call_value_reg_thumb2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x3, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11839 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 382; /* *sign_extract_onebit */

    case NOT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x6, 2);
          operands[2] = x18;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11857 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 383; /* *not_signextract_onebit */

        case REG:
          operands[1] = x6;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !low_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1512 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern295 (x5, pnum_clobbers) != 0)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          x19 = XEXP (x5, 1);
          x20 = XVECEXP (x19, 0, 2);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern530 (x1))
            {
            case 0:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3161; /* atomic_nand_fetchqi */

            case 1:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3162; /* atomic_nand_fetchhi */

            case 2:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3163; /* atomic_nand_fetchsi */

            case 3:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3164; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case MEM:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_27 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (memory_operand (operands[2], E_SImode))
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == SET)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x12 = XEXP (x5, 0);
                  operands[1] = x12;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x19 = XEXP (x5, 1);
                      operands[3] = x19;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 164 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true)))
                        return 435; /* *arm_ldrd */
                    }
                }
            }
        }
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 184 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false)))
        return -1;
      return 436; /* *arm_strd */

    case CONST_DOUBLE:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 2142 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))))
            return -1;
          return 927; /* no_literal_pool_df_immediate */

        case 1:
          if (!
#line 2169 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])))
            return -1;
          return 928; /* no_literal_pool_sf_immediate */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 446 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 963; /* thumb1_extendhisi2 */

    case CONST_INT:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!low_register_operand (operands[0], E_QImode)
              || !const_int_operand (operands[1], E_QImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1054; /* *thumb2_movqi_shortim */

        case E_HImode:
          if (!low_register_operand (operands[0], E_HImode)
              || !const_int_operand (operands[1], E_HImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1055; /* *thumb2_movhi_shortim */

        case E_SImode:
          if (!low_register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1056; /* *thumb2_movsi_shortim */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern92 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4912; /* mve_vldrq_gather_shifted_offset_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4913; /* mve_vldrq_gather_shifted_offset_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4914; /* mve_vldrq_gather_shifted_offset_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4915; /* mve_vldrq_gather_shifted_offset_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4916; /* mve_vldrq_gather_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern391 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4825; /* mve_vstrq_p_v16qi */

    case E_V8HImode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4826; /* mve_vstrq_p_v8hi */

    case E_V4SImode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4827; /* mve_vstrq_p_v4si */

    case E_V8HFmode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4828; /* mve_vstrq_p_v8hf */

    case E_V4SFmode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4829; /* mve_vstrq_p_v4sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2465; /* neon_vsri_nv8qi */

    case 1:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2466; /* neon_vsri_nv16qi */

    case 2:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2467; /* neon_vsri_nv4hi */

    case 3:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2468; /* neon_vsri_nv8hi */

    case 4:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2469; /* neon_vsri_nv2si */

    case 5:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2470; /* neon_vsri_nv4si */

    case 6:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2471; /* neon_vsri_ndi */

    case 7:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2472; /* neon_vsri_nv2di */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern44 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2613; /* neon_vld1x4qbv16qi */

    case 1:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2614; /* neon_vld1x4qbv8hi */

    case 2:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2615; /* neon_vld1x4qbv8hf */

    case 3:
      if (!(
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2616; /* neon_vld1x4qbv8bf */

    case 4:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2617; /* neon_vld1x4qbv4si */

    case 5:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2618; /* neon_vld1x4qbv4sf */

    case 6:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2619; /* neon_vld1x4qbv2di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern42 (x1))
    {
    case 0:
      if (!
#line 3954 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2190; /* neon_vqdmulh_lanev8hi */

    case 1:
      if (!
#line 3954 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2192; /* neon_vqdmulh_lanev4si */

    case 2:
      if (!
#line 3968 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2194; /* neon_vqdmulh_lanev4hi */

    case 3:
      if (!
#line 3968 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2196; /* neon_vqdmulh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6680 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3029; /* neon_vbfcvtv4sfv4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6680 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3030; /* neon_vbfcvtv4sfv8bf */

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 6699 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3032; /* neon_vbfcvtsf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !
#line 6708 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3033; /* neon_vbfcvtv4bf */

        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !
#line 6708 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3034; /* neon_vbfcvtv8bf */

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_BFmode)
          || !
#line 6749 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3036; /* neon_vbfcvtbf_cvtmodev2si */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 6749 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3037; /* neon_vbfcvtbf_cvtmodesf */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3355; /* mve_vctp8qv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3356; /* mve_vctp16qv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3357; /* mve_vctp32qv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3358; /* mve_vctp64qv2qi */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2109; /* neon_vcvtuv2sf */

    case 1:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2111; /* neon_vcvtuv4sf */

    case 2:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2113; /* neon_vcvtuv2si */

    case 3:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2115; /* neon_vcvtuv4si */

    case 4:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2119; /* neon_vcvtuv4hi */

    case 5:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2121; /* neon_vcvtuv8hi */

    case 6:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2123; /* neon_vcvtuv8hf */

    case 7:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2125; /* neon_vcvtuv4hf */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 852 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1341; /* neon_vrsqrtev8hf */

    case 1:
      if (!
#line 852 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1342; /* neon_vrsqrtev4hf */

    case 2:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2032; /* neon_vrsqrtev2si */

    case 3:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2033; /* neon_vrsqrtev2sf */

    case 4:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2034; /* neon_vrsqrtev4si */

    case 5:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2035; /* neon_vrsqrtev4sf */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1928; /* neon_vcadd90v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1930; /* neon_vcadd90v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3738; /* mve_vcaddq_rot90_fv8hf */

    case 2:
      if (!
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1932; /* neon_vcadd90v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1934; /* neon_vcadd90v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3744; /* mve_vcaddq_rot90_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3562; /* mve_vcaddq_rot90_v16qi */

    case 5:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3566; /* mve_vcaddq_rot90_v8hi */

    case 6:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3570; /* mve_vcaddq_rot90_v4si */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2716; /* neon_vst1x3qbv8qi */

    case 1:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2717; /* neon_vst1x3qbv16qi */

    case 2:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2718; /* neon_vst1x3qbv4hi */

    case 3:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2719; /* neon_vst1x3qbv8hi */

    case 4:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2720; /* neon_vst1x3qbv2si */

    case 5:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2721; /* neon_vst1x3qbv4si */

    case 6:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2722; /* neon_vst1x3qbv4hf */

    case 7:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2723; /* neon_vst1x3qbv8hf */

    case 8:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2724; /* neon_vst1x3qbv4bf */

    case 9:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2725; /* neon_vst1x3qbv8bf */

    case 10:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2726; /* neon_vst1x3qbv2sf */

    case 11:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2727; /* neon_vst1x3qbv4sf */

    case 12:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2728; /* neon_vst1x3qbdi */

    case 13:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2729; /* neon_vst1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern370 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4841; /* mve_vldrq_z_v16qi */

    case E_V8HImode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4842; /* mve_vldrq_z_v8hi */

    case E_V4SImode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4843; /* mve_vldrq_z_v4si */

    case E_V8HFmode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4844; /* mve_vldrq_z_v8hf */

    case E_V4SFmode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4845; /* mve_vldrq_z_v4sf */

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2403; /* neon_vqshl_s_nv8qi */

    case 1:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2405; /* neon_vqshl_s_nv16qi */

    case 2:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2407; /* neon_vqshl_s_nv4hi */

    case 3:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2409; /* neon_vqshl_s_nv8hi */

    case 4:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2411; /* neon_vqshl_s_nv2si */

    case 5:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2413; /* neon_vqshl_s_nv4si */

    case 6:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2415; /* neon_vqshl_s_ndi */

    case 7:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2417; /* neon_vqshl_s_nv2di */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2307; /* neon_vqshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2311; /* neon_vqshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2315; /* neon_vqshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2319; /* neon_vqshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2323; /* neon_vqshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2327; /* neon_vqshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2331; /* neon_vqshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2335; /* neon_vqshlsv2di */

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1633; /* neon_vqsubsv8qi */

    case 1:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1635; /* neon_vqsubsv16qi */

    case 2:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1637; /* neon_vqsubsv4hi */

    case 3:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1639; /* neon_vqsubsv8hi */

    case 4:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1641; /* neon_vqsubsv2si */

    case 5:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1643; /* neon_vqsubsv4si */

    case 6:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1645; /* neon_vqsubsdi */

    case 7:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1647; /* neon_vqsubsv2di */

    default:
      return -1;
    }
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2606; /* neon_vld1x4qav16qi */

    case 1:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2607; /* neon_vld1x4qav8hi */

    case 2:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2608; /* neon_vld1x4qav8hf */

    case 3:
      if (!(
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2609; /* neon_vld1x4qav8bf */

    case 4:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2610; /* neon_vld1x4qav4si */

    case 5:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2611; /* neon_vld1x4qav4sf */

    case 6:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2612; /* neon_vld1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2879; /* neon_vst3qbv16qi */

    case 1:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2880; /* neon_vst3qbv8hi */

    case 2:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2881; /* neon_vst3qbv8hf */

    case 3:
      if (!(
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2882; /* neon_vst3qbv8bf */

    case 4:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2883; /* neon_vst3qbv4si */

    case 5:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2884; /* neon_vst3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1787; /* neon_vabdsv8qi */

    case 1:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1789; /* neon_vabdsv16qi */

    case 2:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1791; /* neon_vabdsv4hi */

    case 3:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1793; /* neon_vabdsv8hi */

    case 4:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1795; /* neon_vabdsv2si */

    case 5:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1797; /* neon_vabdsv4si */

    default:
      return -1;
    }
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 385; /* stack_tie */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1758; /* neon_vcagtv2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1762; /* neon_vcagtv4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1774; /* neon_vcagtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1778; /* neon_vcagtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1440; /* neon_vpsminv8qi */

    case 1:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1441; /* neon_vpsminv4hi */

    case 2:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1442; /* neon_vpsminv2si */

    case 3:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1443; /* neon_vpsminv2sf */

    default:
      return -1;
    }
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern91 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 3);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3521 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4903; /* mve_vstrq_scatter_base_p_v4si */

        case 1:
          if (!
#line 3521 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4904; /* mve_vstrq_scatter_base_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3521 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4905; /* mve_vstrq_scatter_base_p_v2di */

    default:
      return -1;
    }
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern481 (x2, 
E_SImode) != 0
          || !
#line 2226 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 935; /* arm_vcx2asi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern481 (x2, 
E_DImode) != 0
          || !
#line 2226 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 936; /* arm_vcx2adi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern482 (x2) != 0
          || !const_int_mve_cde2_operand (operands[4], E_SImode)
          || !
#line 4473 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5048; /* arm_vcx2qav16qi */

    case 3:
      if (!
#line 4513 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5052; /* arm_vcx1qa_p_v16qi */

    default:
      return -1;
    }
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 3984 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2198; /* neon_vqrdmlah_lanev8hi */

    case 1:
      if (!
#line 3984 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2200; /* neon_vqrdmlah_lanev4si */

    case 2:
      if (!
#line 4000 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2202; /* neon_vqrdmlah_lanev4hi */

    case 3:
      if (!
#line 4000 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2204; /* neon_vqrdmlah_lanev2si */

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL)
    {
      res = recog_267 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!equality_operator (x3, E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) == LABEL_REF)
    {
      res = recog_268 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  x5 = XEXP (x3, 0);
  if (!arm_comparison_operator (x5, E_VOIDmode))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[5] = x9;
  if (!cc_register (operands[5], E_VOIDmode))
    return -1;
  operands[1] = x4;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  if (
#line 10074 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
    return 337; /* *cond_move */
  if (!
#line 706 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1035; /* *thumb2_cond_move */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[6] = x3;
  x6 = XEXP (x3, 1);
  if (!arm_add_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      operands[7] = x7;
      if (!shiftable_operator (operands[7], E_SImode))
        return -1;
      operands[2] = x4;
      operands[3] = x6;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[5] = x9;
      if (!arm_rhs_operand (operands[5], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!arm_rhs_operand (operands[1], E_SImode)
          || !
#line 10996 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 358; /* *ifcompare_arith_move */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!arm_rhs_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      if (!shiftable_operator (x10, E_SImode))
        return -1;
      operands[7] = x10;
      operands[4] = x4;
      operands[5] = x6;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !
#line 11061 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 360; /* *ifcompare_move_arith */

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  if (!cc_register (operands[4], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!arm_not_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  if (!arm_not_operand (operands[2], E_SImode)
      || !
#line 442 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1023; /* *thumb2_movsicc_insn */
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (s_register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && s_register_operand (operands[1], E_SImode))
            {
              switch (XWINT (x4, 0))
                {
                case 0L:
                  if (
#line 4067 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 117; /* *smax_0 */
                  break;

                case -1L:
                  if (
#line 4077 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 118; /* *smax_m1 */
                  break;

                default:
                  break;
                }
            }
          break;

        case REG:
        case SUBREG:
          switch (pattern348 (x2))
            {
            case 0:
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 903 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 603; /* *smaxv2si3_iwmmxt */
              if (s_register_operand (operands[0], E_V2SImode)
                  && s_register_operand (operands[1], E_V2SImode)
                  && s_register_operand (operands[2], E_V2SImode)
                  && 
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1367; /* *smaxv2si3_neon */
              break;

            case 1:
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 903 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 604; /* *smaxv4hi3_iwmmxt */
              if (s_register_operand (operands[0], E_V4HImode)
                  && s_register_operand (operands[1], E_V4HImode)
                  && s_register_operand (operands[2], E_V4HImode)
                  && 
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1365; /* *smaxv4hi3_neon */
              break;

            case 2:
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 903 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 605; /* *smaxv8qi3_iwmmxt */
              if (s_register_operand (operands[0], E_V8QImode)
                  && s_register_operand (operands[1], E_V8QImode)
                  && s_register_operand (operands[2], E_V8QImode)
                  && 
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1363; /* *smaxv8qi3_neon */
              break;

            case 3:
              if (
#line 2070 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 915; /* smaxsf3 */
              break;

            case 4:
              if ((
#line 2070 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 916; /* smaxdf3 */
              break;

            case 5:
              if (
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1364; /* *smaxv16qi3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3613; /* mve_vmaxq_sv16qi */
              break;

            case 6:
              if (
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1366; /* *smaxv8hi3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3617; /* mve_vmaxq_sv8hi */
              break;

            case 7:
              if (
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1368; /* *smaxv4si3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3621; /* mve_vmaxq_sv4si */
              break;

            case 8:
              if (
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1369; /* *smaxv2sf3_neon */
              break;

            case 9:
              if (
#line 891 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1370; /* *smaxv4sf3_neon */
              if (
#line 1341 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3796; /* mve_vmaxnmq_fv4sf */
              break;

            case 10:
              if (
#line 1341 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3794; /* mve_vmaxnmq_fv8hf */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || pattern349 (x2) != 0
          || !
#line 4088 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *arm_smax_insn */

    case SMIN:
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 4477 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL)))
            return -1;
          return 135; /* satsi_smax */

        case 1:
          if (!
#line 4503 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL)))
            return -1;
          return 138; /* *satsi_smax_shift */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1418; /* quad_halves_smaxv4si */

        case 1:
          if (!
#line 1142 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1423; /* quad_halves_smaxv4sf */

        case 2:
          if (!
#line 1157 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1426; /* quad_halves_smaxv8hi */

        case 3:
          if (!
#line 1176 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1431; /* quad_halves_smaxv16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          operands[3] = x4;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2292 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
            return -1;
          return 58; /* *mls */

        case E_HFmode:
          if (pattern433 (x2, 
E_HFmode) != 0
              || !
#line 1268 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 819; /* *mulhf3neghfaddhf_vfp */

        case E_SFmode:
          if (pattern433 (x2, 
E_SFmode) != 0
              || !
#line 1279 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 820; /* *mulsf3negsfaddsf_vfp */

        case E_DFmode:
          if (pattern433 (x2, 
E_DFmode) != 0
              || !
#line 1290 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 821; /* *fmuldf3negdfadddf_vfp */

        case E_V8QImode:
          if (pattern433 (x2, 
E_V8QImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1199; /* mulv8qi3negv8qiaddv8qi_neon */

        case E_V16QImode:
          if (pattern433 (x2, 
E_V16QImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return -1;
          return 1200; /* mulv16qi3negv16qiaddv16qi_neon */

        case E_V4HImode:
          if (pattern433 (x2, 
E_V4HImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1201; /* mulv4hi3negv4hiaddv4hi_neon */

        case E_V8HImode:
          if (pattern433 (x2, 
E_V8HImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return -1;
          return 1202; /* mulv8hi3negv8hiaddv8hi_neon */

        case E_V2SImode:
          if (pattern433 (x2, 
E_V2SImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1203; /* mulv2si3negv2siaddv2si_neon */

        case E_V4SImode:
          if (pattern433 (x2, 
E_V4SImode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return -1;
          return 1204; /* mulv4si3negv4siaddv4si_neon */

        case E_V2SFmode:
          if (pattern433 (x2, 
E_V2SFmode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1205; /* mulv2sf3negv2sfaddv2sf_neon */

        case E_V4SFmode:
          if (pattern433 (x2, 
E_V4SFmode) != 0
              || !
#line 611 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1206; /* mulv4sf3negv4sfaddv4sf_neon */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || pattern467 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (pattern581 (x7) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern620 (x3))
        {
        case 0:
          if (!
#line 794 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 736; /* iwmmxt_wmiawbbn */

        case 1:
          if (!
#line 807 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 737; /* iwmmxt_wmiawbtn */

        case 2:
          if (!
#line 820 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 738; /* iwmmxt_wmiawtbn */

        case 3:
          if (!
#line 833 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 739; /* iwmmxt_wmiawttn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[2] = x5;
              if (!s_register_operand (operands[2], E_SImode)
                  || !reg_or_int_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (!arm_borrow_operation (operands[3], E_SImode)
                  || !
#line 1697 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 29; /* subsi3_carryin */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[2] = x5;
              if (!shift_operator (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              operands[3] = x7;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              if (!shift_amount_operand (operands[4], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !
#line 1831 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 41; /* *subsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              if (!shift_operator (x6, E_SImode))
                return -1;
              operands[2] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x10 = XEXP (x6, 1);
              operands[4] = x10;
              if (!shift_amount_operand (operands[4], E_SImode)
                  || !
#line 1848 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 42; /* *subsi3_carryin_shift_alt */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x4;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          operands[4] = x12;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !
#line 1866 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 43; /* *rsbsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 1881 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 44; /* *rsbsi3_carryin_shift_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[1] = x3;
      if (!arm_carry_operation (operands[1], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1714 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 30; /* rsbsi_carryin_reg */

    case PLUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!arm_neg_immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!arm_borrow_operation (operands[3], E_SImode)
          || !
#line 1807 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 39; /* *subsi3_carryin_const */

    case CONST_INT:
    case REG:
    case SUBREG:
      return recog_286 (x1, insn, pnum_clobbers);

    case NEG:
      if (pattern244 (x2, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!arm_borrow_operation (operands[2], E_SImode)
          || !
#line 5211 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 170; /* negsi2_carryin */

    case MULT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_CODE (operands[3]))
            {
            case CONST_INT:
              if (!power_of_two_operand (operands[3], E_SImode)
                  || pattern397 (x2, 
E_SImode) != 0
                  || !
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 320; /* *rsb_multsi */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_HFmode:
                  if (pattern468 (x2, 
E_HFmode) != 0
                      || !
#line 1234 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                    return -1;
                  return 816; /* *mulhf3subhf_vfp */

                case E_SFmode:
                  if (pattern468 (x2, 
E_SFmode) != 0
                      || !
#line 1245 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                    return -1;
                  return 817; /* *mulsf3subsf_vfp */

                case E_DFmode:
                  if (pattern468 (x2, 
E_DFmode) != 0
                      || !
#line 1256 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                    return -1;
                  return 818; /* *muldf3subdf_vfp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern303 (x3, 
2, 
0) != 0)
            return -1;
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 1);
          x13 = XVECEXP (x8, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x8, 0, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x6 = XEXP (x2, 1);
          if (pattern580 (x6, 
E_V2SImode, 
VEC_SELECT, 
MULT) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          x15 = XEXP (x9, 1);
          if (pattern604 (x15, 
3, 
2) != 0)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != VEC_SELECT
              || GET_MODE (x10) != E_V2SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_CODE (x16) != PARALLEL
              || XVECLEN (x16, 0) != 2)
            return -1;
          x17 = XVECEXP (x16, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x18 = XVECEXP (x16, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          switch (pattern630 (x2))
            {
            case 0:
              if (pattern644 (x2, 
SIGN_EXTEND) != 0
                  || !
#line 232 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 701; /* iwmmxt_wmaddsn */

            case 1:
              if (pattern644 (x2, 
ZERO_EXTEND) != 0
                  || !
#line 251 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 702; /* iwmmxt_wmaddun */

            default:
              return -1;
            }

        case NEG:
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern434 (x2, 
E_HFmode) != 0
                  || !
#line 1304 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 822; /* *mulhf3neghfsubhf_vfp */

            case E_SFmode:
              if (pattern434 (x2, 
E_SFmode) != 0
                  || !
#line 1316 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 823; /* *mulsf3negsfsubsf_vfp */

            case E_DFmode:
              if (pattern434 (x2, 
E_DFmode) != 0
                  || !
#line 1328 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 824; /* *muldf3negdfsubdf_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 325; /* *rsb_shiftsi */

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (!shiftable_operator (x2, E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[5] = x3;
      if (!minmax_operator (operands[5], E_SImode))
        return -1;
      operands[4] = x2;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 4256 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && !arm_restrict_it))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *minmax_arithsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x3;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      operands[5] = x2;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 10110 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 338; /* *cond_arith */

    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x2;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!memory_operand (operands[3], E_SImode)
          || !
#line 11472 "../../gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3])))
        return -1;
      *pnum_clobbers = 1;
      return 380; /* *arith_adjacentmem */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (!s_register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x4;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      operands[5] = x2;
      if (!shiftable_operator (operands[5], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      operands[1] = x3;
      if (!
#line 756 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
        return -1;
      *pnum_clobbers = 1;
      return 1036; /* *thumb2_cond_arith */

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      operands[3] = x2;
      if (!thumb_16bit_operator (operands[3], E_SImode))
        return -1;
      operands[2] = x3;
      if (!
#line 1256 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS))
        return -1;
      *pnum_clobbers = 1;
      return 1052; /* *thumb2_alusi3_short */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  if (register_operand (operands[0], E_SImode))
    {
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 736 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 589; /* iwmmxt_textrmsb */
          break;

        case E_HImode:
          if (register_operand (operands[1], E_V4HImode)
              && 
#line 758 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 591; /* iwmmxt_textrmsh */
          break;

        default:
          break;
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  switch (pattern469 (x3))
    {
    case 0:
      if (!
#line 3222 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2036; /* neon_vget_lanev8qi_sext_internal */

    case 1:
      if (
#line 3260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2044; /* neon_vget_lanev16qi_sext_internal */
      if (!
#line 4194 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))))
        return -1;
      return 5013; /* *mve_vec_extract_sext_internalv16qi */

    case 2:
      if (!
#line 3222 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2037; /* neon_vget_lanev4hi_sext_internal */

    case 3:
      if (
#line 3260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2045; /* neon_vget_lanev8hi_sext_internal */
      if (!
#line 4194 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 5014; /* *mve_vec_extract_sext_internalv8hi */

    case 4:
      if (!
#line 3222 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2038; /* neon_vget_lanev2si_sext_internal */

    case 5:
      if (
#line 3260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2047; /* neon_vget_lanev4si_sext_internal */
      if (!
#line 4194 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
        return -1;
      return 5015; /* *mve_vec_extract_sext_internalv4si */

    case 6:
      if (!
#line 3222 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2039; /* neon_vget_lanev2sf_sext_internal */

    case 7:
      if (!
#line 3260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2048; /* neon_vget_lanev4sf_sext_internal */

    case 8:
      if (!
#line 3260 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2046; /* neon_vget_lanev8hf_sext_internal */

    default:
      return -1;
    }
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 8:
      if (pattern283 (x2, 
E_V8QImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 4);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x2, 0, 5);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 6);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x2, 0, 7);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !s_register_operand (operands[0], E_V8QImode)
          || !
#line 574 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 578; /* iwmmxt_clrv8qi */

    case 4:
      if (pattern283 (x2, 
E_V4HImode) != 0
          || !s_register_operand (operands[0], E_V4HImode)
          || !
#line 584 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 579; /* iwmmxt_clrv4hi */

    case 2:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2SImode)
          || !
#line 593 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 580; /* iwmmxt_clrv2si */

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern345 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (pattern455 (x3, pnum_clobbers) != 0
                      || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 71; /* *smull_high */

                case 1:
                  if (!
#line 494 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 571; /* smulv4hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern345 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern455 (x3, pnum_clobbers) != 0
                          || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 72; /* *umull_high */

                    case E_V2SImode:
                      if (pattern344 (x3, 
E_V2SImode, 
E_V2DImode) != 0
                          || !
#line 279 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                        return -1;
                      return 704; /* iwmmxt_wmulwum */

                    default:
                      return -1;
                    }

                case 1:
                  if (!
#line 507 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 572; /* umulv4hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XWINT (x5, 0) != 1L)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 0);
              operands[2] = x12;
              switch (XVECLEN (x10, 0))
                {
                case 8:
                  if (pattern532 (x10, 
1) != 0
                      || pattern498 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 617 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 581; /* iwmmxt_uavgrndv8qi3 */

                case 4:
                  if (GET_MODE (x10) != E_V4SImode)
                    return -1;
                  x13 = XVECEXP (x10, 0, 0);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x14 = XVECEXP (x10, 0, 1);
                  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x15 = XVECEXP (x10, 0, 2);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x16 = XVECEXP (x10, 0, 3);
                  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 635 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 582; /* iwmmxt_uavgrndv4hi3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != ZERO_EXTEND
                  || XWINT (x5, 0) != 1L)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x17 = XEXP (x10, 0);
              operands[2] = x17;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern344 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 648 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 583; /* iwmmxt_uavgv8qi3 */

                case E_V4HImode:
                  if (pattern344 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 661 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 584; /* iwmmxt_uavgv4hi3 */

                default:
                  return -1;
                }

            case MULT:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 0);
              operands[2] = x12;
              switch (XVECLEN (x10, 0))
                {
                case 4:
                  if (pattern497 (x10) != 0)
                    return -1;
                  x16 = XVECEXP (x10, 0, 3);
                  if (GET_CODE (x16) != CONST_INT
                      || XWINT (x16, 0) != 32768L
                      || XWINT (x5, 0) != 16L
                      || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 316 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 706; /* iwmmxt_wmulumr */

                case 2:
                  if (pattern499 (x3) != 0
                      || !
#line 350 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                    return -1;
                  return 708; /* iwmmxt_wmulwumr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MINUS)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x17 = XEXP (x10, 0);
      operands[2] = x17;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern344 (x3, 
E_V8QImode, 
E_V8HImode) != 0
              || !
#line 37 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 690; /* iwmmxt_wabsdiffb */

        case E_V4HImode:
          if (pattern344 (x3, 
E_V4HImode, 
E_V4SImode) != 0
              || !
#line 50 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 691; /* iwmmxt_wabsdiffh */

        case E_V2SImode:
          if (pattern344 (x3, 
E_V2SImode, 
E_V2DImode) != 0
              || !
#line 63 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 692; /* iwmmxt_wabsdiffw */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V8HImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_MERGE
          || GET_MODE (x6) != E_V8HImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || GET_MODE (x7) != E_V8HImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_V8HImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_V8HImode)
        return -1;
      x18 = XEXP (x11, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_V8HImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != E_V8HImode)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != ZERO_EXTEND
          || GET_MODE (x20) != E_V8HImode)
        return -1;
      x21 = XEXP (x19, 1);
      if (GET_CODE (x21) != ZERO_EXTEND
          || GET_MODE (x21) != E_V8HImode)
        return -1;
      x22 = XEXP (x18, 1);
      if (GET_CODE (x22) != VEC_SELECT
          || GET_MODE (x22) != E_V8HImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_V8HImode)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != PARALLEL
          || XVECLEN (x24, 0) != 8)
        return -1;
      x25 = XVECEXP (x24, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x26 = XVECEXP (x24, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x27 = XVECEXP (x24, 0, 2);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x24, 0, 3);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x24, 0, 4);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x30 = XVECEXP (x24, 0, 5);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x31 = XVECEXP (x24, 0, 6);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x32 = XVECEXP (x24, 0, 7);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x33 = XEXP (x11, 1);
      if (GET_CODE (x33) != VEC_SELECT
          || GET_MODE (x33) != E_V8HImode)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != ZERO_EXTEND
          || GET_MODE (x34) != E_V8HImode)
        return -1;
      x35 = XEXP (x33, 1);
      if (GET_CODE (x35) != PARALLEL
          || XVECLEN (x35, 0) != 8)
        return -1;
      x36 = XVECEXP (x35, 0, 0);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x37 = XVECEXP (x35, 0, 1);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x38 = XVECEXP (x35, 0, 2);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x39 = XVECEXP (x35, 0, 3);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x40 = XVECEXP (x35, 0, 4);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x41 = XVECEXP (x35, 0, 5);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x42 = XVECEXP (x35, 0, 6);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x43 = XVECEXP (x35, 0, 7);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x44 = XEXP (x8, 1);
      if (GET_CODE (x44) != CONST_VECTOR
          || XVECLEN (x44, 0) != 8
          || GET_MODE (x44) != E_V8HImode)
        return -1;
      x45 = XVECEXP (x44, 0, 0);
      if (GET_CODE (x45) != CONST_INT)
        return -1;
      x46 = XVECEXP (x44, 0, 1);
      if (GET_CODE (x46) != CONST_INT)
        return -1;
      x47 = XVECEXP (x44, 0, 2);
      if (GET_CODE (x47) != CONST_INT)
        return -1;
      x48 = XVECEXP (x44, 0, 3);
      if (GET_CODE (x48) != CONST_INT)
        return -1;
      x49 = XVECEXP (x44, 0, 4);
      if (GET_CODE (x49) != CONST_INT)
        return -1;
      x50 = XVECEXP (x44, 0, 5);
      if (GET_CODE (x50) != CONST_INT)
        return -1;
      x51 = XVECEXP (x44, 0, 6);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x44, 0, 7);
      if (GET_CODE (x52) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != CONST_VECTOR
          || XVECLEN (x10, 0) != 8
          || pattern532 (x10, 
0) != 0)
        return -1;
      x53 = XEXP (x6, 2);
      if (GET_CODE (x53) != CONST_INT
          || XWINT (x53, 0) != 254L)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 8)
        return -1;
      x54 = XVECEXP (x5, 0, 0);
      if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x55 = XVECEXP (x5, 0, 1);
      if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x56 = XVECEXP (x5, 0, 2);
      if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x57 = XVECEXP (x5, 0, 3);
      if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x58 = XVECEXP (x5, 0, 4);
      if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x59 = XVECEXP (x5, 0, 5);
      if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x60 = XVECEXP (x5, 0, 6);
      if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x61 = XVECEXP (x5, 0, 7);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x62 = XEXP (x20, 0);
      operands[1] = x62;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x63 = XEXP (x21, 0);
      operands[2] = x63;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      x64 = XEXP (x23, 0);
      if (!rtx_equal_p (x64, operands[1]))
        return -1;
      x65 = XEXP (x34, 0);
      if (!rtx_equal_p (x65, operands[2]))
        return -1;
      switch (XWINT (x45, 0))
        {
        case 1L:
          if (XWINT (x46, 0) != 1L
              || XWINT (x47, 0) != 1L
              || XWINT (x48, 0) != 1L
              || XWINT (x49, 0) != 1L
              || XWINT (x50, 0) != 1L
              || XWINT (x51, 0) != 1L
              || XWINT (x52, 0) != 1L
              || !
#line 143 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 697; /* iwmmxt_avg4 */

        case 2L:
          if (XWINT (x46, 0) != 2L
              || XWINT (x47, 0) != 2L
              || XWINT (x48, 0) != 2L
              || XWINT (x49, 0) != 2L
              || XWINT (x50, 0) != 2L
              || XWINT (x51, 0) != 2L
              || XWINT (x52, 0) != 2L
              || !
#line 175 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 698; /* iwmmxt_avg4r */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (GET_MODE (x6) != E_V2DImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SIGN_EXTEND
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_V2DImode
              || XWINT (x5, 0) != 32L
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2DImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          x17 = XEXP (x10, 0);
          operands[2] = x17;
          if (!register_operand (operands[2], E_V2SImode)
              || !
#line 265 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 703; /* iwmmxt_wmulwsm */

        case PLUS:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MULT)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          x10 = XEXP (x6, 1);
          if (GET_CODE (x10) != CONST_VECTOR)
            return -1;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          switch (XVECLEN (x10, 0))
            {
            case 3:
              if (pattern497 (x10) != 0
                  || XWINT (x5, 0) != 16L
                  || pattern498 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 297 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 705; /* iwmmxt_wmulsmr */

            case 2:
              if (pattern499 (x3) != 0
                  || !
#line 333 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 707; /* iwmmxt_wmulwsmr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 6579 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3009; /* neon_vec_pack_trunc_v8hi */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6579 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3010; /* neon_vec_pack_trunc_v4si */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 6579 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3011; /* neon_vec_pack_trunc_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NEG:
      if (GET_MODE (x3) != E_SImode
          || pattern26 (x1, 
E_CC_Zmode) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      if (!s_register_operand (x4, E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x4;
          if (!
#line 1157 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 15; /* *compare_negsi_si */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[1] = x5;
          if (!shift_operator (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          operands[0] = x4;
          if (!
#line 7925 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 275; /* *arm_cmpsi_negshiftsi_si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern7 (x1, pnum_clobbers, 
E_CC_NVmode))
        {
        case 0:
          x4 = XEXP (x2, 1);
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 33; /* cmpsi3_carryin_CC_NVout */

            case CONST_INT:
              operands[2] = x8;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 35; /* cmpsi3_imm_carryin_CC_NVout */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1795 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 37; /* cmpsi3_0_carryin_CC_NVout */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern7 (x1, pnum_clobbers, 
E_CC_Bmode))
        {
        case 0:
          x4 = XEXP (x2, 1);
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 34; /* cmpsi3_carryin_CC_Bout */

            case CONST_INT:
              operands[2] = x8;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 1;
              return 36; /* cmpsi3_imm_carryin_CC_Bout */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1795 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 38; /* cmpsi3_0_carryin_CC_Bout */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 100)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (s_register_operand (operands[2], E_SImode)
              && GET_MODE (x10) == E_CC_RSBmode
              && GET_MODE (x2) == E_CC_RSBmode)
            {
              operands[1] = x4;
              if (arm_not_immediate_operand (operands[1], E_VOIDmode)
                  && 
#line 2113 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                {
                  *pnum_clobbers = 1;
                  return 49; /* rsb_imm_compare_scratch */
                }
            }
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || XWINT (x4, 0) != 0L
              || GET_MODE (x10) != E_CC_NZmode
              || GET_MODE (x2) != E_CC_NZmode
              || !
#line 5428 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 175; /* *notsi_compare0_scratch */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x5;
          if (!shift_operator (operands[3], E_SImode)
              || XWINT (x4, 0) != 0L
              || GET_MODE (x10) != E_CC_NZmode
              || GET_MODE (x2) != E_CC_NZmode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!shift_amount_operand (operands[2], E_SImode)
              || !
#line 4828 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 156; /* *not_shiftsi_compare0_scratch */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (pnum_clobbers != NULL)
        {
          res = recog_48 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (shift_operator (operands[3], E_SImode))
        {
          res = recog_49 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1455 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 1063; /* *thumb2_mulsi_short_compare0_scratch */

    case ZERO_EXTRACT:
      if (pattern8 (x1) != 0)
        return -1;
      x11 = XEXP (x3, 1);
      operands[1] = x11;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 2);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3092 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
  && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32
      && INTVAL (operands[1]) > 0 
      && INTVAL (operands[1]) + (INTVAL (operands[2]) & 1) <= 8
      && INTVAL (operands[1]) + INTVAL (operands[2]) <= 32)))
        return -1;
      return 93; /* *zeroextractsi_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              res = recog_50 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              res = recog_51 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x4;
          if (!arm_add_operand (operands[1], E_SImode)
              || REGNO (x10) != 100
              || GET_MODE (x10) != E_CCmode
              || GET_MODE (x2) != E_CCmode
              || !s_register_operand (operands[0], E_SImode)
              || !
#line 7877 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 272; /* *arm_cmpsi_insn */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x4;
          if (!shift_operator (operands[3], E_SImode)
              || REGNO (x10) != 100
              || GET_MODE (x10) != E_CCmode
              || GET_MODE (x2) != E_CCmode
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x4, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!shift_amount_operand (operands[2], E_SImode)
              || !
#line 7898 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 273; /* *cmpsi_shiftsi */

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 5)
            return -1;
          x14 = XVECEXP (x3, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x1, 0);
          operands[0] = x10;
          if (!cc_register (operands[0], E_CC_NZmode)
              || GET_MODE (x2) != E_CC_NZmode
              || !
#line 9119 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 304; /* *check_arch2 */

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x3, 1) != 41
              || GET_MODE (x3) != E_SImode
              || pattern26 (x1, 
E_CC_Zmode) != 0)
            return -1;
          x14 = XVECEXP (x3, 0, 0);
          operands[0] = x14;
          if (!memory_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x3, 0, 1);
          operands[1] = x15;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 2;
          return 313; /* stack_protect_test_tls */

        default:
          return -1;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      switch (GET_CODE (x3))
        {
        case PLUS:
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_53 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_54 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          if (pattern8 (x1) == 0)
            {
              x11 = XEXP (x3, 1);
              operands[1] = x11;
              if (arm_rhs_operand (operands[1], E_SImode)
                  && 
#line 3882 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return 115; /* *xorsi3_compare0_scratch */
            }
          break;

        case MINUS:
          res = recog_55 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!shiftable_operator (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!shift_operator (x5, E_SImode))
        return -1;
      operands[3] = x5;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      if (!shift_amount_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 9754 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 330; /* *arith_shiftsi_compare0_scratch */

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!arm_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[4] = x5;
      x11 = XEXP (x3, 1);
      if (!arm_comparison_operator (x11, E_SImode))
        return -1;
      operands[5] = x11;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern340 (x1) != 0)
        return -1;
      switch (XWINT (x12, 0))
        {
        case 0L:
          if (!
#line 10164 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 340; /* *cmp_ite0 */

        case 1L:
          if (!
#line 10247 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 341; /* *cmp_ite1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (pattern243 (x3))
        {
        case 0:
          if (!memory_operand (operands[1], E_HImode)
              || !
#line 5036 "../../gcc/config/arm/arm.md"
(unaligned_access && TARGET_32BIT))
            return -1;
          return 159; /* unaligned_loadhis */

        case 1:
          if (!
#line 3457 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4885; /* mve_vldrq_gather_offset_extend_v8qis */

        case 2:
          if (!
#line 3457 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4887; /* mve_vldrq_gather_offset_extend_v4qis */

        case 3:
          if (!
#line 3457 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4889; /* mve_vldrq_gather_offset_extend_v4his */

        case 4:
          if (!
#line 3600 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4917; /* mve_vldrq_gather_shifted_offset_extend_v4sis */

        case 5:
          if (!
#line 3501 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
            return -1;
          return 4897; /* mve_vldrq_gather_offset_z_extend_v8qis */

        case 6:
          if (!
#line 3501 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4899; /* mve_vldrq_gather_offset_z_extend_v4qis */

        case 7:
          if (!
#line 3501 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4901; /* mve_vldrq_gather_offset_z_extend_v4his */

        case 8:
          if (!
#line 3642 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4924; /* mve_vldrq_gather_shifted_offset_z_extend_v4sis */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if (
#line 5927 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6))
                    return 183; /* *arm_extendhisi2 */
                  if (
#line 5940 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6))
                    return 184; /* *arm_extendhisi2_v6 */
                }
              if (arm_reg_or_extendqisi_mem_op (operands[1], E_QImode))
                {
                  if (
#line 6021 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6))
                    return 187; /* *arm_extendqisi */
                  if (
#line 6034 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                    return 188; /* *arm_extendqisi_v6 */
                }
            }
          if (register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_HImode)
                      && 
#line 446 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    {
                      *pnum_clobbers = 1;
                      return 963; /* thumb1_extendhisi2 */
                    }
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[1], E_QImode)
                      && 
#line 583 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 964; /* thumb1_extendqisi2 */
                  break;

                default:
                  break;
                }
            }
          if (!s_register_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 1094 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6))
            return -1;
          return 1044; /* *thumb2_extendqisi_v6 */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !arm_extendqisi_mem_op (operands[1], E_QImode)
              || !
#line 5984 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4))
            return -1;
          return 186; /* *arm_extendqihi_insn */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 6458 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2994; /* neon_unpacks_v8qi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 6458 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2996; /* neon_unpacks_v4hi */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 6458 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2998; /* neon_unpacks_v2si */

        default:
          return -1;
        }

    case BSWAP:
      if (pattern244 (x3, 
E_HImode) != 0
          || !
#line 12555 "../../gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 412; /* *arm_revsh */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (XVECLEN (x5, 0) == 1)
        {
          res = recog_294 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern373 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 6295 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2964; /* neon_vec_unpacks_lo_v16qi */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 6305 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2970; /* neon_vec_unpacks_hi_v16qi */

        case E_V4SImode:
          if (pattern373 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 6295 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2966; /* neon_vec_unpacks_lo_v8hi */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 6305 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2972; /* neon_vec_unpacks_hi_v8hi */

        case E_V2DImode:
          if (pattern373 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 6295 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return 2968; /* neon_vec_unpacks_lo_v4si */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 6305 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 2974; /* neon_vec_unpacks_hi_v4si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern246 (x3))
        {
        case 0:
          if (!
#line 6420 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2988; /* neon_vec_sshiftl_v8qi */

        case 1:
          if (!
#line 6420 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2990; /* neon_vec_sshiftl_v4hi */

        case 2:
          if (!
#line 6420 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2992; /* neon_vec_sshiftl_v2si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (x4))
            {
            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1512 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 843; /* *truncsisf2_vfp */

            case E_DFmode:
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 1521 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 844; /* *truncsidf2_vfp */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SFmode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!const_double_vcvt_power_of_two (operands[2], E_VOIDmode)
              || !
#line 1895 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 873; /* *combine_vcvtf2i */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern252 (x3))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 903; /* lceilsfsi2 */

        case 1:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 909; /* lceildfsi2 */

        case 2:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 904; /* lfloorsfsi2 */

        case 3:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 910; /* lfloordfsi2 */

        case 4:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 905; /* lroundsfsi2 */

        case 5:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 911; /* lrounddfsi2 */

        case 6:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1231; /* neon_vcvtpv2sfv2si */

        case 7:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1237; /* neon_vcvtpv4sfv4si */

        case 8:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1232; /* neon_vcvtmv2sfv2si */

        case 9:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1238; /* neon_vcvtmv4sfv4si */

        case 10:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1233; /* neon_vcvtav2sfv2si */

        case 11:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1239; /* neon_vcvtav4sfv4si */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 3701 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2104; /* fix_truncv2sfv2si2 */

        case 1:
          if (!
#line 3701 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2105; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  switch (XINT (x5, 1))
    {
    case 47:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6502; /* *p arm_qadd8 */

    case 48:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6503; /* *p arm_qsub8 */

    case 49:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6504; /* *p arm_shadd8 */

    case 50:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6505; /* *p arm_shsub8 */

    case 51:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6506; /* *p arm_uhadd8 */

    case 52:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6507; /* *p arm_uhsub8 */

    case 53:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6508; /* *p arm_uqadd8 */

    case 54:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6509; /* *p arm_uqsub8 */

    case 55:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6510; /* *p arm_qadd16 */

    case 56:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6511; /* *p arm_qasx */

    case 57:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6512; /* *p arm_qsax */

    case 58:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6513; /* *p arm_qsub16 */

    case 59:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6514; /* *p arm_shadd16 */

    case 60:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6515; /* *p arm_shasx */

    case 61:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6516; /* *p arm_shsax */

    case 62:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6517; /* *p arm_shsub16 */

    case 63:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6518; /* *p arm_uhadd16 */

    case 64:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6519; /* *p arm_uhasx */

    case 65:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6520; /* *p arm_uhsax */

    case 66:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6521; /* *p arm_uhsub16 */

    case 67:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6522; /* *p arm_uqadd16 */

    case 68:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6523; /* *p arm_uqasx */

    case 69:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6524; /* *p arm_uqsax */

    case 70:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6525; /* *p arm_uqsub16 */

    case 71:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6526; /* *p arm_smusd */

    case 72:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6527; /* *p arm_smusdx */

    case 43:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6528; /* *p arm_sxtab16 */

    case 44:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6529; /* *p arm_uxtab16 */

    case 73:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6530; /* *p arm_usad8 */

    case 98:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6556; /* *p arm_smuad_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6557; /* *p arm_smuad_setq_insn */

    case 99:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6558; /* *p arm_smuadx_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6559; /* *p arm_smuadx_setq_insn */

    case 100:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !ssat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6560; /* *p arm_ssat16_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6561; /* *p arm_ssat16_setq_insn */

    case 101:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !usat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6562; /* *p arm_usat16_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6563; /* *p arm_usat16_setq_insn */

    case 13:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 528 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6712; /* *p iwmmxt_wmacsz */

    case 14:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 549 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6714; /* *p iwmmxt_wmacuz */

    case 6:
      if (GET_MODE (x5) != E_V4HImode
          || !register_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode)
          || !immediate_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 780 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6731; /* *p iwmmxt_wshufh */

    case 10:
      if (GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[0], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1750 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6823; /* *p iwmmxt_wsadbz */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1760 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6824; /* *p iwmmxt_wsadhz */

        default:
          return -1;
        }

    case 113:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6848; /* *p iwmmxt_wqmulm */

    case 112:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 381 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6849; /* *p iwmmxt_wqmulwm */

    case 111:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 391 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6850; /* *p iwmmxt_wqmulmr */

    case 110:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 401 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6851; /* *p iwmmxt_wqmulwmr */

    case 1069:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7059; /* *p mve_uqrshll_sat64_di */

    case 1070:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7060; /* *p mve_uqrshll_sat48_di */

    case 1071:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7061; /* *p mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7062; /* *p mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7063; /* *p mve_uqrshl_si */

    case 1067:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4310 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7064; /* *p mve_sqrshr_si */

    case 1066:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4333 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7066; /* *p mve_urshrl_di */

    case 1065:
      if (pattern523 (x5, 
E_SImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4356 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7068; /* *p mve_urshr_si */

    case 1064:
      if (pattern523 (x5, 
E_DImode) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4379 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7070; /* *p mve_srshr_si */

    case 1063:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4391 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7071; /* *p mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case SS_TRUNCATE:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != SS_TRUNCATE)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      switch (pattern492 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 946 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6753; /* *p iwmmxt_wpackhss */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6754; /* *p iwmmxt_wpackwss */

        case 2:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6755; /* *p iwmmxt_wpackdss */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != US_TRUNCATE)
            return -1;
          switch (pattern492 (x6))
            {
            case 0:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 979 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6756; /* *p iwmmxt_wpackhus */

            case 1:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 990 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6757; /* *p iwmmxt_wpackwus */

            case 2:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1001 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6758; /* *p iwmmxt_wpackdus */

            default:
              return -1;
            }

        case SS_PLUS:
          if (GET_MODE (x9) != E_V4HImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_V4HImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != VEC_SELECT
              || GET_MODE (x11) != E_V4QImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 4)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x12, 0, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x15 = XVECEXP (x12, 0, 2);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x16 = XVECEXP (x12, 0, 3);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CONST_VECTOR
              || XVECLEN (x8, 0) != 4
              || GET_MODE (x8) != E_V4QImode)
            return -1;
          x17 = XVECEXP (x8, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x8, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x8, 0, 2);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x8, 0, 3);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x6) != E_V8QImode
              || GET_MODE (x7) != E_V4QImode)
            return -1;
          x21 = XEXP (x9, 0);
          operands[1] = x21;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x22 = XEXP (x11, 0);
          operands[2] = x22;
          if (!register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 433 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6853; /* *p iwmmxt_waddbhusl */

        default:
          return -1;
        }

    case CONST_VECTOR:
      if (XVECLEN (x7, 0) != 4
          || GET_MODE (x7) != E_V4QImode)
        return -1;
      x23 = XVECEXP (x7, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x7, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x25 = XVECEXP (x7, 0, 2);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x26 = XVECEXP (x7, 0, 3);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != US_TRUNCATE
          || GET_MODE (x8) != E_V4QImode)
        return -1;
      x27 = XEXP (x8, 0);
      if (GET_CODE (x27) != SS_PLUS
          || GET_MODE (x27) != E_V4HImode)
        return -1;
      x28 = XEXP (x27, 1);
      if (pattern600 (x28, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0)
        return -1;
      x29 = XEXP (x28, 0);
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != PARALLEL
          || XVECLEN (x30, 0) != 4)
        return -1;
      x31 = XVECEXP (x30, 0, 0);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x30, 0, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x33 = XVECEXP (x30, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x34 = XVECEXP (x30, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x35 = XEXP (x27, 0);
      operands[1] = x35;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x36 = XEXP (x29, 0);
      operands[2] = x36;
      if (!register_operand (operands[2], E_V8QImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 417 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6852; /* *p iwmmxt_waddbhusm */

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!mem_and_no_t1_wback_op (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5046 "../../gcc/config/arm/arm.md"
(unaligned_access)))
        return -1;
      return 6476; /* *p unaligned_loadhiu */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5688 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
            return 6487; /* *p *arm_zero_extendhisi2 */
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5699 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6488; /* *p *arm_zero_extendhisi2_v6 */
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1107 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6984; /* *p *thumb2_zero_extendhisi2_v6 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5757 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6)))
            return 6490; /* *p *arm_zero_extendqisi2 */
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5769 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6491; /* *p *arm_zero_extendqisi2_v6 */
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1120 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6985; /* *p thumb2_zero_extendqisi2_v6 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 725 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6726; /* *p iwmmxt_textrmub */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 747 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6728; /* *p iwmmxt_textrmuh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern312 (x1))
    {
    case 0:
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
        return 6460; /* *p arm_qadd_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
        return -1;
      return 6461; /* *p arm_qadd_setq_insn */

    case 1:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 351 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6693; /* *p ssaddv8qi3 */

    case 2:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 361 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6694; /* *p ssaddv4hi3 */

    case 3:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6695; /* *p ssaddv2si3 */

    case 4:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7022; /* *p *arm_ssaddv4qq3 */

    case 5:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7023; /* *p *arm_ssaddv2hq3 */

    case 6:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7024; /* *p *arm_ssaddqq3 */

    case 7:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7025; /* *p *arm_ssaddhq3 */

    case 8:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7026; /* *p *arm_ssaddv2ha3 */

    case 9:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7027; /* *p *arm_ssaddha3 */

    case 10:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7028; /* *p *arm_ssaddsq3 */

    case 11:
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7029; /* *p *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case MEM:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MEM
          || pattern546 (x8) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x7, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x13 = XEXP (x12, 1);
          if (XWINT (x13, 0) != 4L)
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 855 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6654; /* *p *ldm2_ */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XEXP (x11, 0);
          operands[3] = x16;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          switch (XWINT (x15, 0))
            {
            case 4L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != 8L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 942 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6658; /* *p *ldm2_ib */

            case -8L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != -4L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1044 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6666; /* *p *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x7;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x4, 0);
      if (pattern573 (x10) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x17 = XEXP (x9, 0);
      switch (GET_CODE (x17))
        {
        case REG:
        case SUBREG:
          operands[3] = x17;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x19 = XEXP (x18, 1);
          if (XWINT (x19, 0) != 4L)
            return -1;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 904 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6656; /* *p *stm2_ */

        case PLUS:
          if (GET_MODE (x17) != E_SImode)
            return -1;
          x21 = XEXP (x17, 1);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XEXP (x17, 0);
          operands[3] = x22;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3]))
            return -1;
          switch (XWINT (x21, 0))
            {
            case 4L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != 8L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6660; /* *p *stm2_ib */

            case -8L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != -4L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1070 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6668; /* *p *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (arm_general_register_operand (operands[0], E_DImode)
              && arm_general_register_operand (operands[1], E_DImode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_54 (insn, operands);
          break;

        case E_DFmode:
          if (arm_general_register_operand (operands[0], E_DFmode)
              && arm_general_register_operand (operands[1], E_DFmode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_55 (insn, operands);
          break;

        case E_V8QImode:
          if (arm_general_register_operand (operands[0], E_V8QImode)
              && arm_general_register_operand (operands[1], E_V8QImode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_56 (insn, operands);
          break;

        case E_V4HImode:
          if (arm_general_register_operand (operands[0], E_V4HImode)
              && arm_general_register_operand (operands[1], E_V4HImode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_57 (insn, operands);
          break;

        case E_V4BFmode:
          if (arm_general_register_operand (operands[0], E_V4BFmode)
              && arm_general_register_operand (operands[1], E_V4BFmode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_58 (insn, operands);
          break;

        case E_V4HFmode:
          if (arm_general_register_operand (operands[0], E_V4HFmode)
              && arm_general_register_operand (operands[1], E_V4HFmode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_59 (insn, operands);
          break;

        case E_V2SImode:
          if (arm_general_register_operand (operands[0], E_V2SImode)
              && arm_general_register_operand (operands[1], E_V2SImode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_60 (insn, operands);
          break;

        case E_V2SFmode:
          if (arm_general_register_operand (operands[0], E_V2SFmode)
              && arm_general_register_operand (operands[1], E_V2SFmode)
              && 
#line 6424 "../../gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_61 (insn, operands);
          break;

        case E_EImode:
          if (s_register_operand (operands[0], E_EImode)
              && s_register_operand (operands[1], E_EImode)
              && 
#line 201 "../../gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_152 (insn, operands);
          break;

        case E_OImode:
          if (s_register_operand (operands[0], E_OImode)
              && s_register_operand (operands[1], E_OImode)
              && 
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed))
            return gen_split_153 (insn, operands);
          break;

        case E_V2x16QImode:
          if (s_register_operand (operands[0], E_V2x16QImode)
              && s_register_operand (operands[1], E_V2x16QImode)
              && (
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 157 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_154 (insn, operands);
          break;

        case E_V2x8HImode:
          if (s_register_operand (operands[0], E_V2x8HImode)
              && s_register_operand (operands[1], E_V2x8HImode)
              && (
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 158 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_155 (insn, operands);
          break;

        case E_V2x4SImode:
          if (s_register_operand (operands[0], E_V2x4SImode)
              && s_register_operand (operands[1], E_V2x4SImode)
              && (
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 159 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_156 (insn, operands);
          break;

        case E_V2x8HFmode:
          if (s_register_operand (operands[0], E_V2x8HFmode)
              && s_register_operand (operands[1], E_V2x8HFmode)
              && (
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 160 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_157 (insn, operands);
          break;

        case E_V2x4SFmode:
          if (s_register_operand (operands[0], E_V2x4SFmode)
              && s_register_operand (operands[1], E_V2x4SFmode)
              && (
#line 220 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 161 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_158 (insn, operands);
          break;

        case E_CImode:
          if (s_register_operand (operands[0], E_CImode)
              && s_register_operand (operands[1], E_CImode)
              && 
#line 239 "../../gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_159 (insn, operands);
          break;

        case E_XImode:
          if (s_register_operand (operands[0], E_XImode)
              && s_register_operand (operands[1], E_XImode)
              && 
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed))
            return gen_split_160 (insn, operands);
          break;

        case E_V4x16QImode:
          if (s_register_operand (operands[0], E_V4x16QImode)
              && s_register_operand (operands[1], E_V4x16QImode)
              && (
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 166 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_161 (insn, operands);
          break;

        case E_V4x8HImode:
          if (s_register_operand (operands[0], E_V4x8HImode)
              && s_register_operand (operands[1], E_V4x8HImode)
              && (
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 167 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_162 (insn, operands);
          break;

        case E_V4x4SImode:
          if (s_register_operand (operands[0], E_V4x4SImode)
              && s_register_operand (operands[1], E_V4x4SImode)
              && (
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 168 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_163 (insn, operands);
          break;

        case E_V4x8HFmode:
          if (s_register_operand (operands[0], E_V4x8HFmode)
              && s_register_operand (operands[1], E_V4x8HFmode)
              && (
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 169 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_164 (insn, operands);
          break;

        case E_V4x4SFmode:
          if (s_register_operand (operands[0], E_V4x4SFmode)
              && s_register_operand (operands[1], E_V4x4SFmode)
              && (
#line 261 "../../gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 170 "../../gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_165 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case MEM:
      if (GET_MODE (x2) == E_DImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_DImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (s_register_operand (operands[2], E_SImode)
                          && 
#line 6454 "../../gcc/config/arm/arm.md"
(TARGET_LDRD
  && reg_overlap_mentioned_p (operands[0], operands[1])
  && reg_overlap_mentioned_p (operands[0], operands[2])))
                        return gen_split_62 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (arm_general_register_operand (operands[0], E_SImode)
      && general_operand (operands[1], E_SImode)
      && 
#line 6638 "../../gcc/config/arm/arm.md"
(TARGET_USE_MOVT && GET_CODE (operands[1]) == SYMBOL_REF
   && !target_word_relocations
   && !arm_tls_referenced_p (operands[1])))
    return gen_split_65 (insn, operands);
  if (register_operand (operands[0], E_SImode)
      && const_int_operand (operands[1], E_SImode))
    {
      if (
#line 767 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_J (operands[1])))
        return gen_split_126 (insn, operands);
      if (
#line 780 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_K (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_127 (insn, operands);
      if (
#line 808 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_Pe (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_128 (insn, operands);
      if (
#line 823 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && arm_disable_literal_pool
   && GET_CODE (operands[1]) == CONST_INT
   && !TARGET_HAVE_MOVT
   && !satisfies_constraint_K (operands[1])))
        return gen_split_129 (insn, operands);
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return NULL;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x6 = XEXP (x4, 1);
  if (pattern317 (x6, 
1) != 0)
    return NULL;
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!
#line 6674 "../../gcc/config/arm/arm.md"
(flag_pic))
    return NULL;
  return gen_split_66 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_11 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_10 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC
              || XVECLEN (x3, 0) != 1
              || pattern285 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER
              || pattern451 (x1) != 0
              || !
#line 9306 "../../gcc/config/arm/arm.md"
(reload_completed))
            return NULL;
          return gen_split_75 (insn, operands);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != EQ)
                return NULL;
              x8 = XEXP (x7, 1);
              if (pattern297 (x8) != 0)
                return NULL;
              x9 = XEXP (x3, 1);
              if (GET_CODE (x9) != LABEL_REF)
                return NULL;
              x10 = XEXP (x3, 2);
              if (GET_CODE (x10) != PC)
                return NULL;
              x11 = XEXP (x2, 0);
              if (GET_CODE (x11) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER
                  || pattern577 (x1) != 0
                  || !
#line 9395 "../../gcc/config/arm/arm.md"
(reload_completed))
                return NULL;
              return gen_split_76 (insn, operands);

            case UNSPEC_VOLATILE:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!((
#line 250 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!((
#line 250 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 2:
                  if (!((
#line 250 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 3:
                  if (!((
#line 250 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_180 (insn, operands);

                case 4:
                  if (!((
#line 281 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_181 (insn, operands);

                case 5:
                  if (!((
#line 281 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case 6:
                  if (!((
#line 281 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_182 (insn, operands);

                case 7:
                  if (!((
#line 281 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_184 (insn, operands);

                case 8:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_189 (insn, operands);

                case 9:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 10:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                case 11:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_204 (insn, operands);

                case 12:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_190 (insn, operands);

                case 13:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_195 (insn, operands);

                case 14:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_200 (insn, operands);

                case 15:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_205 (insn, operands);

                case 16:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 17:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_196 (insn, operands);

                case 18:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_201 (insn, operands);

                case 19:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_206 (insn, operands);

                case 20:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 21:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 22:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_202 (insn, operands);

                case 23:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 24:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 25:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case 26:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_203 (insn, operands);

                case 27:
                  if (!(
#line 342 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_208 (insn, operands);

                case 28:
                  if (!(
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 29:
                  if (!(
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_210 (insn, operands);

                case 30:
                  if (!(
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 31:
                  if (!(
#line 366 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_212 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              operands[1] = x3;
              if (pattern319 (x1, 
18, 
2) != 0)
                return NULL;
              x11 = XEXP (x2, 0);
              operands[0] = x11;
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[2] = x13;
              x14 = XVECEXP (x12, 0, 1);
              operands[3] = x14;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              x15 = XEXP (x6, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode))
                return NULL;
              x16 = XEXP (x4, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern576 (x12, 
E_QImode) != 0
                      || !(
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_185 (insn, operands);

                case E_HImode:
                  if (pattern576 (x12, 
E_HImode) != 0
                      || !(
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case E_SImode:
                  if (pattern576 (x12, 
E_SImode) != 0
                      || !(
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case E_DImode:
                  if (pattern576 (x12, 
E_DImode) != 0
                      || !(
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_188 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_237 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_242 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_247 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_252 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_238 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_248 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_253 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_239 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_249 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_254 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_240 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_250 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_255 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_251 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND
                  || pattern319 (x1, 
19, 
3) != 0)
                return NULL;
              switch (pattern531 (x1))
                {
                case 0:
                  if (!(
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_257 (insn, operands);

                case 1:
                  if (!(
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_258 (insn, operands);

                case 2:
                  if (!(
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_259 (insn, operands);

                case 3:
                  if (!(
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_260 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET
              || pattern12 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (pattern565 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_218 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_228 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_214 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_219 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_229 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_220 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_225 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_230 (insn, operands);

                default:
                  return NULL;
                }

            case 3:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_216 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_226 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_231 (insn, operands);

                default:
                  return NULL;
                }

            case 4:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_227 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_232 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x17 = XEXP (x13, 0);
              if (GET_CODE (x17) != AND)
                return NULL;
              x18 = XEXP (x17, 1);
              operands[2] = x18;
              x19 = XEXP (x17, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern622 (x12, 
E_QImode) != 0
                      || !(
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_233 (insn, operands);

                case E_HImode:
                  if (pattern622 (x12, 
E_HImode) != 0
                      || !(
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_234 (insn, operands);

                case E_SImode:
                  if (pattern622 (x12, 
E_SImode) != 0
                      || !(
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_235 (insn, operands);

                case E_DImode:
                  if (pattern623 (x12) != 0
                      || !(
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_236 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x20 = XEXP (x1, 0);
      if (!arm_comparison_operator (x20, E_VOIDmode))
        return NULL;
      x21 = XEXP (x20, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x22 = XEXP (x20, 0);
      if (!cc_register (x22, E_VOIDmode))
        return NULL;
      x23 = XEXP (x1, 1);
      switch (GET_CODE (x23))
        {
        case SET:
          x24 = XEXP (x23, 1);
          switch (GET_CODE (x24))
            {
            case PLUS:
              if (pattern320 (x1) != 0
                  || !
#line 962 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
                return NULL;
              return gen_split_261 (insn, operands);

            case MINUS:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return NULL;
              x27 = XEXP (x24, 1);
              operands[2] = x27;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 2020 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
                return NULL;
              return gen_split_262 (insn, operands);

            case AND:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              switch (GET_CODE (x26))
                {
                case REG:
                case SUBREG:
                  operands[1] = x26;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x20;
                  operands[4] = x22;
                  x27 = XEXP (x24, 1);
                  operands[2] = x27;
                  if (!reg_or_int_operand (operands[2], E_SImode)
                      || !
#line 3031 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                    return NULL;
                  return gen_split_263 (insn, operands);

                case IOR:
                  if (GET_MODE (x26) != E_SImode)
                    return NULL;
                  x27 = XEXP (x24, 1);
                  if (GET_CODE (x27) != NOT
                      || GET_MODE (x27) != E_SImode)
                    return NULL;
                  operands[4] = x20;
                  operands[5] = x22;
                  x28 = XEXP (x26, 0);
                  operands[1] = x28;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  x29 = XEXP (x26, 1);
                  operands[2] = x29;
                  if (!arm_rhs_operand (operands[2], E_SImode))
                    return NULL;
                  x30 = XEXP (x27, 0);
                  operands[3] = x30;
                  if (!arm_rhs_operand (operands[3], E_SImode)
                      || !(
#line 3910 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc/config/arm/arm.md"
( reload_completed)))
                    return NULL;
                  return gen_split_267 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              if (XWINT (x24, 0) != 0L)
                return NULL;
              x25 = XEXP (x23, 0);
              if (GET_CODE (x25) != ZERO_EXTRACT
                  || GET_MODE (x25) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x31 = XEXP (x25, 0);
              operands[0] = x31;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x32 = XEXP (x25, 1);
              operands[1] = x32;
              if (!const_int_M_operand (operands[1], E_SImode))
                return NULL;
              x33 = XEXP (x25, 2);
              operands[2] = x33;
              if (!const_int_M_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_264 (insn, operands);

            case IOR:
              if (pattern320 (x1) != 0
                  || !
#line 3744 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_265 (insn, operands);

            case XOR:
              if (pattern320 (x1) != 0
                  || !
#line 3849 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_266 (insn, operands);

            case NEG:
              if (GET_MODE (x24) != E_DFmode)
                return NULL;
              operands[2] = x20;
              operands[3] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_DFmode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 906 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          if (XVECLEN (x23, 0) != 2)
            return NULL;
          x34 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x34) != SET
              || pattern363 (x1) != 0)
            return NULL;
          x35 = XEXP (x34, 0);
          operands[0] = x35;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x36 = XEXP (x34, 1);
          if (GET_MODE (x36) != E_SImode)
            return NULL;
          switch (GET_CODE (x36))
            {
            case ABS:
              x37 = XEXP (x36, 0);
              operands[1] = x37;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_268 (insn, operands);
              if (!(
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_271 (insn, operands);

            case NEG:
              x37 = XEXP (x36, 0);
              if (GET_CODE (x37) != ABS
                  || GET_MODE (x37) != E_SImode)
                return NULL;
              x38 = XEXP (x37, 0);
              operands[1] = x38;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_269 (insn, operands);
              if (!(
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_272 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
