/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern19 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern19 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern19 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode
          || !mem_noofs_operand (operands[1], E_DImode)
          || !s_register_operand (operands[2], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8BImode:
      return pattern62 (x3, 
E_V8BImode, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4BImode:
      if (pattern62 (x3, 
E_V4BImode, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern72 (x3, 
E_V8BImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !imm_lshift_or_reg_neon (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != FIX
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX
      || GET_MODE (x4) != E_SFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != FLOAT_EXTEND
      || GET_MODE (x5) != E_SFmode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_HFmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V4HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern40 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !vpr_register_operand (operands[2], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x16QImode:
      return 0;

    case E_V2x8HImode:
      return 1;

    case E_V2x4SImode:
      return 2;

    case E_V2x8HFmode:
      return 3;

    case E_V2x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern226 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern226 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          return pattern233 (x1, 
E_V16QImode, 
E_V16BImode); /* [-1, 0] */

        case E_V8BImode:
          if (pattern233 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 1;

        case E_V4BImode:
          if (pattern233 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          if (pattern234 (x1, 
E_QImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 3;

        case E_V8BImode:
          if (pattern234 (x1, 
E_HImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 4;

        case E_V4BImode:
          if (pattern234 (x1, 
E_SImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!s_register_operand (operands[1], E_SImode)
          || !mem_noofs_operand (operands[2], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !arm_add_operand (operands[3], E_SImode)
          || !s_register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[1], E_DImode)
          || !mem_noofs_operand (operands[2], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_DImode
          || !cmpdi_operand (operands[3], E_DImode)
          || !s_register_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!arm_comparison_operator (operands[5], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  if (!arm_add_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 40
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  return pattern291 (x1); /* [-1, 3] */
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 41
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern303 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 2)
    return -1;
  return 0;
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern308 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern308 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern308 (x1, 
E_DImode, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
E_CCmode, 
100); /* [-1, 0] */
}

int
pattern324 (rtx x1, int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != i4
      || GET_MODE (x6) != i3
      || pattern323 (x1, 
i2, 
i3, 
i4) != 0)
    return -1;
  return 0;
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern339 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern338 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern338 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern338 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[2] = x5;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_memory_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern386 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern398 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern398 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern398 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!mem_noofs_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  switch (XWINT (x8, 0))
    {
    case 8L:
      x9 = XEXP (x6, 2);
      switch (XWINT (x9, 0))
        {
        case 8L:
          return 0;

        case 16L:
          return 1;

        default:
          return -1;
        }

    case 16L:
      x9 = XEXP (x6, 2);
      if (XWINT (x9, 0) != 8L)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_struct_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !register_operand (operands[2], E_V16QImode)
      || !register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern450 (x1) != 0)
    return -1;
  return 0;
}

int
pattern501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!s_register_operand (operands[1], E_TImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern515 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern571 (x1) != 0)
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 28
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 104
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || pattern417 (x1, 
E_CCmode, 
MINUS) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2])
      || !
#line 1654 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 26; /* subsi3_compare1 */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x8, 
IOR))
        {
        case 0:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2])
              || !
#line 3782 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 111; /* *iorsi3_compare0 */

        case 1:
          if (!
#line 3797 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 112; /* *iorsi3_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern384 (x1, 
IOR) != 0
          || !
#line 10530 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 345; /* *ior_scc_scc_cmp */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_SImode)
          && pattern495 (x1) == 0)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (s_register_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x9 = XEXP (x3, 1);
                  operands[4] = x9;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3182 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return 96; /* *ite_ne_zeroextractsi */
                }
            }
        }
      if (XWINT (x6, 0) != 0L
          || pattern495 (x1) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (s_register_operand (operands[0], E_SImode)
          && pattern387 (x1) == 0)
        {
          x9 = XEXP (x3, 1);
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          if (
#line 1491 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1065; /* *thumb2_cbnz */
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (XWINT (x11, 0) != 1L)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != LABEL_REF)
        return -1;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != PC)
        return -1;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != PC)
        return -1;
      x14 = XVECEXP (x1, 0, 1);
      if (pattern528 (x14) != 0)
        return -1;
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 14
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!
#line 1771 "../../gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      *pnum_clobbers = 1;
      return 1075; /* *doloop_end_internal */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 12765 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false))))
    return -1;
  return 426; /* *thumb2_strd */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      switch (XINT (x3, 1))
        {
        case 79:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 87; /* arm_smlawb_setq_insn */

        case 80:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 89; /* arm_smlawt_setq_insn */

        case 94:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 239; /* arm_smlad_setq_insn */

        case 95:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 241; /* arm_smladx_setq_insn */

        case 96:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 243; /* arm_smlsd_setq_insn */

        case 97:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 245; /* arm_smlsdx_setq_insn */

        case 622:
          switch (pattern365 (x1, 
622))
            {
            case 0:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3954; /* mve_vshlcq_sv16qi */

            case 1:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3956; /* mve_vshlcq_sv8hi */

            case 2:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3958; /* mve_vshlcq_sv4si */

            default:
              return -1;
            }

        case 623:
          switch (pattern365 (x1, 
623))
            {
            case 0:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3955; /* mve_vshlcq_uv16qi */

            case 1:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3957; /* mve_vshlcq_uv8hi */

            case 2:
              if (!
#line 1679 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3959; /* mve_vshlcq_uv4si */

            default:
              return -1;
            }

        case 1035:
          switch (pattern366 (x1, 
1035))
            {
            case 0:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4950; /* mve_viwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4952; /* mve_viwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4954; /* mve_viwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1031:
          switch (pattern366 (x1, 
1031))
            {
            case 0:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4951; /* mve_vdwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4953; /* mve_vdwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4955; /* mve_vdwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1037:
          if (pattern334 (x2) != 0
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1037)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          switch (pattern586 (x4))
            {
            case 0:
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3891 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4962; /* mve_vstrq_scatter_base_wb_v4si */

                case 1:
                  if (!
#line 3891 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4963; /* mve_vstrq_scatter_base_wb_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3891 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4964; /* mve_vstrq_scatter_base_wb_v2di */

            default:
              return -1;
            }

        case 1039:
          x8 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SCRATCH
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1039)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern602 (x1, 
E_V4SImode) != 0
                  || !
#line 3937 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4968; /* mve_vldrq_gather_base_wb_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x5) != E_V4SImode
                  || !
#line 3937 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4969; /* mve_vldrq_gather_base_wb_v4sf */

            case E_V2DImode:
              if (pattern602 (x1, 
E_V2DImode) != 0
                  || !
#line 3937 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4970; /* mve_vldrq_gather_base_wb_v2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 1:
      if (XINT (x3, 1) != 40
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x6) == MEM
          && GET_MODE (x6) == E_SImode)
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER)
            {
              x14 = XEXP (x6, 0);
              operands[1] = x14;
              if (register_operand (operands[1], E_SImode))
                {
                  x11 = XEXP (x4, 0);
                  if (rtx_equal_p (x11, operands[1]))
                    return 309; /* *stack_protect_set_insn */
                }
            }
        }
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 312; /* stack_protect_set_tls */

    case 4:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      switch (XINT (x3, 1))
        {
        case 1034:
          switch (pattern333 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4944; /* mve_vidupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4946; /* mve_vidupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4948; /* mve_vidupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1030:
          switch (pattern333 (x1, 
MINUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4945; /* mve_vddupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4947; /* mve_vddupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4949; /* mve_vddupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1038:
          if (pattern334 (x2) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1038)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          x15 = XVECEXP (x3, 0, 3);
          operands[4] = x15;
          switch (pattern586 (x4))
            {
            case 0:
              if (!vpr_register_operand (operands[4], E_V4BImode))
                return -1;
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3915 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4965; /* mve_vstrq_scatter_base_wb_p_v4si */

                case 1:
                  if (!
#line 3915 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4966; /* mve_vstrq_scatter_base_wb_p_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!vpr_register_operand (operands[4], E_V2QImode)
                  || !s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3915 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4967; /* mve_vstrq_scatter_base_wb_p_v2di */

            default:
              return -1;
            }

        case 1040:
          x15 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SCRATCH)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1040)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[4] = x8;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern609 (x1, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4971; /* mve_vldrq_gather_base_wb_z_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || pattern608 (x5, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4972; /* mve_vldrq_gather_base_wb_z_v4sf */

            case E_V2DImode:
              if (pattern609 (x1, 
E_V2DImode, 
E_V2QImode) != 0
                  || !
#line 3960 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4973; /* mve_vldrq_gather_base_wb_z_v2di */

            default:
              return -1;
            }

        case 1054:
          if (pattern336 (x1, 
1054) != 0
              || !
#line 4015 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4980; /* mve_vadciq_m_uv4si */

        case 1056:
          if (pattern336 (x1, 
1056) != 0
              || !
#line 4015 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4981; /* mve_vadciq_m_sv4si */

        case 1047:
          if (pattern336 (x1, 
1047) != 0
              || !
#line 4015 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4982; /* mve_vsbciq_m_uv4si */

        case 1048:
          if (pattern336 (x1, 
1048) != 0
              || !
#line 4015 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4983; /* mve_vsbciq_m_sv4si */

        case 1042:
          if (pattern337 (x1, 
1042) != 0
              || !
#line 4056 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4988; /* mve_vadcq_m_uv4si */

        case 1044:
          if (pattern337 (x1, 
1044) != 0
              || !
#line 4056 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4989; /* mve_vadcq_m_sv4si */

        case 1051:
          if (pattern337 (x1, 
1051) != 0
              || !
#line 4056 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4990; /* mve_vsbcq_m_uv4si */

        case 1052:
          if (pattern337 (x1, 
1052) != 0
              || !
#line 4056 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4991; /* mve_vsbcq_m_sv4si */

        case 1061:
          switch (pattern339 (x1, 
1061))
            {
            case 0:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5039; /* mve_vshlcq_m_sv16qi */

            case 1:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5041; /* mve_vshlcq_m_sv8hi */

            case 2:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5043; /* mve_vshlcq_m_sv4si */

            default:
              return -1;
            }

        case 1060:
          switch (pattern339 (x1, 
1060))
            {
            case 0:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5040; /* mve_vshlcq_m_uv16qi */

            case 1:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5042; /* mve_vshlcq_m_uv8hi */

            case 2:
              if (!
#line 4423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5044; /* mve_vshlcq_m_uv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x8 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 4)
          || GET_MODE (x8) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 5
          || GET_MODE (x5) != E_SImode)
        return -1;
      x17 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x17) != SUBREG
          || maybe_ne (SUBREG_BYTE (x17), 4)
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[4], E_DImode))
        return -1;
      x15 = XVECEXP (x3, 0, 3);
      operands[5] = x15;
      if (!mve_imm_selective_upto_8 (operands[5], E_SImode))
        return -1;
      x18 = XVECEXP (x3, 0, 4);
      operands[6] = x18;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[4]))
        return -1;
      x20 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = XVECEXP (x5, 0, 4);
      if (!rtx_equal_p (x21, operands[6]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 1036:
          switch (pattern632 (x1, 
1036))
            {
            case 0:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4956; /* mve_viwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4958; /* mve_viwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4960; /* mve_viwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1032:
          switch (pattern632 (x1, 
1032))
            {
            case 0:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4957; /* mve_vdwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4959; /* mve_vdwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4961; /* mve_vdwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x5;
      if (!s_register_operand (operands[0], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 3076 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 92; /* *andsi3_compare0_scratch */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_SImode
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[0] = x7;
          if (!shift_operator (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[2] = x9;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x6;
          if (!
#line 3637 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 106; /* andsi_not_shiftsi_si_scc_no_reuse */

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x6;
          if (!
#line 3691 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* *andsi_notsi_si_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10330 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 342; /* *cmp_and */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 648; /* ashlv4hi3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 660; /* ashlv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 649; /* ashlv2si3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 661; /* ashlv2si3_di */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (register_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1340 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 650; /* ashldi3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1424 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 662; /* ashldi3_di */
            }
        }
      if (!arm_general_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!arm_reg_or_long_shift_imm (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 1749 "../../gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
        return -1;
      return 1073; /* thumb2_lsll */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_BLKmode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_EImode:
      if (!s_register_operand (operands[1], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2885; /* neon_vst3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2886; /* neon_vst3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2887; /* neon_vst3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2888; /* neon_vst3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2889; /* neon_vst3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5910 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2890; /* neon_vst3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[1], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5936 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2891; /* neon_vst3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5936 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2892; /* neon_vst3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5936 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2893; /* neon_vst3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5936 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2894; /* neon_vst3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5936 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2895; /* neon_vst3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern89 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      switch (pattern507 ())
        {
        case 0:
          if (!
#line 3661 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4926; /* mve_vstrq_scatter_shifted_offset_v8hi */

        case 1:
          if (!
#line 3661 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4928; /* mve_vstrq_scatter_shifted_offset_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern508 ())
        {
        case 0:
          if (!
#line 3661 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4927; /* mve_vstrq_scatter_shifted_offset_v4si */

        case 1:
          if (!
#line 3661 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4929; /* mve_vstrq_scatter_shifted_offset_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3661 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4930; /* mve_vstrq_scatter_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2436; /* neon_vrsrau_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2440; /* neon_vrsrau_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2444; /* neon_vrsrau_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2448; /* neon_vrsrau_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2452; /* neon_vrsrau_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2456; /* neon_vrsrau_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2460; /* neon_vrsrau_ndi */

    case 7:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2464; /* neon_vrsrau_nv2di */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 105
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode)
      || !
#line 6194 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
    return -1;
  return 254; /* arm_sel */
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (pattern94 (x2, 
0, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[1] = x5;
  if (!
#line 12341 "../../gcc/config/arm/arm.md"
(TARGET_GNU2_TLS))
    return -1;
  *pnum_clobbers = 3;
  return 409; /* tlscall */
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1597; /* neon_vqrdmlshv4hi */

    case 1:
      if (!
#line 2192 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1599; /* neon_vqrdmlshv2si */

    case 2:
      if (!
#line 2192 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1601; /* neon_vqrdmlshv8hi */

    case 3:
      if (!
#line 2192 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1603; /* neon_vqrdmlshv4si */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!mve_memory_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 3130 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4820; /* mve_vstrq_v16qi */

    case E_V8HImode:
      if (!mve_memory_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 3130 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4821; /* mve_vstrq_v8hi */

    case E_V4SImode:
      if (!mve_memory_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3130 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4822; /* mve_vstrq_v4si */

    case E_V8HFmode:
      if (!mve_memory_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 3130 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4823; /* mve_vstrq_v8hf */

    case E_V4SFmode:
      if (!mve_memory_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3130 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4824; /* mve_vstrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 24 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 687; /* iwmmxt_wabsv2si3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 24 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 688; /* iwmmxt_wabsv4hi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 24 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 689; /* iwmmxt_wabsv8qi3 */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2108; /* neon_vcvtsv2sf */

    case 1:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2110; /* neon_vcvtsv4sf */

    case 2:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2112; /* neon_vcvtsv2si */

    case 3:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2114; /* neon_vcvtsv4si */

    case 4:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2118; /* neon_vcvtsv4hi */

    case 5:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2120; /* neon_vcvtsv8hi */

    case 6:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2122; /* neon_vcvtsv8hf */

    case 7:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2124; /* neon_vcvtsv4hf */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (pattern392 (x2, 
E_V4HImode) != 0
          || !
#line 111 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 695; /* addcv4hi3 */

    case E_V2SImode:
      if (pattern392 (x2, 
E_V2SImode) != 0
          || !
#line 111 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 696; /* addcv2si3 */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!s_register_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !neon_struct_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2772; /* neon_vld2v8qi */

        case E_V4HImode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2773; /* neon_vld2v4hi */

        case E_V4HFmode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2774; /* neon_vld2v4hf */

        case E_V4BFmode:
          if (!(
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2775; /* neon_vld2v4bf */

        case E_V2SImode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2776; /* neon_vld2v2si */

        case E_V2SFmode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2777; /* neon_vld2v2sf */

        case E_DImode:
          if (!
#line 5417 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2778; /* neon_vld2di */

        default:
          return -1;
        }

    case 1:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !neon_struct_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2779; /* neon_vld2v16qi */

        case E_V8HImode:
          if (!
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2780; /* neon_vld2v8hi */

        case E_V8HFmode:
          if (!
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2781; /* neon_vld2v8hf */

        case E_V8BFmode:
          if (!(
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2782; /* neon_vld2v8bf */

        case E_V4SImode:
          if (!
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2783; /* neon_vld2v4si */

        case E_V4SFmode:
          if (!
#line 5435 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2784; /* neon_vld2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 929; /* arm_vcx1si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 930; /* arm_vcx1di */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !const_int_mve_cde1_operand (operands[2], E_SImode)
          || !
#line 4436 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5045; /* arm_vcx1qv16qi */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4072 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 4992; /* mve_vst2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4072 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 4993; /* mve_vst2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4072 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 4994; /* mve_vst2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4072 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 4995; /* mve_vst2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4072 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 4996; /* mve_vst2qv4sf */

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4852; /* mve_vldrq_z_extend_v8qis */

        case 1:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4854; /* mve_vldrq_z_extend_v4qis */

        case 2:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4856; /* mve_vldrq_z_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4853; /* mve_vldrq_z_extend_v8qiu */

        case 1:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4855; /* mve_vldrq_z_extend_v4qiu */

        case 2:
          if (!
#line 3298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4857; /* mve_vldrq_z_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2310; /* neon_vqrshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2314; /* neon_vqrshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2318; /* neon_vqrshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2322; /* neon_vqrshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2326; /* neon_vqrshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2330; /* neon_vqrshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2334; /* neon_vqrshludi */

    case 7:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2338; /* neon_vqrshluv2di */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2796 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1909; /* neon_vrecpsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2796 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1910; /* neon_vrecpsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2807 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1911; /* neon_vrecpsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2807 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1912; /* neon_vrecpsv4hf */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern163 (x1, 
E_EImode))
    {
    case 0:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2866; /* neon_vst3v8qi */

    case 1:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2867; /* neon_vst3v4hi */

    case 2:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2868; /* neon_vst3v4hf */

    case 3:
      if (!(
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2869; /* neon_vst3v4bf */

    case 4:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2870; /* neon_vst3v2si */

    case 5:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2871; /* neon_vst3v2sf */

    case 6:
      if (!
#line 5826 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2872; /* neon_vst3di */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (pattern115 (x3))
    {
    case 0:
      if (!mve_imm_7 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3721; /* mve_vqshluq_n_sv16qi */

    case 1:
      if (!mve_imm_15 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3722; /* mve_vqshluq_n_sv8hi */

    case 2:
      if (!mve_imm_31 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3723; /* mve_vqshluq_n_sv4si */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1882; /* neon_vpadaluv8qi */

    case 1:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1884; /* neon_vpadaluv16qi */

    case 2:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1886; /* neon_vpadaluv4hi */

    case 3:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1888; /* neon_vpadaluv8hi */

    case 4:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1890; /* neon_vpadaluv2si */

    case 5:
      if (!
#line 2766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1892; /* neon_vpadaluv4si */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1487; /* neon_vhadduv8qi */

    case 1:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1491; /* neon_vhadduv16qi */

    case 2:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1495; /* neon_vhadduv4hi */

    case 3:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1499; /* neon_vhadduv8hi */

    case 4:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1503; /* neon_vhadduv2si */

    case 5:
      if (!
#line 1590 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1507; /* neon_vhadduv4si */

    default:
      return -1;
    }
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1760; /* neon_vcaltv2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1764; /* neon_vcaltv4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1776; /* neon_vcaltv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1780; /* neon_vcaltv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 2180 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1588; /* neon_vqdmulhv4hi */

    case 1:
      if (!
#line 2180 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1590; /* neon_vqdmulhv2si */

    case 2:
      if (!
#line 2180 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1592; /* neon_vqdmulhv8hi */

    case 3:
      if (!
#line 2180 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1594; /* neon_vqdmulhv4si */

    default:
      return -1;
    }
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern231 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[3], E_V16BImode)
          || !
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4864; /* mve_vstrq_scatter_offset_p_v16qi */

    case E_V8HImode:
      switch (pattern533 ())
        {
        case 0:
          if (!
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4865; /* mve_vstrq_scatter_offset_p_v8hi */

        case 1:
          if (!
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4867; /* mve_vstrq_scatter_offset_p_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4866; /* mve_vstrq_scatter_offset_p_v4si */

        case 1:
          if (!
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4868; /* mve_vstrq_scatter_offset_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3354 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4869; /* mve_vstrq_scatter_offset_p_v2di */

    default:
      return -1;
    }
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 3984 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2199; /* neon_vqrdmlsh_lanev8hi */

    case 1:
      if (!
#line 3984 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2201; /* neon_vqrdmlsh_lanev4si */

    case 2:
      if (!
#line 4000 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2203; /* neon_vqrdmlsh_lanev4hi */

    case 3:
      if (!
#line 4000 "../../gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 2205; /* neon_vqrdmlsh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 2);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      operands[3] = x4;
      if (const_int_operand (operands[3], E_SImode)
          && pattern394 (x2) == 0
          && 
#line 3116 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
        {
          *pnum_clobbers = 1;
          return 94; /* *ne_zeroextractsi */
        }
      if (XWINT (x4, 0) != 0L
          || pattern394 (x2) != 0
          || !
#line 3154 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 95; /* *ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      switch (pattern235 (x2))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3407; /* mve_vcmpneq_v16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3415; /* mve_vcmpneq_v8hi */

        case 2:
          if (!
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3755; /* mve_vcmpneq_fv8hf */

        case 3:
          if (!
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3423; /* mve_vcmpneq_v4si */

        case 4:
          if (!
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3761; /* mve_vcmpneq_fv4sf */

        case 5:
          if (!
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3431; /* mve_vcmpneq_n_v16qi */

        case 6:
          if (!
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3439; /* mve_vcmpneq_n_v8hi */

        case 7:
          if (!
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3767; /* mve_vcmpneq_n_fv8hf */

        case 8:
          if (!
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3447; /* mve_vcmpneq_n_v4si */

        case 9:
          if (!
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3773; /* mve_vcmpneq_n_fv4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!reg_or_zero_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (x4))
    {
    case NOT:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 966 "../../gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1040; /* *thumb2_csinv */

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 981 "../../gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1041; /* *thumb2_csinc */

    case NEG:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 995 "../../gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1042; /* *thumb2_csneg */

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      res = recog_269 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (arm_comparison_operator (x3, E_VOIDmode))
    {
      res = recog_274 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  if (arm_comparison_operation (operands[1], E_VOIDmode))
    {
      res = recog_275 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_276 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 10807 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
    {
      *pnum_clobbers = 1;
      return 351; /* movcond */
    }
  operands[3] = x3;
  if (arm_comparison_operator (operands[3], E_VOIDmode))
    {
      res = recog_277 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 1012 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
    {
      *pnum_clobbers = 1;
      return 1043; /* *thumb2_movcond */
    }
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  operands[0] = x3;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (s_register_operand (operands[1], E_SImode))
    {
      if (equality_operator (operands[0], E_VOIDmode)
          && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (
#line 1108 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && TARGET_HAVE_CBZ))
            return 974; /* thumb1_cbz */
        }
      if (arm_comparison_operator (operands[0], E_VOIDmode))
        {
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (
#line 1191 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 975; /* cbranchsi4_insn */
            }
        }
    }
  if (pnum_clobbers == NULL
      || !s_register_operand (x8, E_SImode))
    return -1;
  operands[1] = x8;
  operands[4] = x3;
  if (arm_comparison_operator (operands[4], E_VOIDmode))
    {
      operands[2] = x4;
      if (thumb1_cmpneg_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (
#line 1271 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 976; /* cbranchsi4_scratch */
            }
        }
    }
  operands[0] = x8;
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  switch (GET_CODE (x3))
    {
    case EQ:
      if (!
#line 1467 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1064; /* *thumb2_cbz */

    case NE:
      if (!
#line 1491 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1065; /* *thumb2_cbnz */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1936; /* neon_vcmla0v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1940; /* neon_vcmla0v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4229; /* mve_vcmlaq_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1944; /* neon_vcmla0v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1948; /* neon_vcmla0v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4233; /* mve_vcmlaq_fv4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1937; /* neon_vcmla90v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1941; /* neon_vcmla90v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4230; /* mve_vcmlaq_rot90_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1945; /* neon_vcmla90v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1949; /* neon_vcmla90v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4234; /* mve_vcmlaq_rot90_fv4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1938; /* neon_vcmla180v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1942; /* neon_vcmla180v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4231; /* mve_vcmlaq_rot180_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1946; /* neon_vcmla180v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1950; /* neon_vcmla180v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4235; /* mve_vcmlaq_rot180_fv4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1939; /* neon_vcmla270v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1943; /* neon_vcmla270v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4232; /* mve_vcmlaq_rot270_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1947; /* neon_vcmla270v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1951; /* neon_vcmla270v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4236; /* mve_vcmlaq_rot270_fv4sf */

            default:
              return -1;
            }

        case 370:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern484 (x2, 
E_V4BFmode, 
E_V2SFmode) != 0
                  || !
#line 6635 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3023; /* neon_vbfdotv2sf */

            case E_V4SFmode:
              if (pattern484 (x2, 
E_V8BFmode, 
E_V4SFmode) != 0
                  || !
#line 6635 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3024; /* neon_vbfdotv4sf */

            default:
              return -1;
            }

        case 394:
          if (pattern464 (x2) != 0
              || !
#line 6759 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3038; /* neon_vmmlav8bf */

        case 395:
          if (pattern464 (x2) != 0
              || !
#line 6770 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3039; /* neon_vfmabv8bf */

        case 396:
          if (pattern464 (x2) != 0
              || !
#line 6770 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3040; /* neon_vfmatv8bf */

        default:
          return -1;
        }

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1952; /* neon_vcmla_lane0v4hf */

            case 1:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1972; /* neon_vcmla_laneq0v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1956; /* neon_vcmla_lane0v8hf */

            case 3:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1976; /* neon_vcmlaq_lane0v8hf */

            case 4:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1960; /* neon_vcmla_lane0v2sf */

            case 5:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1968; /* neon_vcmla_laneq0v2sf */

            case 6:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1964; /* neon_vcmla_lane0v4sf */

            case 7:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1980; /* neon_vcmlaq_lane0v4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1953; /* neon_vcmla_lane90v4hf */

            case 1:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1973; /* neon_vcmla_laneq90v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1957; /* neon_vcmla_lane90v8hf */

            case 3:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1977; /* neon_vcmlaq_lane90v8hf */

            case 4:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1961; /* neon_vcmla_lane90v2sf */

            case 5:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1969; /* neon_vcmla_laneq90v2sf */

            case 6:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1965; /* neon_vcmla_lane90v4sf */

            case 7:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1981; /* neon_vcmlaq_lane90v4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1954; /* neon_vcmla_lane180v4hf */

            case 1:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1974; /* neon_vcmla_laneq180v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1958; /* neon_vcmla_lane180v8hf */

            case 3:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1978; /* neon_vcmlaq_lane180v8hf */

            case 4:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1962; /* neon_vcmla_lane180v2sf */

            case 5:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1970; /* neon_vcmla_laneq180v2sf */

            case 6:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1966; /* neon_vcmla_lane180v4sf */

            case 7:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1982; /* neon_vcmlaq_lane180v4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1955; /* neon_vcmla_lane270v4hf */

            case 1:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1975; /* neon_vcmla_laneq270v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1959; /* neon_vcmla_lane270v8hf */

            case 3:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1979; /* neon_vcmlaq_lane270v8hf */

            case 4:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1963; /* neon_vcmla_lane270v2sf */

            case 5:
              if (!
#line 2918 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1971; /* neon_vcmla_laneq270v2sf */

            case 6:
              if (!
#line 2903 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1967; /* neon_vcmla_lane270v4sf */

            case 7:
              if (!
#line 2933 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1983; /* neon_vcmlaq_lane270v4sf */

            default:
              return -1;
            }

        case 370:
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              switch (pattern534 (x2, 
E_V4BFmode, 
E_V2SFmode))
                {
                case 0:
                  if (!
#line 6648 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3025; /* neon_vbfdot_lanev4bfv2sf */

                case 1:
                  if (!
#line 6661 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3027; /* neon_vbfdot_lanev8bfv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern534 (x2, 
E_V8BFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!
#line 6648 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3026; /* neon_vbfdot_lanev4bfv4sf */

                case 1:
                  if (!
#line 6661 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3028; /* neon_vbfdot_lanev8bfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 395:
          if (pattern486 (x2) != 0
              || !
#line 6782 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3041; /* neon_vfmab_lanev8bf */

        case 396:
          if (pattern486 (x2) != 0
              || !
#line 6782 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3042; /* neon_vfmat_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 66 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 942; /* *thumb1_addsi3 */

    case MINUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !
#line 146 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 944; /* thumb1_subsi3_insn */

    case AND:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 192 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 947; /* *thumb1_andsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (!s_register_operand (operands[3], E_SImode)
              || !
#line 618 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1032; /* *thumb2_and_scc */

        default:
          return -1;
        }

    case IOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 250 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 949; /* *thumb1_iorsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (x3, E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (!cc_register (x6, E_VOIDmode))
            return -1;
          operands[2] = x6;
          operands[1] = x3;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (s_register_operand (operands[3], E_SImode)
              && 
#line 646 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
            return 1033; /* *thumb2_ior_scc */
          operands[3] = x6;
          operands[2] = x3;
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 677 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
            return -1;
          return 1034; /* *thumb2_ior_scc_strict_it */

        default:
          return -1;
        }

    case XOR:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 264 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 950; /* *thumb1_xorsi3_insn */

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  if (register_operand (operands[0], E_SImode))
    {
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 725 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 588; /* iwmmxt_textrmub */
          break;

        case E_HImode:
          if (register_operand (operands[1], E_V4HImode)
              && 
#line 747 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 590; /* iwmmxt_textrmuh */
          break;

        default:
          break;
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  switch (pattern469 (x3))
    {
    case 0:
      if (!
#line 3241 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2040; /* neon_vget_lanev8qi_zext_internal */

    case 1:
      if (
#line 3287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2049; /* neon_vget_lanev16qi_zext_internal */
      if (!
#line 4212 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))))
        return -1;
      return 5016; /* *mve_vec_extract_zext_internalv16qi */

    case 2:
      if (!
#line 3241 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2041; /* neon_vget_lanev4hi_zext_internal */

    case 3:
      if (
#line 3287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2050; /* neon_vget_lanev8hi_zext_internal */
      if (!
#line 4212 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 5017; /* *mve_vec_extract_zext_internalv8hi */

    case 4:
      if (!
#line 3241 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2042; /* neon_vget_lanev2si_zext_internal */

    case 5:
      if (
#line 3287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2052; /* neon_vget_lanev4si_zext_internal */
      if (!
#line 4212 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
        return -1;
      return 5018; /* *mve_vec_extract_zext_internalv4si */

    case 6:
      if (!
#line 3241 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2043; /* neon_vget_lanev2sf_zext_internal */

    case 7:
      if (!
#line 3287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2053; /* neon_vget_lanev4sf_zext_internal */

    case 8:
      if (!
#line 3287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2051; /* neon_vget_lanev8hf_zext_internal */

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFTRT
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != MULT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTRACT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x9 = XEXP (x7, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_V8QImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x12 = XEXP (x5, 1);
  operands[2] = x12;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[3] = x13;
  if (register_operand (operands[3], E_SImode)
      && 
#line 1656 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
    return 678; /* iwmmxt_walignr */
  if (GET_CODE (x13) != REG
      || GET_MODE (x13) != E_SImode)
    return -1;
  switch (REGNO (x13))
    {
    case 96:
      if (!
#line 1671 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 679; /* iwmmxt_walignr0 */

    case 97:
      if (!
#line 1686 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 680; /* iwmmxt_walignr1 */

    case 98:
      if (!
#line 1701 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 681; /* iwmmxt_walignr2 */

    case 99:
      if (!
#line 1716 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 682; /* iwmmxt_walignr3 */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == ZERO_EXTRACT
          && GET_MODE (x3) == E_SImode)
        {
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (XWINT (x2, 0) == 0L)
                {
                  x5 = XEXP (x3, 1);
                  operands[1] = x5;
                  if (const_int_M_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x3, 2);
                      operands[2] = x6;
                      if (const_int_M_operand (operands[2], E_SImode)
                          && 
#line 3500 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2))
                        return 98; /* insv_zero */
                    }
                }
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                {
                  x6 = XEXP (x3, 2);
                  if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    {
                      operands[1] = x2;
                      if (const_int_operand (operands[1], E_SImode)
                          && 
#line 12371 "../../gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT))
                        return 410; /* *arm_movtas_ze */
                    }
                }
            }
        }
      break;

    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          if (pattern247 (x3) == 0)
            {
              operands[3] = x2;
              if (s_register_operand (operands[3], E_SImode)
                  && 
#line 3524 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2))
                return 99; /* insv_t2 */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
            {
              operands[1] = x2;
              if (soft_df_operand (operands[1], E_DFmode)
                  && 
#line 7627 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
                return 271; /* *movdf_soft_insn */
            }
          break;

        case PC:
          operands[0] = x2;
          if (s_register_operand (operands[0], E_SImode)
              && 
#line 9629 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 315; /* *arm_indirect_jump */
          if (memory_operand (operands[0], E_SImode)
              && 
#line 9638 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 316; /* *load_indirect_jump */
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 2018 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1000; /* *thumb1_indirect_jump */
              if (
#line 604 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1031; /* *thumb2_indirect_jump */
            }
          break;

        default:
          break;
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (
#line 8591 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 288; /* *arm_jump */
          if (
#line 1845 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 990; /* *thumb_jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode)
          && 
#line 6345 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !(TARGET_HARD_FLOAT)
   && !(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT)
   && !TARGET_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return 255; /* *arm_movdi */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 6557 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 257; /* *arm_movsi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 7212 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
        return 265; /* *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && 
#line 7239 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT))
        return 266; /* *movhi_bytes */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 7356 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
        return 267; /* *arm_movqi_insn */
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode)
          && 
#line 7403 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
        return 268; /* *arm32_movhf */
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode)
          && 
#line 7403 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
        return 269; /* *arm32_movbf */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 7502 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode))))
        return 270; /* *arm_movsf_soft_insn */
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (cc_register (operands[0], E_VOIDmode)
      && rtx_equal_p (x2, operands[0])
      && 
#line 7942 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
    return 276; /* *deleted_compare */
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode))
        {
          if (
#line 103 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
            return 537; /* *iwmmxt_arm_movdi */
          if (
#line 344 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL))))
            return 767; /* *movdi_vfp */
        }
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 540; /* movv2si_internal */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode)
          && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 541; /* movv4hi_internal */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode)
          && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 542; /* movv8qi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode))
        {
          if (
#line 29 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 753; /* *arm_movhi_vfp */
          if (
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 754; /* *thumb2_movhi_vfp */
          if (
#line 135 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 759; /* *arm_movhi_fp16 */
          if (
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 760; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V16BImode:
      if (nonimmediate_operand (operands[0], E_V16BImode)
          && general_operand (operands[1], E_V16BImode))
        {
          if (
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 755; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 761; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V8BImode:
      if (nonimmediate_operand (operands[0], E_V8BImode)
          && general_operand (operands[1], E_V8BImode))
        {
          if (
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 756; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 762; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V4BImode:
      if (nonimmediate_operand (operands[0], E_V4BImode)
          && general_operand (operands[1], E_V4BImode))
        {
          if (
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 757; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 763; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V2QImode:
      if (nonimmediate_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode))
        {
          if (
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 758; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 764; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode))
        {
          if (
#line 407 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 768; /* *movhf_vfp_hf16 */
          if (
#line 488 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 770; /* *movhf_vfp_neon */
          if (
#line 544 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 772; /* *movhf_vfp */
        }
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode))
        {
          if (
#line 407 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 769; /* *movbf_vfp_bf16 */
          if (
#line 488 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 771; /* *movbf_vfp_neon */
          if (
#line 544 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 773; /* *movbf_vfp */
        }
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          if (general_operand (operands[1], E_SFmode)
              && 
#line 600 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 774; /* *movsf_vfp */
          if (hard_sf_operand (operands[1], E_SFmode)
              && 
#line 636 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 775; /* *thumb2_movsf_vfp */
        }
      break;

    case E_DFmode:
      if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
        {
          if (soft_df_operand (operands[1], E_DFmode)
              && 
#line 674 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 776; /* *movdf_vfp */
          if (hard_df_operand (operands[1], E_DFmode)
              && 
#line 725 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 777; /* *thumb2_movdf_vfp */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case MEM:
      if (pattern248 (x2, 
8) == 0
          && register_operand (operands[0], E_SImode))
        {
          x7 = XEXP (x2, 0);
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_SImode))
            {
              x9 = XVECEXP (x7, 0, 2);
              operands[2] = x9;
              if (
#line 6771 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 263; /* tls_load_dot_plus_eight */
            }
        }
      break;

    case CONST_VECTOR:
      res = recog_297 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_298 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_SImode))
    {
      operands[1] = x2;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 158 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 538; /* *iwmmxt_movsi_insn */
          if (
#line 238 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 765; /* *arm_movsi_vfp */
          if (
#line 283 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 766; /* *thumb2_movsi_vfp */
        }
    }
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 101
      && GET_CODE (x3) == REG
      && REGNO (x3) == 100
      && 
#line 1637 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
    return 855; /* *movcc_vfp */
  operands[1] = x2;
  res = recog_299 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  if (GET_MODE (x2) == E_SImode)
    {
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) == 15
              && s_register_operand (operands[0], E_SImode)
              && 
#line 2075 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 1003; /* *thumb1_movpc_insn */
          break;

        case MEM:
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) == POST_INC
              && GET_MODE (x7) == E_SImode)
            {
              x10 = XEXP (x7, 0);
              if (GET_CODE (x10) == REG
                  && REGNO (x10) == 13
                  && GET_MODE (x10) == E_SImode
                  && low_register_operand (operands[0], E_SImode)
                  && 
#line 223 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && (reload_in_progress || reload_completed)))
                return 1013; /* *thumb2_pop_single */
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x2;
  if (general_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_SImode)
      && 
#line 238 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
    return 1014; /* *thumb2_movsi_insn */
  if (pnum_clobbers != NULL
      && const_int_operand (operands[1], E_SImode)
      && low_register_operand (operands[0], E_SImode)
      && 
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
    {
      *pnum_clobbers = 1;
      return 1056; /* *thumb2_movsi_shortim */
    }
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_SImode)
      || GET_CODE (x2) != MEM
      || pattern248 (x2, 
4) != 0)
    return -1;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x7, 0, 2);
  operands[3] = x9;
  if (!
#line 274 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  *pnum_clobbers = 1;
  return 1015; /* tls_load_dot_plus_four */
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      res = recog_266 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case EQ:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3400; /* mve_vcmpeqq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3408; /* mve_vcmpeqq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3750; /* mve_vcmpeqq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3416; /* mve_vcmpeqq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3756; /* mve_vcmpeqq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3424; /* mve_vcmpeqq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3432; /* mve_vcmpeqq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3762; /* mve_vcmpeqq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3440; /* mve_vcmpeqq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3768; /* mve_vcmpeqq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3401; /* mve_vcmpgeq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3409; /* mve_vcmpgeq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3751; /* mve_vcmpgeq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3417; /* mve_vcmpgeq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3757; /* mve_vcmpgeq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3425; /* mve_vcmpgeq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3433; /* mve_vcmpgeq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3763; /* mve_vcmpgeq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3441; /* mve_vcmpgeq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3769; /* mve_vcmpgeq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GEU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3402; /* mve_vcmpcsq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3410; /* mve_vcmpcsq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3418; /* mve_vcmpcsq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3426; /* mve_vcmpcsq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3434; /* mve_vcmpcsq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3442; /* mve_vcmpcsq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case GT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3403; /* mve_vcmpgtq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3411; /* mve_vcmpgtq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3752; /* mve_vcmpgtq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3419; /* mve_vcmpgtq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3758; /* mve_vcmpgtq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3427; /* mve_vcmpgtq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3435; /* mve_vcmpgtq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3764; /* mve_vcmpgtq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3443; /* mve_vcmpgtq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3770; /* mve_vcmpgtq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GTU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3404; /* mve_vcmphiq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3412; /* mve_vcmphiq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3420; /* mve_vcmphiq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3428; /* mve_vcmphiq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3436; /* mve_vcmphiq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3444; /* mve_vcmphiq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case LE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3405; /* mve_vcmpleq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3413; /* mve_vcmpleq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3753; /* mve_vcmpleq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3421; /* mve_vcmpleq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3759; /* mve_vcmpleq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3429; /* mve_vcmpleq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3437; /* mve_vcmpleq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3765; /* mve_vcmpleq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3445; /* mve_vcmpleq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3771; /* mve_vcmpleq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case LT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3406; /* mve_vcmpltq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3414; /* mve_vcmpltq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3754; /* mve_vcmpltq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3422; /* mve_vcmpltq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3760; /* mve_vcmpltq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3430; /* mve_vcmpltq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3438; /* mve_vcmpltq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3766; /* mve_vcmpltq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3446; /* mve_vcmpltq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3772; /* mve_vcmpltq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (arm_comparison_operator_mode (operands[1], E_SImode))
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (cc_register (operands[2], E_VOIDmode)
              && 
#line 8092 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 279; /* *mov_scc */
        }
    }
  if (pnum_clobbers != NULL
      && arm_comparison_operator (operands[1], E_SImode))
    {
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (s_register_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[3] = x4;
          if (arm_add_operand (operands[3], E_SImode)
              && 
#line 9952 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            {
              *pnum_clobbers = 1;
              return 336; /* *compare_scc */
            }
        }
    }
  if (GET_CODE (x3) == LTU
      && GET_MODE (x3) == E_SImode)
    {
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (s_register_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode)
              && 
#line 1789 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 988; /* cstoresi_ltu_thumb1 */
        }
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  operands[1] = x3;
  if (!arm_comparison_operator_mode (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!cc_register (operands[2], E_VOIDmode)
      || !
#line 326 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1018; /* *thumb2_mov_scc */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      return recog_263 (x1, insn, pnum_clobbers);

    case 1:
      return recog_265 (x1, insn, pnum_clobbers);

    case 2:
      return recog_262 (x1, insn, pnum_clobbers);

    case 4:
      return recog_264 (x1, insn, pnum_clobbers);

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 103:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!const_int_ccde3_operand (operands[5], E_SImode))
            return -1;
          switch (pattern426 (x2))
            {
            case 0:
              if (!
#line 4587 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 149; /* arm_cx3asi */

            case 1:
              if (!
#line 4587 "../../gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 150; /* arm_cx3adi */

            default:
              return -1;
            }

        case 115:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 446 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 716; /* iwmmxt_wqmiabb */

            case 1:
              if (!
#line 459 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 717; /* iwmmxt_wqmiabt */

            case 2:
              if (!
#line 472 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 718; /* iwmmxt_wqmiatb */

            case 3:
              if (!
#line 485 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 719; /* iwmmxt_wqmiatt */

            default:
              return -1;
            }

        case 114:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 498 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 720; /* iwmmxt_wqmiabbn */

            case 1:
              if (!
#line 511 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 721; /* iwmmxt_wqmiabtn */

            case 2:
              if (!
#line 524 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 722; /* iwmmxt_wqmiatbn */

            case 3:
              if (!
#line 537 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 723; /* iwmmxt_wqmiattn */

            default:
              return -1;
            }

        case 105:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          switch (GET_CODE (operands[4]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern512 (x2, 
E_SImode) != 0
                      || !
#line 2251 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 939; /* arm_vcx3asi */

                case E_DImode:
                  if (pattern512 (x2, 
E_DImode) != 0
                      || !
#line 2251 "../../gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 940; /* arm_vcx3adi */

                case E_V16QImode:
                  if (pattern482 (x2) != 0
                      || !register_operand (operands[4], E_V16QImode)
                      || !const_int_mve_cde3_operand (operands[5], E_SImode)
                      || !
#line 4500 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                    return -1;
                  return 5050; /* arm_vcx3qav16qi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (!const_int_mve_cde2_operand (operands[4], E_SImode)
                  || pattern482 (x2) != 0
                  || !vpr_register_operand (operands[5], E_V16BImode)
                  || !
#line 4528 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                return -1;
              return 5054; /* arm_vcx2qa_p_v16qi */

            default:
              return -1;
            }

        case 104:
          if (GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[0], E_V16QImode)
              || !const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!const_int_mve_cde2_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!vpr_register_operand (operands[5], E_V16BImode)
              || !
#line 4528 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5053; /* arm_vcx2q_p_v16qi */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_coproc_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!register_operand (operands[4], E_V16QImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_int_mve_cde3_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      if (!vpr_register_operand (operands[6], E_V16BImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 104:
          if (!
#line 4544 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5055; /* arm_vcx3q_p_v16qi */

        case 105:
          if (!
#line 4544 "../../gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5056; /* arm_vcx3qa_p_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 208 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 539; /* *cond_iwmmxt_movsi_insn */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6557 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode)))))
        return -1;
      return 6566; /* *p *arm_movsi_insn */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7212 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6569; /* *p *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7239 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT)))
        return 6570; /* *p *movhi_bytes */
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 29 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6891; /* *p *arm_movhi_vfp */
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6892; /* *p *thumb2_movhi_vfp */
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6897; /* *p *arm_movhi_fp16 */
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6898; /* *p *thumb2_movhi_fp16 */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
  && (register_operand (operands[0], HImode)
     || register_operand (operands[1], HImode)))))
        return -1;
      return 6982; /* *p *thumb2_movhi_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7356 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode)))))
        return -1;
      return 6571; /* *p *arm_movqi_insn */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return 6572; /* *p *arm32_movhf */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return -1;
      return 6906; /* *p *movhf_vfp_hf16 */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !general_operand (operands[1], E_BFmode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return 6573; /* *p *arm32_movbf */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return -1;
      return 6907; /* *p *movbf_vfp_bf16 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode))
        return -1;
      if (general_operand (operands[1], E_SFmode))
        {
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7502 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode)))))
            return 6574; /* *p *arm_movsf_soft_insn */
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 600 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
            return 6908; /* *p *movsf_vfp */
        }
      if (!hard_sf_operand (operands[1], E_SFmode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 636 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
        return -1;
      return 6909; /* *p *thumb2_movsf_vfp */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6678; /* *p movv2si_internal */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6679; /* *p movv4hi_internal */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6680; /* *p movv8qi_internal */

    case E_V16BImode:
      if (!nonimmediate_operand (operands[0], E_V16BImode)
          || !general_operand (operands[1], E_V16BImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return 6893; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return -1;
      return 6899; /* *p *thumb2_movhi_fp16 */

    case E_V8BImode:
      if (!nonimmediate_operand (operands[0], E_V8BImode)
          || !general_operand (operands[1], E_V8BImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return 6894; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return -1;
      return 6900; /* *p *thumb2_movhi_fp16 */

    case E_V4BImode:
      if (!nonimmediate_operand (operands[0], E_V4BImode)
          || !general_operand (operands[1], E_V4BImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return 6895; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return -1;
      return 6901; /* *p *thumb2_movhi_fp16 */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return 6896; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return -1;
      return 6902; /* *p *thumb2_movhi_fp16 */

    case E_DImode:
      if (!nonimmediate_di_operand (operands[0], E_DImode)
          || !di_operand (operands[1], E_DImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 344 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL)))))
        return -1;
      return 6905; /* *p *movdi_vfp */

    case E_DFmode:
      if (!nonimmediate_soft_df_operand (operands[0], E_DFmode)
          || !soft_df_operand (operands[1], E_DFmode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 674 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode)))))
        return -1;
      return 6910; /* *p *movdf_vfp */

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      operands[3] = x9;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      switch (GET_CODE (x10))
        {
        case TRUNCATE:
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern584 (x4, 
E_V8QImode, 
E_QImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 676 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6723; /* *p iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern584 (x4, 
E_V4HImode, 
E_HImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 693 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6724; /* *p iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x4) != E_V2SImode
              || GET_MODE (x5) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 710 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6725; /* *p iwmmxt_tinsrw */

        default:
          return -1;
        }

    case VEC_SELECT:
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != PARALLEL)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != PARALLEL)
        return -1;
      x9 = XEXP (x4, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x14 = XEXP (x8, 0);
      operands[2] = x14;
      switch (XVECLEN (x12, 0))
        {
        case 8:
          if (pattern585 (x12) != 0)
            return -1;
          x15 = XVECEXP (x12, 0, 4);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XVECEXP (x12, 0, 5);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x12, 0, 6);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x12, 0, 7);
          if (GET_CODE (x18) != CONST_INT
              || pattern605 (x13, 
8) != 0)
            return -1;
          x19 = XVECEXP (x13, 0, 4);
          if (GET_CODE (x19) != CONST_INT)
            return -1;
          x20 = XVECEXP (x13, 0, 5);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x13, 0, 6);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XVECEXP (x13, 0, 7);
          if (GET_CODE (x22) != CONST_INT
              || XWINT (x9, 0) != 85L
              || pattern618 (x4, 
E_V8QImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 4L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 5L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L
                  || XWINT (x15, 0) != 6L
                  || XWINT (x16, 0) != 2L
                  || XWINT (x17, 0) != 7L
                  || XWINT (x18, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 4L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 5L
                  || XWINT (x19, 0) != 2L
                  || XWINT (x20, 0) != 6L
                  || XWINT (x21, 0) != 3L
                  || XWINT (x22, 0) != 7L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1029 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6759; /* *p iwmmxt_wunpckihb */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 5L
                  || XWINT (x15, 0) != 2L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 3L
                  || XWINT (x18, 0) != 7L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 4L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 5L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || XWINT (x19, 0) != 6L
                  || XWINT (x20, 0) != 2L
                  || XWINT (x21, 0) != 7L
                  || XWINT (x22, 0) != 3L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1093 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6762; /* *p iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern585 (x12) != 0
              || pattern605 (x13, 
4) != 0
              || XWINT (x9, 0) != 5L
              || pattern618 (x4, 
E_V4HImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 2L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 3L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 2L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 3L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1049 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6760; /* *p iwmmxt_wunpckihh */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 2L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 3L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1113 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6763; /* *p iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x23 = XVECEXP (x12, 0, 0);
          if (GET_CODE (x23) != CONST_INT)
            return -1;
          x24 = XVECEXP (x12, 0, 1);
          if (GET_CODE (x24) != CONST_INT
              || XVECLEN (x13, 0) != 2)
            return -1;
          x27 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XVECEXP (x13, 0, 1);
          if (GET_CODE (x28) != CONST_INT
              || XWINT (x9, 0) != 1L
              || pattern618 (x4, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x23, 0))
            {
            case 1L:
              if (XWINT (x24, 0) != 0L
                  || XWINT (x27, 0) != 0L
                  || XWINT (x28, 0) != 1L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1065 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6761; /* *p iwmmxt_wunpckihw */

            case 0L:
              if (XWINT (x24, 0) != 1L
                  || XWINT (x27, 0) != 1L
                  || XWINT (x28, 0) != 0L
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1129 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6764; /* *p iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern380 (x1, 
SS_PLUS) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 81 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6831; /* *p iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern380 (x1, 
SS_MINUS) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 99 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6832; /* *p iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!arm_add_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && GET_MODE (x3) == E_CC_NZmode
              && GET_MODE (x4) == E_CC_NZmode
              && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1142 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6399; /* *p *addsi3_compare0_scratch */
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x10, operands[0])
              && GET_MODE (x3) == E_CC_Cmode
              && GET_MODE (x4) == E_CC_Cmode
              && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1293 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return 6401; /* *p *compare_addsi2_op0 */
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CC_Cmode
          || GET_MODE (x4) != E_CC_Cmode
          || !rtx_equal_p (x10, operands[1])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6402; /* *p *compare_addsi2_op1 */

    case NEG:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_Zmode
          || GET_MODE (x4) != E_CC_Zmode)
        return -1;
      x10 = XEXP (x4, 1);
      if (!s_register_operand (x10, E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          operands[1] = x10;
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1157 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6400; /* *p *compare_negsi_si */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[1] = x8;
          if (!shift_operator (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          operands[0] = x10;
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7925 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6576; /* *p *arm_cmpsi_negshiftsi_si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (GET_MODE (x4) != E_CC_NZmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x5, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3092 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
  && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32
      && INTVAL (operands[1]) > 0 
      && INTVAL (operands[1]) + (INTVAL (operands[2]) & 1) <= 8
      && INTVAL (operands[1]) + INTVAL (operands[2]) <= 32))))
        return -1;
      return 6443; /* *p *zeroextractsi_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && REGNO (x3) == 100
              && GET_MODE (x3) == E_CC_Zmode)
            {
              x6 = XEXP (x1, 0);
              operands[1] = x6;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (GET_MODE (x4) == E_CC_Zmode
                  && s_register_operand (operands[0], E_QImode)
                  && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5832 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return 6493; /* *p *compareqi_eq0 */
            }
          break;

        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          res = recog_333 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s_register_operand (operands[0], E_SImode)
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (GET_MODE (x4) != E_CCmode)
        return -1;
      operands[1] = x10;
      if (!arm_add_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7877 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6575; /* *p *arm_cmpsi_insn */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5179 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6483; /* *p *arm_negsi2 */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 890 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6913; /* *p *negsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 901 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6914; /* *p *negdf2_vfp */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern524 (x4, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1163 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6924; /* *p *negmulsf3_vfp */

        case E_DFmode:
          if (pattern524 (x4, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1184 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6926; /* *p *negmuldf3_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (s_register_operand (operands[0], E_SImode))
    {
      res = recog_359 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!low_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 1);
  if (pattern474 (x7) != 0)
    return -1;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!low_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!low_reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1271 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2])))))
    return -1;
  return 6987; /* *p *thumb2_shiftsi3_short */
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (s_register_operand (x4, E_SImode))
    {
      res = recog_366 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 15
      || GET_MODE (x8) != E_SImode)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      switch (XINT (x5, 1))
        {
        case 116:
          if (XINT (x7, 1) != 116)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6879; /* *p iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6880; /* *p iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6881; /* *p iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x7, 1) != 117)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6882; /* *p iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6883; /* *p iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6884; /* *p iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x7, 1) != 118)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6885; /* *p iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6886; /* *p iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6887; /* *p iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 119)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x7, 1) != 119)
        return -1;
      x10 = XEXP (x1, 0);
      operands[1] = x10;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 1);
      operands[0] = x12;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_V2SImode:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6888; /* *p iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6889; /* *p iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6890; /* *p iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_37 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_38 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_39 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_40 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_41 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          res = recog_42 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 5)
        {
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 3)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 1
          && load_multiple_operation (operands[0], E_VOIDmode))
        {
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 1);
              if (GET_CODE (x3) == MEM
                  && GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 0);
                      operands[1] = x5;
                      if (s_register_operand (operands[1], E_SImode)
                          && 
#line 12828 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                        return 494; /* *load_multiple */
                    }
                }
            }
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != PLUS
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 0);
          if (pattern453 (x10) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x3, 1);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x6, 1);
          operands[3] = x12;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          x14 = XEXP (x13, 1);
          operands[5] = x14;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x15 = XEXP (x9, 1);
          operands[4] = x15;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[0]))
            return -1;
          x17 = XEXP (x8, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x13, 0);
          if (!rtx_equal_p (x18, operands[0])
              || !
#line 316 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && INTVAL (operands[5]) == INTVAL (operands[2]) + 4))
            return -1;
          return 1017; /* *thumb2_storewb_pairsi */

        case 4:
          if (pattern0 (x1, 
18) != 0
              || pattern257 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          operands[2] = x19;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1])
              || !
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3091; /* atomic_exchangesi */

        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x12 = XEXP (x6, 1);
          if (GET_CODE (x12) != UNSPEC_VOLATILE
              || XVECLEN (x12, 0) != 2)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x12) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (XINT (x12, 1))
            {
            case 18:
              x19 = XVECEXP (x12, 0, 0);
              operands[2] = x19;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3091; /* atomic_exchangesi */

            case 19:
              x19 = XVECEXP (x12, 0, 0);
              if (GET_MODE (x19) != E_SImode)
                return -1;
              switch (pattern579 (x19))
                {
                case 0:
                  if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3127; /* atomic_fetch_addsi */

                case 1:
                  if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3128; /* atomic_fetch_subsi */

                case 2:
                  if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3129; /* atomic_fetch_orsi */

                case 3:
                  if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3130; /* atomic_fetch_xorsi */

                case 4:
                  if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3131; /* atomic_fetch_andsi */

                case 5:
                  if (!
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3139; /* atomic_fetch_nandsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 5:
          if (pattern0 (x1, 
19) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (pattern318 (x9, 
E_CCmode, 
100) != 0)
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x21) != CLOBBER)
            return -1;
          x23 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x23) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          if (GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x24 = XEXP (x23, 0);
          operands[5] = x24;
          if (!scratch_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (pattern579 (x19))
            {
            case 0:
              if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3127; /* atomic_fetch_addsi */

            case 1:
              if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3128; /* atomic_fetch_subsi */

            case 2:
              if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3129; /* atomic_fetch_orsi */

            case 3:
              if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3130; /* atomic_fetch_xorsi */

            case 4:
              if (!
#line 406 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3131; /* atomic_fetch_andsi */

            case 5:
              if (!
#line 432 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3139; /* atomic_fetch_nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      return recog_376 (x1, insn, pnum_clobbers);

    case RETURN:
      if (!
#line 9022 "../../gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE)))
        return -1;
      return 298; /* *arm_return */

    case SIMPLE_RETURN:
      if (
#line 9083 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return 303; /* *arm_simple_return */
      if (
#line 1210 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !IS_CMSE_ENTRY (arm_current_func_type ())))
        return 1049; /* *thumb2_return */
      if (!
#line 1218 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && IS_CMSE_ENTRY (arm_current_func_type ())))
        return -1;
      return 1050; /* *thumb2_cmse_entry_return */

    case UNSPEC_VOLATILE:
      return recog_377 (x1, insn, pnum_clobbers);

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 317; /* nop */

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XEXP (x1, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 318; /* trap */

    case PREFETCH:
      x25 = XEXP (x1, 0);
      operands[0] = x25;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      x26 = XEXP (x1, 1);
      operands[1] = x26;
      x27 = XEXP (x1, 2);
      operands[2] = x27;
      if (!
#line 12229 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch5te))
        return -1;
      return 402; /* prefetch */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 4
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 403; /* force_register_use */

    case COND_EXEC:
      x25 = XEXP (x1, 0);
      if (!arm_comparison_operator (x25, E_VOIDmode))
        return -1;
      x28 = XEXP (x25, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x29 = XEXP (x25, 0);
      if (!cc_register (x29, E_VOIDmode))
        return -1;
      x26 = XEXP (x1, 1);
      switch (GET_CODE (x26))
        {
        case SET:
          return recog_375 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x26, 0) == 2)
            {
              res = recog_369 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x26;
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_370 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 4)
            {
              res = recog_371 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 5)
            {
              res = recog_372 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 3)
            {
              res = recog_373 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_374 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) < 1)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          switch (GET_CODE (x30))
            {
            case SET:
              x31 = XEXP (x30, 1);
              switch (GET_CODE (x31))
                {
                case MEM:
                  if (GET_MODE (x31) != E_SImode)
                    return -1;
                  operands[3] = x25;
                  operands[4] = x29;
                  if (!load_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[2] = x32;
                  if (!s_register_operand (operands[2], E_SImode))
                    return -1;
                  x33 = XEXP (x31, 0);
                  operands[1] = x33;
                  if (!s_register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12828 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed)))
                    return -1;
                  return 6670; /* *p *load_multiple */

                case CONST_INT:
                  if (XWINT (x31, 0) != 0L)
                    return -1;
                  operands[2] = x25;
                  operands[3] = x29;
                  if (!clear_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[1] = x32;
                  if (!register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1711 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                    return -1;
                  return 6999; /* *p *clear_multiple */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x30, 0) != 1
                  || XINT (x30, 1) != 55)
                return -1;
              x34 = XVECEXP (x30, 0, 0);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[1] = x25;
              operands[2] = x29;
              if (!clear_vfp_multiple_operation (operands[0], E_VOIDmode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1688 "../../gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                return -1;
              return 6961; /* *p *clear_vfp_multiple */

            default:
              return -1;
            }

        case RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9022 "../../gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE))))
            return -1;
          return 6578; /* *p *arm_return */

        case SIMPLE_RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9083 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
            return -1;
          return 6579; /* *p *arm_simple_return */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x26, 0) != 1
              || XINT (x26, 1) != 56)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          if (GET_CODE (x30) != MEM
              || GET_MODE (x30) != E_BLKmode)
            return -1;
          operands[1] = x25;
          operands[2] = x29;
          x32 = XEXP (x30, 0);
          operands[0] = x32;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1725 "../../gcc/config/arm/vfp.md"
(use_cmse && reload_completed)))
            return -1;
          return 6962; /* *p lazy_store_multiple_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
